//  gapdimer.c-  searches for motifs with gaps: also adjusts using Metropolis
//  uses modified beta priors :  version Aug 13 01: no penalty at begin for FS
//  writes results to motif.out 
//  Max. no of sequences- 200 (F strand), 100 (F & B strand)
//  constructs table of frequecies and chooses starting points according to occurrence
//  above a specified cutoff (#iterations)
//  Both forward and reverse complement strands may be searched for
//  Has dimers to account for 1st order Markov structure
//  priors based on background of given data set


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <unistd.h>
#include "define.h"
#include "globaldef.h"
#include "multfns.h"


main(){

  unsigned int  dum, SEED;  

  int 	        i,j,jj,a,reqd, k,nw, l, L[NO_OF_SEQ],word_length,iter,N,flag1,seqno,sum_L=0,total_chosen,gw, start_position[NO_OF_SEQ][MOTIF_COUNT],end_position[NO_OF_SEQ][MOTIF_COUNT], gapindices[MOTIFLENGTH], it=0,wordmax, count[MOTIFLENGTH],ind[MOTIFLENGTH],sel,A, matcount[NO_OF_BASES][MOTIFLENGTH],sumcount=0,searchmotifs=0,del, num, iter50, flag, div, Tcount[NO_OF_BASES][NO_OF_BASES], MC=0, totBase=0, NoDimer=0, dimer=0,  equi, totdimer=0,gapcount[NO_OF_BASES+1],yesgap,kk ,seq17=0, FB;

  double 	f[BIGSEQ], lnS[BIGSEQ], T1, T2,T3, maxT ,pa[MOTIFLENGTH],count1[MOTIFLENGTH][NO_OF_BASES],probs[MOTIFLENGTH][NO_OF_BASES],localmat[NO_OF_BASES][MOTIFLENGTH],dictcount[MOTIFLENGTH],dictprobs[MOTIFLENGTH],obslik, b[MOTIFLENGTH][NO_OF_BASES][MOTIFLENGTH],startprob,normsum=0.0, SEGMENT_PROB[BIGSEQ],choose, rannum, expscore, Zscore[NO_OF_BASES][NO_OF_BASES], tmpT[NO_OF_BASES], tmpD[NO_OF_BASES], fracN, info=0.0, motifscore =0.0, postlik,MAP;

  char 	        str1[BIGSEQ],str2[BIGSEQ],S[NO_OF_SEQ][BIGSEQ],S1[NO_OF_SEQ][BIGSEQ],lastword[MOTIFLENGTH],newstr[MOTIFLENGTH],comm[COMMENT_LENGTH], updateMotif[MOTIFLENGTH], selwords[TOTLENGTH],tempword[MOTIFLENGTH],choseword[NO_OF_SEQ][MOTIF_COUNT][MOTIFLENGTH],chosemotif[NO_OF_SEQ][MOTIF_COUNT][MOTIFLENGTH],newword[MOTIFLENGTH],newS[NO_OF_SEQ][BIGSEQ],yes, rof;

 char	        filename[15],string1[10],file1[20],  names[NO_OF_SEQ], rowname[20] ;
 char           outfiles[NO_OF_SEQ][10], outfile[15],gapfile[15];
 vect           *tmpvect; 
 table		*freqtable, *tmptab;
 FILE	        *f1, *f2,*inputfile, *tmp1, *buf, *out, *in;
 
  fflush(stdin);
 scanf("%s",file1);

 
 fflush(stdin);
 scanf("%s",outfile);

 fflush(stdin);
 scanf("%d", &SEED);
 srand(SEED);

 
 inputfile = fopen(file1,"r");

  buf = fopen("buf.out","w");   
 
  no_of_seq = ReadSeq(inputfile, buf, newS, L);   //  read sequences in fasta format

  forwardno = no_of_seq;		// number of forward strands


 for(i = 0;i < no_of_seq; i++){
   strUpr(newS[i],S[i]);
   L[i] = strlen(S[i]);
   totBase += L[i];
   totdimer += L[i] - 1;
 }
 
 fflush(stdin);
 fflush(stdin);
 scanf("%d",&width);

 fflush(stdin);
 scanf("%d",&gaplength);
 


 gw = gaplength + width;

 reqd = 1;		// single motif

 strcpy(tempword,"X");
 for(i = 0;i < width-1; i++) strcat(tempword,"X");

 strcpy(word_list[dict_length-2],tempword);
 div = 20;

 fflush(stdin);
 scanf("%d", &i); 
 motifPC = i/1000.0;
 

 equi = 2; 
 fracN = 0.10; 

 fflush(stdin);
 scanf("%d", &MC); 
 
 fflush(stdin);
 scanf("%d", &FB); 

 fflush(stdin);
 scanf("%d", &MAXITER);


 if(FB == 1){			//include backward strand also
   
   for(i = 0;i < no_of_seq; i++){
     strcpy(str1, S[i]);
     TakeComplement(str1, str2);
     strcpy(S[i+no_of_seq],str2);
   }

   no_of_seq +=  no_of_seq;		// doubles the number of input sequences

   for(i = 0; i < no_of_seq; i++){
      L[i] = strlen(S[i]);
   }
 }


 //initialize start position vector 

 for(seqno = 0; seqno < no_of_seq; seqno++){
   startvec[seqno] = (node*)malloc(sizeof(node));
   startvec[seqno]->position = 0;
   startvec[seqno]->next = NULL;
 }


 sum_L=0;

 for(k = 0; k < no_of_seq; k++){
   sum_L += L[k];
   L[k]++;    /* L is now L+1 */
   S1[k][0] = '*';
 
   for(i=1; i<L[k]; i++)   S1[k][i] = S[k][i-1];
 }

 while(searchmotifs<reqd){

/* initialization */
   
  for(a = 1; a < dict_length; a++){
    strcpy(dict[a].name,word_list[a-1]);
    dict[a].coeff = 0.0;
    dict[a].repeat = 0;
    word_size[a] = strlen(dict[a].name);
  }

  motifIndex = dict_length-1;

/* finding max length of the word */

  wordmax = word_size[1];

for(a=2; a<dict_length; a++){
	if(word_size[a] > wordmax) wordmax = word_size[a];
}

 max_length = wordmax;		      

/* finding no. of repeats */

 for(a=1; a<dict_length-1; a++){
	word_length = strlen(dict[a].name);

	for(k=0;k<no_of_seq;k++){	

	for(i=0; i<L[k]-word_length; i++){
			setString(i, i+word_length-1, S[k],str1);
			if(strcmp(str1,dict[a].name) == 0) dict[a].repeat++;		
	}	

	}
	} /*end a*/

 normsum=0.0;
 for(a=1; a<dict_length-1; a++){
   normsum += dict[a].repeat;
 }
 normsum/= (float)NO_OF_BASES;
 normsum*= fracN;		// ave. of betas for bases

 for(a = 1; a < dict_length-1; a++) {
   beta[a-1] = (float)dict[a].repeat*fracN;     // pseudocounts to fix the prior
 }
 beta[dict_length-2] = motifPC*normsum ;     //in proportion to prior parameters of bases

 dict[dict_length-1].repeat = 0;

 for(a=1; a<dict_length; a++){
   dictcount[a-1] = dict[a].repeat+beta[a-1];
 }

 
 rDirich(dict_length-1, dictcount, dictprobs);


 for(a=1; a<dict_length; a++){
   dict[a].prob = dictprobs[a-1];   
   dictprobs[a-1] =  (float)dict[a].repeat/sum_L ;    // proportion of occurrence of bases
}

 if(equi == 1){

 startprob=.25;

 for(i=0; i<NO_OF_BASES; i++){
   for(j=0; j<max_length; j++){
	dict[dict_length-1].probmat[i][j] = startprob;
	b[dict_length-1][i][j] = startprob;
   }
 }
 }

 else{  // matrix based on background

   for(j=0; j<max_length; j++){
     for(i=0; i<NO_OF_BASES; i++){
  	  b[dict_length-1][i][j] = dictprobs[i];
	  dict[dict_length-1].probmat[i][j] = dictprobs[i];
     }
   }
 }

 if(MC == 1){ // finding number of repeats of 2-mers
  
  dimer = 1;
  
   for(j = 0; j < NO_OF_BASES; j++){
     for(k = 0; k < NO_OF_BASES; k++){
       Tcount[j][k] = 0;
     }
   }
 
   for(seqno = 0; seqno < no_of_seq; seqno++){
     
     for(i = 1; i < (L[k]-1) ; i++){
        j = findindex(S1[seqno][i]);		// index- from 1 to 4
	k = findindex(S1[seqno][i+1]);
	
	if((j>0)&&(k>0)) Tcount[j-1][k-1]++;
     }
   }

 // Setting up the Markov transition matrix

   for(i = 0; i < NO_OF_BASES; i++){

     for(j = 0; j < NO_OF_BASES; j++)   tmpD[j] = 1.0*Tcount[i][j];
   
     rDirich(NO_OF_BASES, tmpD, tmpT);
   
     for(j = 0; j < NO_OF_BASES; j++)   T[i+1][j+1] = tmpT[j];
   }

 
   //  Finding significant dimers

    for(j = 0; j < NO_OF_BASES; j++){
     for(k = 0; k < NO_OF_BASES; k++){
       expscore = totdimer*dictprobs[j]*dictprobs[k];
       Zscore[j][k] = (Tcount[j][k] - expscore)/sqrt(expscore);
     }
   }
  
   // Adding "significant" dimers to the dictionary

   jj = dict_length; 

    NoDimer = 0;
    for(seqno = 0; seqno < no_of_seq; seqno++){
      NoDimer += L[seqno]-2;
    }

   flag1 = 0;


   for(j = 1; j <= NO_OF_BASES; j++){
     for(k = 1; k <= NO_OF_BASES; k++){
       
       if(Zscore[j-1][k-1] > zCutOff){ 
	 //add dimer to dictionary - occurs more than expected

	 setString(0,0,base[j-1],str1);
	 strcat(str1,base[k-1]);
	 strcpy(dict[jj].name,str1);
	 dict[jj].coeff = 0.0;
	
	 dict[jj].repeat = Tcount[j-1][k-1];
	 word_size[jj] = strlen(dict[jj].name);
	 strcpy(word_list[jj-1], dict[jj].name);
	 beta[jj-1] = fracN*Tcount[j-1][k-1]; 
	 dictcount[jj-1] = Tcount[j-1][k-1] + beta[jj-1] ;
	 jj++;
       }
     }
   }
  
   dict_length = jj;
   
   rDirich(dict_length-1, dictcount, dictprobs);
   

   for(a=1; a<dict_length; a++){
     dict[a].prob = dictprobs[a-1];   
   }
   
   printf("\n");

 }
 
 
    // PART 1: Sampling for words given current update of stochastic word matrix

 iter=0; flag1=0;
 storemat.maxloglik = maxneg;
 storemat.maxpostlik = maxneg;

 while(flag1 == 0){
   iter++;
   
   seq17=0;

   for(seqno = 0; seqno < no_of_seq; seqno++) no_chosen[seqno]=0;

   obslik=0.0;

/* Given p, draw A */

 for(i=0; i<NO_OF_BASES; i++){
   for(j=0; j<max_length; j++){
     matcount[i][j] = 0;
   }}

 for(a=1; a<dict_length; a++) count[a] = 0;
 
 for(a=1; a<=NO_OF_BASES;a++) gapcount[a] = 0;

/* finding f */

 for(seqno = 0; seqno < no_of_seq; seqno++){// each sequence
    
    setString(1,1,S1[seqno],str1);

    for(k = 1; k < L[seqno]; k++) SEGMENT_PROB[k] = 0.0;

    lnS[0] = 0.0;
    lnS[1] = log(prob_back(str1[0]));
   
    k=2;

    while(k < L[seqno]){		// FORWARD SUMMATION
      

      lnS[k] = 0.0;
      	
      // two components of prob
      
      T1 = lnS[k-1] + log(prob_back(S1[seqno][k]));

      setString(k-1, k, S1[seqno], str1);   //dimer string 

      
	if( (k < L[seqno])&&(k >= gw) ){
	  
	  tmpFmat = FORWARD_SUM(k-gw+1, S1[seqno],motifIndex);	
	  T2 = lnS[k-gw] + log(tmpFmat.motifprob);
	  SEGMENT_PROB[k-gw+1] = tmpFmat.motifprob;  //starts from 2 when k = gw+1
 
	  if((dimer == 1)&&(dimerProb(str1) == 1)){ // 3 components to sample from
	    
	    T3 = lnS[k-2] + log(newprob);   //prob of dimer str1
	   
	    maxT = min(T1,T2);
	    maxT = min(maxT,T3);
	    
	    lnS[k] = log( exp(T1 - maxT) + exp(T2 - maxT) + exp(T3 - maxT) ) + maxT ;
	    
	  }

	  else{ // no dimers or insignificant dimer
	    maxT =  min(T1, T2);    
	    lnS[k] = log( exp(T1 - maxT) + exp(T2 - maxT)) + maxT ;
	  }
	}

	else{   // only base or dimer

	  if((dimer == 1)&&(dimerProb(str1) == 1)){ // has dimer
	    T3 = lnS[k-2] + log(newprob);
	    maxT = min(T1,T3);
	    lnS[k] = log( exp(T1 - maxT) + exp(T3 - maxT)) + maxT ;
	  }

	  else{ 
	    lnS[k] = T1 ;      // no dimer, only base
	  }
	}

	k++;
	if(k == L[seqno]) break;
 }
    
 obslik += lnS[L[seqno]-1];
 
/* Backward Sampling */



 k=L[seqno]-1;
 
 while(k >= 1){

	// for base

		nw = 1;
	
       		setString(k,k,S1[seqno],str1);
	
		for(a=1; a<motifIndex; a++){
				if(strcmp(str1, dict[a].name)==0) {
				  pa[nw] =  lnS[k-1] + log(dict[a].prob);    // log prob of being a base
				  ind[nw] = a;
				} /* end if */
		}
		
	 
		// for motif

		if(k >= gw){		  
			nw++;
		       	pa[nw] = lnS[k-gw] + log(SEGMENT_PROB[k-gw+1]);  /* based on current update of parameter */
			ind[nw] = motifIndex;			
			setString(k-gw+1,k,S1[seqno],str2);
			}
	

		// dimer may be present

		if((dimer == 1) && (k >= 2)){
		  
		  setString(k-1, k, S1[seqno], str1);
		  
		  if(dimerProb(str1) == 1){
		    
                    nw++;
		    pa[nw] = lnS[k-2] + log(newprob);   
		    ind[nw] = wordind;
		  }
		}
	     
		if(nw > 2){  // motif, dimer and base
		 
		  pa[1] = exp(pa[1] - pa[3]);
		  pa[2] = exp(pa[2] - pa[3]);
		  pa[3] = 1;

		  sel = sample(pa,3);
		  A = ind[sel];
		}


		else if(nw > 1){ // base and dimer, or motif and base
		  
		  pa[1] = exp(pa[1] - pa[2]);
		  pa[2] = 1;

		  sel = sample(pa,2);
		  A = ind[sel];
		}
		else A = ind[nw];
		
	if(A != motifIndex){ /* base or dimer */
	    count[A]++;		
	    strcpy(lastword,str1);
	}
	
	
	else {	 
	  // now need to sample for gaps within selected words and update the count matrix

	  count[A]++;

	  total_chosen = no_chosen[seqno];  
	  jj = k - gw + 1;

	start_position[seqno][total_chosen] = FindGaps(jj, S1[seqno],motifIndex, gapindices);
				// now don't penalise for gaps at end
	end_position[seqno][total_chosen] = k;

	strcpy(lastword,str2);	// this is motif with gaps

	
	
	setMotif(str2,updateMotif,gapindices); //finds positions for the motif
	
	setWithGaps(selwords,str2, gapindices); // motif with gaps that is chosen
	strcpy(choseword[seqno][total_chosen],selwords);


	for(i=0; i<gw; i++){

	  yesgap = 0;

	  for(kk=0; kk<width; kk++){
	    if((i+1) == gapindices[kk]){
	      yesgap = 1;   // not a gap position
	    
	      if(iter>1000){
		fprintf(f2,"%d\t",start_position[seqno][total_chosen]+gapindices[kk]-gapindices[0]);
	      }
	    }
	  }

	  if(yesgap==0){
	    a = findindex(lastword[i]);
	   
	    gapcount[a]++;
	  }
	}

	strcpy(chosemotif[seqno][total_chosen],updateMotif);

       	no_chosen[seqno]++;

	if(iter>1000) fclose(f2);  // closes the gap pos file
	}
		
	k -= strlen(lastword); 	 
      
	} /* end k */
 
  
 }/* end seqno */

  //Metropolis if iter > METRO and every 10th step

  if((iter > METRO) && (iter%10 == 0)){  //Metropolis
    
    if((rannum=rand()/M1) < 0.5) del = 1; else del = -1;

    if(del == 1){ // check whether shift one ahead

      choose = colratio(start_position, end_position,1,S1 );	// comparison of column after end with first column 
      //calculates ratio of gamma functions for specified columns


      if(choose > 1){ // move ahead  
	  motifplus(chosemotif,S1,end_position,start_position);
      }

      else if((rannum=rand()/M1) < (choose/(1+choose))) {	
		motifplus(chosemotif,S1,end_position,start_position); 
      }
    }



    else if (del == -1){
      choose = colratio(end_position, start_position,-1,S1 );	// comparison of column before start with last column

      if(choose > 1){ // move back
	motifminus(chosemotif,S1,start_position);
      }

      else if((rannum=rand()/M1) < (choose/(1+choose)) ){ 	
		motifminus(chosemotif,S1,start_position); 
      }
    }
  }	// end of Metropolis


 //print positions

  if(iter > collIter){					//somewhat stabilized 

    for(seqno = 0; seqno < no_of_seq; seqno++){
      for(i = 0; i < no_chosen[seqno]; i++){
	addnode(startvec[seqno], start_position[seqno][i]);
      }
    }
  }

// update count matrix

    for(seqno = 0; seqno < no_of_seq; seqno++){
	  for(k = 0; k < no_chosen[seqno]; k++){
	    
	    
	    for(i=0; i<width; i++){
	    setString(i,i,chosemotif[seqno][k], str2);

	    for(a=0; a<NO_OF_BASES; a++){
	      if(strcmp(str2,dict[a+1].name)==0) matcount[a][i]++;
	    }
	  }	    
	  }}


 sumcount=0;
for(a=1; a<dict_length; a++){

 if(a<=NO_OF_BASES){
    count[a] += gapcount[a];
  }
  sumcount +=count[a];
}

 total_chosen=0;
 for(seqno=0; seqno<no_of_seq; seqno++){
   total_chosen += no_chosen[seqno];
 }
 count[motifIndex] = total_chosen;
 

 
 postlik =  findlikSINGLE(matcount , count, beta,sumcount,total_chosen ,b[motifIndex]);
 MAP = motifsig(width, b[motifIndex],dict_length-1, count, matcount);
 
      if((postlik > storemat.maxpostlik)&&(iter > collIter)){ // store this theta
    
    storemat.maxloglik = obslik;
    storemat.maxpostlik = postlik;
 
    // copy matrix

     for(a=0; a<NO_OF_BASES; a++){
       storemat.prob[a] = dict[a+1].prob; 
       for(i=0; i<width; i++){
	 storemat.mat[a][i] =  dict[motifIndex].probmat[a][i];
       }
     }
     
     // copy starting positions

      for(seqno = 0; seqno < no_of_seq; seqno++){
	  storemat.pos[seqno] = copynode(start_position[seqno], no_chosen[seqno]);
	  storemat.words[seqno] = copymotifs(start_position[seqno], chosemotif[seqno], no_chosen[seqno]);
      }
    }

  // END OF SAMPLING FOR WORDS -- next: sampling for theta


  // PART 2 : SAMPLING FOR THETA
 

// now updating the word stochastic matrix

/* given A, draw p */

/* first draw probs of words */

 for(a=1; a<dict_length; a++){
   dictcount[a-1] = count[a]+beta[a-1];
 }


 // Check significance of dimers at end of each iteration then update dictionary

 rDirich(dict_length-1,dictcount,dictprobs);
 
 for(a=1; a<dict_length; a++){
  dict[a].prob = dictprobs[a-1];
 }


 for(j=0; j<max_length; j++){
   for(i=0; i<NO_OF_BASES; i++){
     count1[j][i] = b[motifIndex][i][j] + matcount[i][j];
   }
 }


// Now draw for theta

 /* draws from product Dirichlet */
 
 for(i=0; i<max_length; i++){
   rDirich(NO_OF_BASES, count1[i], probs[i]);
 }
 

 for(a=0; a<NO_OF_BASES; a++){
   for(i=0; i<max_length; i++){
     dict[motifIndex].probmat[a][i] = probs[i][a];
   }}



/* check criterion */

   for(i=0; i<max_length; i++){	
     for(a=0; a<NO_OF_BASES; a++){	
	localmat[a][i] = dict[motifIndex].probmat[a][i] ;	
     }}

   a = word_size[motifIndex];

   if(criterion(localmat,a,newword)==1){
	/* converged if after burn-out period */
     if(iter>MAXITER) flag1=1;
   }
   else {
     if(iter>MAXITER) {
       flag1=1;
     }
   }

}/* end iter */


/* add new word to dictionary */

 searchmotifs++;
 dict_length++;

 strcpy(word_list[dict_length-2],dict[dict_length-2].name);
 strcpy(word_list[dict_length-3],newword);

} /* end prob calc */

/* updated dictionary */


 // write start position vectors in files

 for(seqno = 0; seqno < no_of_seq; seqno++) names[seqno] = seqno + 1;

 iter50 = (int)((iter - collIter)*div/100);    // div% of utilised iterations  
 

 // get final theta (to find gaps) based on highest likelihood

  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      dict[motifIndex].probmat[a][i] = storemat.mat[a][i];
    }
  }

  for(a=0; a<NO_OF_BASES; a++){
    dict[a+1].prob = storemat.prob[a];
  }

 // write output file
 
 out = fopen(outfile,"a");  
 
 fprintf(out,"**********************************************\n");
 fprintf(out,"\n FILE OF RESULTS FROM SEGMENTATION SAMPLER \n\n");
 fprintf(out,"**********************************************\n");

 fprintf(out,"sdgap -i %s -o %s -S %d -w %d -g %d -p %d -d %d -r %d -I %d\n",file1,outfile,SEED,width,gaplength,(int)(motifPC*1000),MC,FB,MAXITER);

 fprintf(out,"\n Input data file is %s\n", file1);
 fprintf(out,"\n Number of sequences is %d\n",  forwardno);
 
 if(equi == 1)
   fprintf(out,"\n Starting stochastic word matrix has probabilities of %f\n", startprob);
 else 
   fprintf(out,"\n Starting stochastic word matrix based on background probabilities\n");

 fprintf(out,"\n Total number of iterations: %d\n", iter);
 fprintf(out,"\n No of iterations results calculated from: %d\n", (iter-collIter) );
 fprintf(out,"\n Motif width = %d ",width);
 fprintf(out,"\t Gap size is %d\n",gaplength);

 fprintf(out, "\n Prior for base proportional to %f of occurrence\n", fracN);
 fprintf(out, "\n Prior for motif %f of base\n", motifPC);
 fprintf(out,"\n Starting positions of binding sites\n");
 
 T1 = 100.0/(iter-collIter);

 fprintf(out,"\n MAXIMUM  probability aposteriori\n"); 

for(seqno = 0; seqno < no_of_seq; seqno++){
  printmotifnode(storemat.words[seqno],seqno,out, S1[seqno]);
}


 fprintf(out,"\n seed = %u\n", SEED);


 fprintf(out,"\n");


 fclose(out);


 system("rm -f buf.out");
 printf("\n <END> \n ");

} /* end main */
