#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "define.h"
#define burniniter (METRO+takepos) 

main(int argc,char *argv[])

{
  FILE *out;
  int infilegiven=0;
  int d=0, /* dimer absent */  r=0 /* reverse strand not taken */;
  int i;          
  char *option;

  int program = 1; /* multmotif */
  int g = 0, g0 = 0  ; /* gap width */
  int I = 1000, I0 = 1000; /* Max number of iterations */
  int l = 5, l0 = 5;  /*  minimum motif length */
  int L = 30, L0 = 30; /*  maximum motif length */
  int n = 5, n0 = 5; /* number of motifs */
  int p = 10, p0 = 10; /* pseudoprior: expected motif count per 100 bp */
  int w = 10,  w0 = 10; /* motif width */
  int A = 4000, A0 = 4000; /* length  iterations- len only */ 
  int M = 5, M0 = 5; /* number of mixture components - BF only */
  unsigned int S = (unsigned int)(time(NULL)); /* SEED value */
  char infile[20],outfile[20], result[30];
  const char *resultfile;
  strcpy(outfile,"sdda.out");// default output file

  if(argc==1){
     goto INTERACTIVE;     // No command line options given
  }
  
  for(i=1;i<argc;i++){
    if(argv[i][0]=='-'){
      switch(argv[i][1]){

      case 'i':
	infilegiven=1;
	strcpy(infile,argv[i+1]);
	i++;break;

      case 'P':  
	switch(argv[i+1][0]){
	case 'l': program = 2; break;
	case 'g': program = 3; break;	
	case 'b': program = 4; break;
       	default: printf("Invalid program option\n Usage:  -P [(l)en,(g)ap,(b)f]\n");
	  exit(0);
	} 
	i++;break;
	
      case 'g': 
	g = atoi(argv[i+1]);
	i++;break;	

      case 'I': 
	I = atoi(argv[i+1]) +  burniniter;
	i++;break;	
	
      case 'l': 
	l = atoi(argv[i+1]);
	i++;break;

	
      case 'L': 
	L = atoi(argv[i+1]);
	i++;break;
	
      case 'n':
	n = atoi(argv[i+1]);
	i++;break;

      case 'o':
	strcpy(outfile,argv[i+1]);
	i++;break;

      case 'p':
	p = atoi(argv[i+1]);
	i++;break;

      case 'S': 
	S = atoi(argv[i+1]); //seed
	i++;break;	

      case 'w': 
	w = atoi(argv[i+1]);
	i++;break;

      case 'A': 
	A = atoi(argv[i+1]);
	i++;break;	
	
      case 'M': 
	M = atoi(argv[i+1]);
	i++;break;	

      case 'd': d=1;break;
	
      case 'r': r=1; break;	
     
      default:
	continue;
	break;
	}
    }
  
    else printf("Usage:.......................");
  }
  
  if(!infilegiven) {
    printf("Input file not given!\n");
    exit(0);
  }


  // send arguments to programs


  resultfile = &result[0];
  
  out = fopen("INPUTS","w");
  if(remove(resultfile) != 0) 
 

  switch(program){

   case 1: //multiple motifs
     fprintf(out,"%s\n%s\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n",infile,outfile,S,w,p,n,d,r,I);
     fclose(out);
     if(g!=g0) printf("\n Gaps option not being utilized\n");
     if((l!=l0)||(L!=L0)) printf("\n length change not utilized\n");   
     system("./sdmultmotif < INPUTS");
     break;

  case 2: //varying motif length
     fprintf(out,"%s\n%s\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n",infile,outfile,S,w,p,d,r,I,l,L,A);
     fclose(out);
     printf("\n reporting top motif only\n");
     if(g!=g0) printf("\n Gaps option not being utilized\n");
     system("./sdlen < INPUTS");
     break;

  case 3: //gaps
     fprintf(out,"%s\n%s\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n",infile,outfile,S,w,g,p,d,r,I);
     fclose(out);
     printf("\n reporting top motif only\n");
     if((l!=l0)||(L!=L0)) printf("\n length change not utilized\n");
     system("./sdgap < INPUTS");
     break;
 
  case 4: //bayes factor
     fprintf(out,"%s\n%s\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n",infile,outfile,S,w,p,d,r,I,M);
     fclose(out);
     printf("\n reporting top motif only\n");
     if((l!=l0)||(L!=L0)) printf("\n length change not utilized\n");
     if(g!=g0) printf("\n Gaps option not being utilized\n");
     system("./sdBFmix < INPUTS");
     break;
  }

  printf("\n <END>\n");
  system("rm -f INPUTS");
  exit(0);

 INTERACTIVE:
  system("cat options.txt");
  printf("\n\n");
  exit(0);
}
    
