#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "define.h"
#include "allstruct.h"
#include "multfns.h"




int ReadSeq(FILE *fIn, FILE *fOut, char Seq[NoSeqs][MaxSeqLen], int SeqLen[NoSeqs]){
  // reads sequences in FASTA format from fIn, writes to fOut(without newline characters or comments, stores sequence lengths in SeqLen, and the sequences in Seq, and returns number of sequences

  int   seqno = 0, sLen = 0, NoOfChar, NoOfSeq;
  char  c;

  while(feof(fIn) == 0){
        
     while((c = getc(fIn)) != '\n') ;      // read comment line
    
       sLen = 0;

    // read sequence

     while((c = getc(fIn)) != '>'){ 
      
      if (c == EOF) break;

      if(c != '\n'){
	Seq[seqno][sLen] = c;
	sLen++ ;		// next position in string   
      }
    }
    Seq[seqno][sLen] = '\0';

    SeqLen[seqno] = strlen(Seq[seqno]);
    
    fprintf(fOut,">%d\n",seqno+1);
    fprintf(fOut,"%s\n",Seq[seqno]);
    seqno++ ;
  } // end while

  NoOfSeq = seqno;

  fclose(fIn);
  fclose(fOut);

  return(NoOfSeq);
}


table *maketable(node *oldlist){
  // makes table from linklist of positions (excludes 1st node of 0)


  node   *tmp;
  int	 i = 0, j = 0, n, ind, numInd ;
  int    x[50000],temp;
  table  *new,*new1,*top;

  //count number of nodes

  tmp = oldlist;
  n = 0;

  while(tmp->next != NULL){
    tmp = tmp->next;
    n++;
  }

  //sort list
  
  i = 0;
  tmp = oldlist;

  while(tmp->next != NULL){
    tmp = tmp->next;
    x[i] = tmp->position;
    i++;
  }
  
  
 for( i = 0; i < n ; i++){
   for( j = 0; j < i ; j++){
     if (x[i] > x[j]) {
       temp = x[i];
       x[i] = x[j];
       x[j] = temp;

     }
   }
 }

 top = (table*)malloc(sizeof(table));
 top->val = x[0];
 top->freq = 1;
 top->index = 1;
 ind = 1; 

 new = top;
 i = 1;
 while ( i < n){
   
	if (new->val==x[i]) new->freq++;
		else {
		  new1=(table*)malloc(sizeof(table));
		  new->next=new1;
		  new1->val=x[i];
		  new1->freq=1;
		  new1->next=NULL;
		  ind++;
		  new1->index = ind;
		  new=new1;
		}
	i++;
 }
 
 new1 = top;
 numInd = 1;

 while(new1->next != NULL){
   new1 = new1->next;
   numInd++;
 }

 // sort table according to frequencies

 for(new = top; new!=NULL; new=new->next){
    for(new1 = top; new1->index < new->index; new1=new1->next){

      if(new->freq > new1->freq){  //switch
       j = new->freq;
       new->freq = new1->freq;
       new1->freq = j;

       j = new->val;
       new->val = new1->val;
       new1->val = j;
     }

    }
 }

 new = top;

 return(top);
}



/***************************************/
/* Dirichlet random variate generation */
/***************************************/

/* Best's rejection algorithm for gamma variables, a>=1 */

void Rgamma(double a, int n, double gam[]){
  /* generate n gamma random variables with parameter a >= 1 */

  double b,c,u,v,w,y,x,z;
  int i, accept;


  b = a - 1;
  c = 3*a - 3/4;

    for(i=0; i<n; i++){ /* n draws */

      accept = 0;

      while(accept==0){
	
	u = rand()/M1;
	v = rand()/M1;		/* generate uniform variates  */

	w = u*(1-u);
	y = sqrt(c/w) * (u - 1/2);
	x = b + y;

	if (x >= 0) {
	  z = 64*pow(w,3)*pow(v,2);

	  if (z<= 1 - 2*y*y/x) accept = 1;
	  
	  else if ((a>1)&&(log(z)<= 2*(b*log(x/b) - y))) accept = 1;
	  else if ((a==1)&&(log(z)<=-2*y)) accept = 1;
		}

      }
      gam[i] = x; 
    }

}


void rgamma(double a, int n, double gam[]){
  /* Johnk's gamma generator  */

	int i, accept,flag=0;
	double  u,v,e,x,y,r;
	

	for(i=0; i<n; i++){
	  accept = 0;
	
	   while(accept==0){
	     u = rand()/M1;
	     v = rand()/M1;

	     x = pow(u,1/a);
	     y = pow(v,1/(1-a));

	     if(x+y<=1)  accept =1;
	   }

	   while(flag==0){ 
	     r= rand();
	     if(r>1E-10){ 
	       flag=1;
	       e =  -log(r/M1);  /* exponential r.v. */
	                }
	   }
	   gam[i] =  e*x/(x+y);
	}
	return;
}

void rDirich(int k, double a[], double d[]){

  int i;
  double gam[100], cum=0.0,temp[20];

  for(i=0; i<k; i++){

    if(a[i]>=1){
	Rgamma(a[i],1,temp); 
	gam[i] = temp[0];
	}
    else{ 
	rgamma(a[i],1,temp); 
	gam[i] = temp[0];
	}
    }

for(i=0; i<k; i++) cum += gam[i];

 for(i=0; i<k; i++){
   d[i] = gam[i]/cum;
 }
    return;
}


/************************************************/


void setString(int i, int j, char str[], char newString[]){
  /* gets a segment of sequence from position i to j of str*/

	int l;

	for(l=0; l<j-i+1; l++)
		newString[l] = str[i+l];
	newString[j-i+1] = '\0';
} 


int dimerProb(char str[]){

  int a;

  newprob = 0.0; wordind = 0;

  for(a = motifIndex; a < dict_length; a++){
    if(strcmp(dict[a].name,str) == 0){ 
      newprob = dict[a].prob;
      wordind = a;
      return(1);
    }
  }
  
  return(0);
}




int maximum(double array[MOTIFLENGTH],int n){
  // returns index of maximum of an array

int 	i,maxindex=0;
double 	max;

 max = array[0];
for(i=1; i<n; i++){
	if(array[i]>max) {max = array[i];
			  maxindex = i;}
}
return(maxindex);
}


int intmax(int array[NO_OF_BASES]){
  // returns index of maximum of an array

int 	i,maxindex=0;
double 	max;

 max = array[0];
 for(i=1; i<NO_OF_BASES; i++){
   if(array[i]>max) {max = array[i];
   maxindex = i;}
 }
 return(maxindex);
}




int criterion(double p[NO_OF_BASES][MOTIFLENGTH], int length, char newword[MOTIFLENGTH]){

int 	i,j,flag[MOTIFLENGTH],sum=0,crit=0,maxp;
double	parr[NO_OF_BASES];


for(i=0; i<length; i++){
  flag[i]=0;

  for(j=0; j<NO_OF_BASES; j++){
	parr[j] = p[j][i];	
 }
	maxp = maximum(parr,NO_OF_BASES);	

       	if (parr[maxp]>.8) flag[i]=1;
	newword[i] = letter[maxp];
}

for(i=0; i<length; i++){
	sum += flag[i];
}
if(sum>=length) crit=1;

return(crit);
}


void strUpr(char str1[], char str2[]){

  int i;

  strcpy(str2,str1);
  for(i=0; i<strlen(str1); i++){
    str2[i] = toupper(str1[i]);
  }
  }

void strLwr(char str1[], char str2[]){

  int i;

  strcpy(str2,str1);
  for(i=0; i<strlen(str1); i++){
    str2[i] = tolower(str1[i]);
  }
  }





int sample(double p[], int p_length){

double	 cum[20],r,sum=0.0;
int 	 i,index=0;


for(i=1; i<=p_length; i++)sum += p[i]; 
 for(i=1; i<=p_length; i++) p[i] /= sum;

 cum[0]=0.0;
 for(i=1; i<=p_length; i++){
	cum[i] = cum[i-1] + p[i];
 }

	r = rand()/M1;
	for(i=1; i<=p_length; i++){

		if((r>=cum[i-1])&&(r<=cum[i])){
		  index = i;
		}
	}
	
	return(index);
}


int findindex(char b){  //returns index of base

  int  a;

 for(a=1; a<=NO_OF_BASES;a++){
    if(letter[a-1] == b) return a;
  } 
 if(b == 'N') return(0);    // unknown (missing) nucleotide
 printf("\n Error: not a valid letter (A,C,G,T,N)!");
 return(-1);   // error
}

double prob_back(char base){   /* returns background probability */
  int a;
  char str[2];


  str[0]=base;
  str[1]='\0';

 for(a=1; a<=NO_OF_BASES;a++){
    if(strcmp(dict[a].name,str)==0) return dict[a].prob;
  }
 if(base == 'N') return(1.0);    // unknown (missing) nucleotide

}

double prob_mat(char base, int i, int word){ /* returns prob. according to matrix */
  int a = findindex(base);

  if(a > 0) return(dict[word].probmat[a-1][i]);
  return(1.0);  // unknown (missing) nucleotide
}

double logProb(char str[], int word){ 
  // returns log(prob) of old word based on its stochastic word matrix

  int   i,a,length;
  char  str2[2];
  double  lnR = 0.0, R = 1.0;

  length = strlen(str);
  
    for(i=0; i<length; i++){
      a = findindex(str[i])-1;
      if(a > -1) lnR += log(dict[word].probmat[a][i]);
    } 

    return(lnR+log(dict[word].prob));	/* prob of the word  */
}


struct Fmat FORWARD_SUM(int pos, char SEQ[BIGSEQ],int wordno){

  // finds probability of (alignment of stochastic matrix with) segment containing gaps for forward summation

  int  end, length = gaplength + width, g = gaplength, w = width ,j, k ;
  char seg[TOTLENGTH];
  struct Fmat F;
  
  end = pos + g + w - 1;  
  
  setString(pos, end , SEQ,seg); 


  /* FS to compute alignment probs for motif */

  for(j = 0; j <= w; j++){
    for(k = 0; k <= length; k++){
      F.FH[j][k] = 0.0;
      F.FM[j][k] = 0.0;
    }}
  
  F.FH[0][1] = prob_back(seg[0]);


  for(k = 2; k <= g; k++){
    F.FH[0][k] = F.FH[0][k-1]*prob_back(seg[k-1]);	// gap at beginning not penalised
  }

  
  F.FH[0][0] = 1.0; // convention that gives F.FM(1,1) in the next step

   for(j = 1; j <= (w-1); j++){
    for(k = j; k <= (g+j); k++){

      F.FH[j][k] = (F.FM[j][k-1]*P_go + F.FH[j][k-1]*P_ge)*prob_back(seg[k-1]); // for gaps
      
      F.FM[j][k] = (F.FM[j-1][k-1] + F.FH[j-1][k-1])*P_m*prob_mat(seg[k-1],j-1,wordno); // k-th match

    }
  }

  /* j = w : last line */

   F.FM[w][w+g] = (F.FH[w-1][w+g-1] + F.FM[w-1][w+g-1])*P_m*prob_mat(seg[w+g-1],w-1,wordno); 
   
   // has to be aligned at end
   

   F.motifprob = F.FM[w][w+g]*dict[wordno].prob; ;

  
// bottom right corner multiplied by prob of that word in the dictionary is the prob. of the motif

  return(F);

} //end function


void MatPrint(struct Fmat F, int w, int gw){

  int  i, j;

  printf("\n H matrix \n");

  for(i = 0 ; i < w; i++){
    printf("\n");
    for(j = 0; j < gw ; j++){
      printf("\t %lf",F.FH[i][j]);
    }
  }

  printf("\n \n  M MATRIX \n ");

for(i = 0 ; i < w ; i++){
    printf("\n");
    for(j = 0; j < gw ; j++){
      printf("\t %lf",F.FM[i][j]);
    }
  }
 return;
}



struct Fmat FIND_ALIGNMENT(int pos, char SEQ[BIGSEQ],int wordno){

  // finds probability of (alignment of stochastic matrix with) segment containing gaps during backward sampling

  int  end, length = gaplength + width, g = gaplength, w = width ,j, k ;
  char seg[TOTLENGTH];
  struct Fmat F;
  
  end = pos + g + w - 1;  

  setString(pos, end , SEQ,seg); 

  
  /* FS to compute alignment probs for motif */

  for(j = 0; j < w; j++){
    for(k = 0; k < length; k++){
      F.FH[j][k] = 0.0;
      F.FM[j][k] = 0.0;
    }}

  F.FM[0][0] = P_m * prob_mat(seg[0],0,wordno);

  
  /* j = 0 : 1st line */

  for(k = 1; k < (g+1); k++){
    F.FH[0][k] = (F.FM[0][k-1]*P_go + F.FH[0][k-1]*P_ge)*prob_back(seg[k]);
  }

  for(j = 1; j < (w-1); j++){
    for(k = j; k <= (g+j); k++){

      F.FH[j][k] = (F.FM[j][k-1]*P_go + F.FH[j][k-1]*P_ge)*prob_back(seg[k]); // for gaps
      
      F.FM[j][k] = (F.FM[j-1][k-1] + F.FH[j-1][k-1])*P_m*prob_mat(seg[k],j,wordno); // k-th match

    }
  }

  /* j = w-1 : last line */

  for(k = (w-1) ; k < length; k++){
    F.FH[w-1][k] = (F.FM[w-1][k-1] + F.FH[w-1][k-1])*prob_back(seg[k]); // no penalty for gap at end

    F.FM[w-1][k] = (F.FM[w-2][k-1] + F.FH[w-2][k-1])*P_m*prob_mat(seg[k],w-1,wordno);
  }


  F.motifprob = (F.FH[w-1][w+g-1] + F.FM[w-1][w+g-1])*dict[wordno].prob; 

// bottom right corner multiplied by prob of that word in the dictionary is the prob. of the motif

  return(F);

} //end function




int FindFinalGaps(int pos, char SEQ[BIGSEQ],int wordno, int nogaps[MOTIFLENGTH]){

  // Maximal Alignment Probability
  // Finds which positions in motif are likely to be gap positions: after start positions 
  // chosen.. then returns ending position of motif

  int     i, j, k, ind, gw = width + gaplength ;
  double  gapprob[dict_length];
  struct  Fmat newF;
  

  for(i = 0; i < width; i++) nogaps[i] = 0;

  newF = FIND_ALIGNMENT(pos, SEQ, wordno);

  j = width - 1;
  k = width + gaplength - 1;

  // no gap present at start: may have gaps (unpenalised) at end
  
  while((j > 0)&&(k >= 0)){
     gapprob[0] = newF.FM[j][k];  
     gapprob[1] = newF.FH[j][k];

     ind = maximum(gapprob,2);
  
     if(ind==0){
       nogaps[j] = k ;      // which position of motif is non-gap
       j--;
       k--;       
     }

     else{
       k--;
     }

  }// end while


  if(j==0){ 
    nogaps[j] = 0;           // start position
  }

  return(pos+nogaps[width-1]);     // end position

}






int FindGaps(int pos, char SEQ[BIGSEQ],int wordno, int nogaps[MOTIFLENGTH]){

  // Finds which positions in motif are likely to be gap positions and returns position of start of motif

  int     i, j, k, ind ;
  double  gapprob[dict_length];
  struct  Fmat newF;
  

  for(i = 0; i < width; i++) nogaps[i] = 0;

  newF = FORWARD_SUM(pos, SEQ, wordno);

  j = width - 1;
  k = width + gaplength - 1;

  // no gap present at end: may have gaps (unpenalised) at front end

  nogaps[j] = k;
  
  while((j > 0)&&(k >= 0)){
     gapprob[1] = newF.FM[j][k];  
     gapprob[2] = newF.FH[j][k];

     ind = sample(gapprob,2);
  
     if(ind==1){
       nogaps[j-1] = k-1 ;      // which position of motif is non-gap
       j--;
       k--;       
     }

     else{
       k--;
     }

  }// end while


  if(j==0){ //reached top line- deterministic
    return(pos+nogaps[0]);    
  }

  return(pos+nogaps[0]);

}


void setMotif(char str[TOTLENGTH], char updateMotif[MOTIFLENGTH], int gapindices[MOTIFLENGTH]){

  // selects the motif by leaving out gap positions
  int i;

  for(i = 0; i < width; i++){    
    updateMotif[i] = str[gapindices[i]];
   }  
  updateMotif[width]= '\0';
  return;
}

void setWithGaps(char newstr[TOTLENGTH],char withgaps[MOTIFLENGTH],int gapindices[MOTIFLENGTH]){ 

  int i, gw = gaplength + width;

  for(i = 0; i < gw; i++) newstr[i] = '-';

  for(i = 0; i < width ; i++){    
    newstr[gapindices[i]] = withgaps[gapindices[i]];    
   }  
  newstr[gw] = '\0';
  return;
}


double colratio(int den[NO_OF_SEQ][MOTIF_COUNT], int num[NO_OF_SEQ][MOTIF_COUNT], int d,char SEQ[NO_OF_SEQ][BIGSEQ]){
//calculates ratio of gamma functions for 'num+d' column to 'den' column

  int	 seqno,k,a;
  double rat = 0.0, coll1[NO_OF_BASES],coll2[NO_OF_BASES] ;

for(a=0; a<NO_OF_BASES; a++){ coll1[a]=0; coll2[a]=0;}

  for(seqno = 0 ; seqno < no_of_seq; seqno++){
    for(k = 0 ; k < no_chosen[seqno]; k++){
            for(a = 0; a < NO_OF_BASES; a++){
	 		if(SEQ[seqno][num[seqno][k]+ d]==letter[a]) coll2[a]++;	
			if(SEQ[seqno][den[seqno][k]]==letter[a]) coll1[a]++;	
	    }

    }}

  for(a=0; a<NO_OF_BASES; a++){
    rat += (coll2[a]+beta[a]-0.5)*log(coll2[a]+beta[a]-1.0) - (coll1[a]+beta[a]-0.5)*log(coll1[a]+beta[a]-1.0);
  }
  
return(exp(rat));

}




void addnode(node *mylist, int newpos){   //adds a new starting position to the current list

  node  *tmp;

  tmp = mylist;
  
  while(tmp->next != NULL){
    tmp = tmp->next;
  }

  
  tmp->next = (node*)malloc(sizeof(node));
  tmp = tmp->next;
  tmp->position = newpos;
  tmp->next = NULL;
  

  return;
}

void printlist(node *mylist){

  node *tmp;

  tmp = mylist;
  if(tmp == NULL) return;
  
  while(tmp != NULL){
    printf("\t --> %d",tmp->position);  
    tmp = tmp->next;
  }

  return;  
}


node *copynode(int pos[MOTIF_COUNT], int total){

  int   i;
  node  *newlist;

  if(total == 0){
    newlist = NULL;
    return newlist;
  }

  newlist = (node*)malloc(sizeof(node));
  newlist->position = pos[0];
  newlist->next = NULL;
  
  for(i = 1; i < total; i++){   
    addnode(newlist,pos[i]);
  }

  return newlist;
}


void printnode(node *mylist,int seqno, FILE *fp, char SEQ[BIGSEQ]){

  node *tmp;
  char  tmpstr[MOTIFLENGTH];

  tmp = mylist;
  if(tmp==NULL) return;

  while(tmp != NULL){   
    setString(tmp->position,tmp->position+width-1,SEQ,tmpstr);
    printf("%d\t %d\t %s\n",seqno+1,tmp->position,tmpstr);       
    fprintf(fp,"%d\t %d\t %s\n",seqno+1,tmp->position,tmpstr);       
    tmp = tmp->next;
  }

  return;
}


void printnodeEmc(node *mylist,int seqno, FILE *fp, char SEQ[BIGSEQ],int MotifNo){

  node *tmp;
  char  tmpstr[MOTIFLENGTH];

  tmp = mylist;
  if(tmp==NULL) {
    return;
  }

  while(tmp != NULL){   
    setString(tmp->position,tmp->position+width-1,SEQ,tmpstr);
    fprintf(fp,"%d\t %d\t %d\t %s\n",MotifNo,seqno+1,tmp->position,tmpstr);       
    tmp = tmp->next;
  }

  return;
}





void printpositions(node *mylist, FILE *fp,int seqno, char SEQ[BIGSEQ]){
  // prints ungapped motifs from list
  int     i;
  char    tmpstr[MOTIFLENGTH];
  node    *tmp;

  tmp = mylist;
  if(tmp==NULL){
    return;
  }

  while(tmp != NULL){   
    i = tmp->position;
    printf("i= %d, seq = %d",i,seqno);
    setString(i,i+width-1,SEQ,tmpstr);    
    fprintf(fp,"%d\t %d\t %s\n",seqno, tmp->position,tmpstr);  
    printf("%d\t %d\t %s\n",seqno, tmp->position,tmpstr);  
    tmp = tmp->next;
  }

  return;
}

   


int compare(int pos, node *startlist){

  //returns pos if no match, 0 if match (overlaps)

  node *tmp;
  int  over = (int)(width);		// doesn't overlap 90%

  tmp =  startlist;
  
  if(abs(tmp->position - pos) < over) return 0;     // overlap

  while(tmp->next != NULL){
    tmp = tmp->next;
    if(abs(tmp->position - pos) < over) return 0;   // overlap
  }

  return(pos);					// no match, so add new position

}


void addpos(vect *myvect, int seq, int ps, int fr, char rof){
  // adds a new vect

  vect  *tmp;
 
  tmp = myvect;

  while(tmp->next != NULL){
    tmp = tmp->next;
  }

  tmp->next = (vect*)malloc(sizeof(vect));
  tmp = tmp->next;
  tmp->SeqNo = seq + 1;
  tmp->pos = ps;
  tmp->freq = fr;
  tmp->rf = rof;
  tmp->next = NULL;
  return;
}





int printvec(FILE *Fout, vect *myvect, char SEQ[NO_OF_SEQ][BIGSEQ],int LEN[NO_OF_SEQ],double Tfreq){
  // leaves out first (0th entry) and prints out the rest (non-overlapping motifs with highest frequency) in file outfile

  int     i,a,st, end, num, NoMotifs = 0, oldnum, new, temp, bef, MotifPos[MOTIFLENGTH];
  double  countmat[NO_OF_BASES][MOTIFLENGTH];
  vect    *tmp;
  char    tempS[MOTIFLENGTH], update[MOTIFLENGTH], gapmotif[TOTLENGTH], dum, bestr[5], afstr[5],newst[5];
  node    *starts;


  for(i = 0; i < width; i++){
    for(a = 0; a < NO_OF_BASES; a++){
      countmat[a][i] = 0.0;
    }}

  tmp = myvect;

  if(tmp==NULL){
    printf("NO MOTIFS\n");
    return(0);
     exit(0);
  }
	if(tmp->next==NULL) {
	  printf(" NO MOTIFS FOUND UNDER SET RESTRICTIONS!\n");
	   return(0);
	  exit(0);
	}

	
   // initialize starts

   finalpos = (vect*)malloc(sizeof(vect));  // vector of all finally chosen starting positions
   finalpos->pos = 0;
   finalpos->SeqNo = 0;
   finalpos->freq = 0;
   finalpos->next = NULL;	
	
   starts = (node*)malloc(sizeof(node));
   starts->position = 0;
   starts->next = NULL;	

   oldnum = tmp->next->SeqNo - 1;   // first sequence that has motifs

   while(tmp->next != NULL){  // go through the positions
    
     tmp = tmp->next;
     st = tmp->pos;		// new start position
     end = st + width - 1; 
     num = tmp->SeqNo - 1;
     dum = tmp->rf;

     if(oldnum == num){   // same sequence

       new = compare(st, starts);
      
         if(new != 0){   //new position- add
	
	   if(dum == 'f'){
	     addnode(starts, st);
	     end = end + gaplength;
	     setString(st, end, SEQ[num], tempS);			   // motif with gaps
	     end = FindFinalGaps(st, SEQ[num], motifIndex, MotifPos);      // gap positions found 
	     setMotif(tempS, update, MotifPos);				   // motif
	     setWithGaps(gapmotif, tempS, MotifPos);			   // gaps positioned
	     setString(st-5, st-1, SEQ[num], newst);			   // 5 before
	     strLwr(newst, bestr);
	     setString(end+1, end+5,  SEQ[num], newst);			   // 5 after
	     strLwr(newst, afstr);
	     fprintf(Fout,"\t  %d\t %c\t %d\t %3.2f\t  %s %s %s\n",tmp->SeqNo, tmp->rf, tmp->pos, tmp->freq*Tfreq,  update, gapmotif, tempS);
	     NoMotifs++;						   //count motif   
	     
	     // update count matrix

	     for(i = 0; i < width; i++){
	       a = findindex(update[i]) - 1;       // 0,1,2, or 3
	       if(a >= 0) countmat[a][i]++;
	     }

	     addpos(finalpos, tmp->SeqNo - 1, tmp->pos, tmp->rf, 0);
	   }
	   
	   else{  // reverse strand
	     temp = LEN[tmp->SeqNo - 1] - tmp->pos;			    // since LEN = strlen + 1
	     addnode(starts, st);
	     setString(st, end, SEQ[num], tempS);
	     fprintf(Fout,"\t %d\t %d\t %c\t %s\n",(tmp->SeqNo-forwardno), temp, tmp->rf, tempS);
	     NoMotifs++;						    //count motif  
	     addpos(finalpos, tmp->SeqNo - 1, tmp->pos, tmp->rf, 0);
	   }
       }
     }

     else{    //new sequence: nothing to compare
       free(starts);
       starts = (node*)malloc(sizeof(node));				// start new set
       starts->position = st;
       starts->next = NULL;	
       oldnum = num;							// index of new sequence
       
       if(dum == 'f'){
	 end = end + gaplength;
	 setString(st, end, SEQ[num], tempS);

	 end = FindFinalGaps(st, SEQ[num], motifIndex, MotifPos);    // gap positions found 
	 setMotif(tempS, update, MotifPos);				// motif
	 setWithGaps(gapmotif, tempS, MotifPos);			// gaps positioned
	 setString(st-5, st-1, SEQ[num], newst);			// 5 before
	 strLwr(newst, bestr);
	 setString(end+1, end+5,  SEQ[num], newst);			// 5 after
	 strLwr(newst, afstr);
	 fprintf(Fout,"\t  %d\t %c\t %d\t %3.2f\t  %s %s %s\n",tmp->SeqNo, tmp->rf, tmp->pos, tmp->freq*Tfreq, update, gapmotif, tempS);
	 NoMotifs++;							//count motif

	 // update count matrix

	     for(i = 0; i < width; i++){
	       a = findindex(update[i]) - 1;       // 0,1,2, or 3
	       if(a >= 0) countmat[a][i]++;
	     }

	 addpos(finalpos, tmp->SeqNo - 1, tmp->pos, tmp->rf,0);
       }
       
       else{		// reverse strand
	 temp = LEN[tmp->SeqNo - 1] - tmp->pos;	
	 setString(st, end, SEQ[num], tempS);
	 fprintf(Fout,"\t %d\t %d\t %c\t  \t %s\n",(tmp->SeqNo-forwardno), temp, tmp->rf, tempS);
	 addpos(finalpos, tmp->SeqNo - 1, tmp->pos, tmp->rf, 0);
       }
     }
   }

   // final prob. matrix based on counts
   
   for(i = 0; i < width; i++){
    for(a = 0; a < NO_OF_BASES; a++){
      FinalMat[a][i] = countmat[a][i]/(float)NoMotifs ;
    }}
   
   
   fprintf(Fout,"\n Total number of motifs = %d\n",NoMotifs);
  return(NoMotifs);  
}



void printout(vect *myvect){
  // prints to stdout

  int   st, end, num, NoMotifs = 0;
  vect  *tmp;

  tmp = myvect;

	if(tmp->next==NULL) {
	  printf("ERROR! NO MOTIFS FOUND\n");
	  exit(0);
	}

	printf("\n");

 while(tmp->next != NULL){
     tmp = tmp->next;
     st = tmp->pos;
     end = st + width - 1; 
     printf("\t %d\t %d\t %s\n",tmp->SeqNo, tmp->pos);
     NoMotifs++;
  }

    printf("\n Total number of motifs = %d\n",NoMotifs);
  return;  
}


void TakeComplement(char str[BIGSEQ], char newstr[BIGSEQ]){
  // takes nucleic acid complement of str and writes to newstr in reverse

  int   i, n = strlen(str);
  char  tmp[BIGSEQ];
  
  strcpy(tmp,str);
  

  for(i = 0; i < n; i++){
    if(str[i] == 'A') tmp[i] = 'T';
    else if(str[i] == 'C') tmp[i] = 'G';
    else if(str[i] == 'G') tmp[i] = 'C';
    else if(str[i] == 'T') tmp[i] = 'A';
  }

  strcpy(newstr,tmp);
  
  for(i = 0; i < n; i++){
    newstr[i] = tmp[n-i-1];
  }

  return;
}

void CapitalizeMotif(char SEQ[BIGSEQ],char newSEQ[BIGSEQ], int pos){
  
  int	 i, k;
  char 	 tmp[BIGSEQ];

  strcpy(tmp, SEQ);


    for(k = pos; k < (pos+width); k++){ 
      tmp[k] = toupper(SEQ[k]);
    }
  

  strcpy(newSEQ,tmp);
  return;
}


double lngamma(double arg){
  //calculates log(gamma(arg)) for arg > 0
  double res;

  res = (arg - 0.5)*log(arg - 1) - arg + 1; 
  return(res);
}



double ChiSqCutoff(int W, double cut){

  double p5[11] ={43.7730, 50.9985,  58.1240,  65.1708,  72.1532,  79.0819 , 85.9649,  92.8083,  99.6169, 106.3948, 113.1453} ,  p1[11] = {50.8922, 58.6192,  66.2062,  73.6826,  81.0688,  88.3794,  95.6257, 102.8163 ,109.9581, 117.0565, 124.1163};
  int   i, ind[11] = {5,6,7,8,9,10,11,12,13,14,15};

  if(cut==0.05){
    for(i = 0; i < 11; i++){
      if(W == ind[i]) return(p5[i]);
    }
    printf("Invalid df!");
  }

  else if(cut==0.01){
    for(i = 0; i < 11; i++){
      if(W == ind[i]) return(p1[i]);
    }
     printf("Invalid df!");
  }

  else printf("Invalid percentile!");
  return 0.0;
}




void motifplus(char motif[NO_OF_SEQ][MOTIF_COUNT][MOTIFLENGTH], char SEQ[NO_OF_SEQ][BIGSEQ], int end[NO_OF_SEQ][MOTIF_COUNT],int start[NO_OF_SEQ][MOTIF_COUNT]){
  // shifts motif ahead by 1

  int	i, n = width, j, k;
  char	newmotif[MOTIFLENGTH];

  for(j = 0 ; j < no_of_seq; j++){
    for(k = 0 ; k < no_chosen[j]; k++){
            
      for(i = 1; i < n; i++)
	newmotif[i-1] = motif[j][k][i];
      newmotif[n-1] = SEQ[j][end[j][k]+1];

      start[j][k]++;	//start position moves ahead by 1
      
      newmotif[n] = '\0';
      
      strcpy(motif[j][k], newmotif);
    }
  }
  return;
}


void motifminus(char motif[NO_OF_SEQ][MOTIF_COUNT][MOTIFLENGTH], char SEQ[NO_OF_SEQ][BIGSEQ], int start[NO_OF_SEQ][MOTIF_COUNT]){
 // shifts motif back by 1

int	i, n = width, j, k;
  char	newmotif[MOTIFLENGTH];

  for(j = 0 ; j < no_of_seq; j++){
    for(k = 0 ; k < no_chosen[j]; k++){
    
      newmotif[0] = SEQ[j][start[j][k]-1];

      for(i = 0; i < n-1; i++)
	newmotif[i+1] = motif[j][k][i];
 
      newmotif[n] = '\0';
      
      strcpy(motif[j][k], newmotif);
      
      start[j][k]--;	//start position moves back by 1
    }
  }
  return;
}



double findlik(int w, double gam[NO_OF_BASES][MOTIFLENGTH], int D, int counts[DICT_SIZE], int countmat[DICT_SIZE][NO_OF_BASES][MOTIFLENGTH],int numwords){
  // computes log(Bayes Factor) for given motif alignment

  int    a,i,jj ;
  int   Mc[DICT_SIZE];
  double NBsum = 0.0,Bsum = 0.0,lBsum = 0.0,lNBsum = 0.0, NBMsum = 0.0,lNBMsum = 0.0,Bprevsum = 0.0,lBprevsum = 0.0,tmpMsum = 0.0,tmpgsum = 0.0, lMsum = 0.0,Msum = 0.0,gsum = 0.0,lgsum = 0.0,logL=0.0;

  for(a=0;a<D;a++){
    NBsum += counts[a+1] + beta[a]; 
      Bsum += beta[a];
    lNBsum += lgamma(counts[a+1]+beta[a]);
      lBsum += lgamma(beta[a]);
  }
  
  logL = lNBsum  - lgamma(NBsum) + lgamma(Bsum) - lBsum ;

  //  motifs part

  for(jj = 0; jj<numwords; jj++){ // each word matrix

   for(i=0; i<w; i++){
     tmpMsum = 0.0;
     tmpgsum = 0.0;

     for(a=0; a<NO_OF_BASES; a++){
      tmpMsum += countmat[jj][a][i] + gam[a][i];
      tmpgsum += gam[a][i];  
     }
           
      Msum += lgamma(tmpMsum);
      gsum += lgamma(tmpgsum);
      
     for(a=0; a<NO_OF_BASES; a++){
       
      lMsum += lgamma(countmat[jj][a][i] + gam[a][i]);
      lgsum += lgamma(gam[a][i]);
     }
   }
   
  }

  logL += lMsum + gsum - Msum - lgsum;
  
  return(logL);

}







double motifsig(int w, double gam[NO_OF_BASES][MOTIFLENGTH], int D, int counts[DICT_SIZE], int countmat[NO_OF_BASES][MOTIFLENGTH]){
  // computes log(Bayes Factor) for given motif alignment

  int    a,i ;
  int   Mc[DICT_SIZE];
  double NBsum = 0.0,Bsum = 0.0,lNBsum = 0.0, NBMsum = 0.0,lNBMsum = 0.0,Bprevsum = 0.0,tmpMsum = 0.0,tmpgsum = 0.0, lMsum = 0.0,Msum = 0.0,gsum = 0.0,lgsum = 0.0,lograt=0.0;


  for(a=0;a<D;a++){
    NBsum += counts[a+1] + beta[a]; 
      Bsum += beta[a];
    lNBsum += lgamma(counts[a+1]+beta[a]);
  }
  
  for(a=0;a<(D-1); a++) Mc[a] = 0;    	// also for words other than bases in dictionary

  for(a=0; a<NO_OF_BASES; a++){
      for(i=0; i<w; i++){
      Mc[a] += countmat[a][i];
      }
    }
   

  for(a=0;a<(D-1);a++){
    
    NBMsum += counts[a+1] + beta[a] + Mc[a];
    
    lNBMsum += lgamma(counts[a+1] + beta[a] + Mc[a]);
    Bprevsum += beta[a];
  }


  // new motif part

   for(i=0; i<w; i++){
     tmpMsum = 0.0;
     tmpgsum = 0.0;

     for(a=0; a<NO_OF_BASES; a++){
      tmpMsum += countmat[a][i] + gam[a][i];
      tmpgsum += gam[a][i];  
     }
           
      Msum += lgamma(tmpMsum);
      gsum += lgamma(tmpgsum);

     for(a=0; a<NO_OF_BASES; a++){
      lMsum += lgamma(countmat[a][i] + gam[a][i]);
      lgsum += lgamma(gam[a][i]);
     }
   }


  lograt = lNBsum - lNBMsum - lgamma(NBsum) + lgamma(NBMsum) + lgamma(Bsum) - lgamma(Bprevsum) - lgamma(beta[D - 1]);

  lograt += lMsum + gsum - Msum - lgsum;

  return(lograt);

}



double multmotifsig(int w, double gam[NO_OF_BASES][MOTIFLENGTH], int D, int counts[DICT_SIZE], int countmat[DICT_SIZE][NO_OF_BASES][MOTIFLENGTH],int numwords){
  // computes log(Bayes Factor) for given motif alignment

  int    a,i,jj ;
  int   Mc[DICT_SIZE];
  double NBsum = 0.0,Bsum = 0.0,lBsum = 0.0,lNBsum = 0.0, NBMsum = 0.0,lNBMsum = 0.0,Bprevsum = 0.0,lBprevsum = 0.0,tmpMsum = 0.0,tmpgsum = 0.0, lMsum = 0.0,Msum = 0.0,gsum = 0.0,lgsum = 0.0,lograt=0.0;


  for(a=0;a<D;a++){
    NBsum += counts[a+1] + beta[a]; 
      Bsum += beta[a];
    lNBsum += lgamma(counts[a+1]+beta[a]);
      lBsum += lgamma(beta[a]);
  }
  
  for(a=0;a<NO_OF_BASES; a++) Mc[a] = 0;    	// also for words other than bases in dictionary

for(jj = 0; jj<numwords; jj++){
  for(a=0; a<NO_OF_BASES; a++){
      for(i=0; i<w; i++){
      Mc[a] += countmat[jj][a][i];
      }
    }
} 


// for background only
 for(a=0;a<NO_OF_BASES;a++){
   NBMsum += counts[a+1] + beta[a] + Mc[a];
   lNBMsum += lgamma(counts[a+1] + beta[a] + Mc[a]);
   Bprevsum += beta[a];
   lBprevsum += lgamma(beta[a]);
  }

  lograt = lNBsum - lNBMsum - lgamma(NBsum) + lgamma(NBMsum) + lgamma(Bsum) - lgamma(Bprevsum) - lBsum + lBprevsum;


  // new motif part

  for(jj = 0; jj<numwords; jj++){ // each word matrix

   for(i=0; i<w; i++){
     tmpMsum = 0.0;
     tmpgsum = 0.0;

     for(a=0; a<NO_OF_BASES; a++){
      tmpMsum += countmat[jj][a][i] + gam[a][i];
      tmpgsum += gam[a][i];  
     }
           
      Msum += lgamma(tmpMsum);
      gsum += lgamma(tmpgsum);

      
      
     for(a=0; a<NO_OF_BASES; a++){
       
      lMsum += lgamma(countmat[jj][a][i] + gam[a][i]);
      lgsum += lgamma(gam[a][i]);
     }
   }
  }

  lograt += lMsum + gsum - Msum - lgsum;
  
  return(lograt);

}



double KLdistance(int matcount[NO_OF_BASES][MOTIFLENGTH], double probs[NO_OF_BASES], double gam[NO_OF_BASES][MOTIFLENGTH], int w, int MotifNum){

  int      a,i;
  double   info=0.0, thetaest[NO_OF_BASES][MOTIFLENGTH];

  for(i=0; i<w; i++){
    for(a=0;a<NO_OF_BASES; a++){
      thetaest[a][i] = (matcount[a][i] + gam[a][i])/(MotifNum + 1.0);   // prior gam rows sum to 1
      info += thetaest[a][i] * (log(thetaest[a][i]) - log(probs[a]));
	}}

  return(info);

}


double backobslik(double probs[NO_OF_BASES],char SEQ[NO_OF_SEQ][BIGSEQ], int seqL[NO_OF_SEQ], int SeqNum){
  int seqno,i,j,a;
  double backlik=0.0;

  for(seqno=0; seqno<SeqNum; seqno++){
    for(i = 1; i < (seqL[seqno]-1); i++){
      a = findindex(SEQ[seqno][i]) - 1;
      if(a >= 0) backlik += log(probs[a]);
    }
  }
  return(backlik);
}


void addmotifnode(motifnode *mylist, int newpos,char newmotif[MOTIFLENGTH]){   //adds a new starting position to the current list

  motifnode  *tmp;

  tmp = mylist;
  
  while(tmp->next != NULL){
    tmp = tmp->next;
  }

  tmp->next = (motifnode*)malloc(sizeof(motifnode));
  tmp = tmp->next;
  tmp->position = newpos;
  strcpy(tmp->motif,newmotif);
  tmp->next = NULL;
  return;
}



motifnode *copymotifs(int pos[MOTIF_COUNT], char newmotif[MOTIF_COUNT][MOTIFLENGTH],int total){

  int   i;
  motifnode  *newlist;

  if(total == 0){
    newlist = NULL;
    return newlist;
  }

  newlist = (motifnode*)malloc(sizeof(motifnode));
  newlist->position = pos[0];
  strcpy(newlist->motif,newmotif[0]);
  newlist->next = NULL;
  
  for(i = 1; i < total; i++){   
    addmotifnode(newlist,pos[i],newmotif[i]);
  }

  return newlist;
}



void printmotifnode(motifnode *mylist,int seqno, FILE *fp, char SEQ[BIGSEQ]){
  // needs to be changed to accommodate gaps
  motifnode *tmp;
  char  tmpstr[MOTIFLENGTH];

  tmp = mylist;
  if(tmp==NULL) return;

  while(tmp != NULL){   
    fprintf(fp,"%d\t %d\t %s\n",seqno+1,tmp->position,tmp->motif);   
    tmp = tmp->next;
  }

  return;
}




/// for gap ///



double findlikSINGLE(int matcount[NO_OF_BASES][MOTIFLENGTH], int count[NO_OF_BASES], double bb[NO_OF_BASES], int sumcount, int Nmotifs, double gam[NO_OF_BASES][MOTIFLENGTH]){

int     D = dict_length - 1, i, a;
  double  tm1= 0.0,tm2= 0.0,sumlog1= 0.0, sumlog2 = 0.0, sumlb = 0.0,sumb = 0.0, logL = 0.0, sumg = 0.0;
  char yes;


  for(a = 1 ; a < dict_length ; a++){ 

    tm1 += count[a] + bb[a-1];
    sumlog1 += lgamma(count[a] + bb[a-1]);

    sumlb +=  lgamma(bb[a-1]);
    sumb +=  bb[a-1];
  }
  
  logL += sumlog1 - lgamma(tm1)+ lgamma(sumb) - sumlb; // 

   sumlb = 0.0;
 
  for(i=0; i<width; i++){
     tm2= 0.0;tm1= 0.0;
    for(a = 0 ; a < NO_OF_BASES; a++){

      tm2 += matcount[a][i] + gam[a][0];
      tm1 += gam[a][0];
      
      sumlog2 += lgamma(matcount[a][i] + gam[a][0]);
      sumlb += lgamma(gam[a][0]);
    }

    logL -= lgamma(tm2);
    logL += lgamma(tm1);
  }
 
  logL += sumlog2 - sumlb; // 

  return(logL);




}




int maxposition(int array[NO_OF_SEQ][MOTIF_COUNT],int n[NO_OF_SEQ],int totseq){
  // returns maximum of a two dimensional array

int 	i,j,maxindex=0;
double 	max;

 for(i=0; i < totseq; i++){
   if(n[i]>0) {  // at least one motif here
     max = array[i][0];
     break;
   }
   }


for(i=0; i<totseq; i++){
  for(j=0; j<n[i];j++){
	if(array[i][j]>max) {max = array[i][j];
			  maxindex = i;}
  }}
return(max);
}



int minposition(int array[NO_OF_SEQ][MOTIF_COUNT],int n[NO_OF_SEQ],int totseq){
  // returns  minimum of a two dimensional array

int 	i,j,minindex=0;
double 	min;

for(i=0; i < totseq; i++){
   if(n[i]>0) {  // at least one motif here
     min = array[i][0];
     break;
   }
   }

for(i=0; i<totseq; i++){
  for(j=0; j<n[i];j++){
	if(array[i][j]<min) {min = array[i][j];
			  minindex = i;}
  }}
return(min);
 
}



void motifplusBF(char motif[NO_OF_SEQ][MOTIF_COUNT][MOTIFLENGTH], char SEQ[NO_OF_SEQ][BIGSEQ], int end[NO_OF_SEQ][MOTIF_COUNT],int start[NO_OF_SEQ][MOTIF_COUNT],int oldcounts[NO_OF_BASES+2]){
  // shifts motif ahead by 1

  int	olda,newa,i, n = width, j, k, oldcol[NO_OF_BASES]={0,0,0,0},newcol[NO_OF_BASES]={0,0,0,0};
  char	newmotif[MOTIFLENGTH];

  for(j = 0 ; j < no_of_seq; j++){
    for(k = 0 ; k < no_chosen[j]; k++){
            
      for(i = 1; i < n; i++)
	newmotif[i-1] = motif[j][k][i];

      start[j][k]++;	//start position moves ahead by 1
      newmotif[n-1] = SEQ[j][start[j][k]+width-1];
      newmotif[n] = '\0';
 
      olda = findindex(motif[j][k][0])-1;	//now in background
      if(olda >= 0) oldcol[olda]++;
      
      newa = findindex(newmotif[n-1])-1;	// now in motif
      if(newa >= 0) newcol[newa]++;
      
      strcpy(motif[j][k], newmotif);
    }
  }

  // adjust counts

  //old

  for(i=0; i<NO_OF_BASES;i++){
    oldcounts[i+1] = oldcounts[i+1] - newcol[i] + oldcol[i];
  }

  return;
}


void motifminusBF(char motif[NO_OF_SEQ][MOTIF_COUNT][MOTIFLENGTH], char SEQ[NO_OF_SEQ][BIGSEQ], int start[NO_OF_SEQ][MOTIF_COUNT],int oldcounts[NO_OF_BASES+2]){
 // shifts motif back by 1

int	olda,newa,i, n = width, j, k, oldcol[NO_OF_BASES]={0,0,0,0},newcol[NO_OF_BASES]={0,0,0,0};
  char	newmotif[MOTIFLENGTH];

  for(j = 0 ; j < no_of_seq; j++){
    for(k = 0 ; k < no_chosen[j]; k++){
    
      newmotif[0] = SEQ[j][start[j][k]-1];

      for(i = 0; i < n-1; i++)
	newmotif[i+1] = motif[j][k][i];
 
      newmotif[n] = '\0';
  
      olda = findindex(motif[j][k][n-1])-1;	//now in background
      if(olda >= 0) oldcol[olda]++;
      newa = findindex(newmotif[0])-1;	// now in motif
      if(newa >= 0) newcol[newa]++;
   
      strcpy(motif[j][k], newmotif);
      
      start[j][k]--;	//start position moves back by 1
    }
  }

 // adjust counts

  //old

  for(i=0; i<NO_OF_BASES;i++){
    oldcounts[i+1] = oldcounts[i+1] - newcol[i] + oldcol[i];
  }

  return;
}






/// BAYES FACTOR CALC. ////



node *addnewnode(node *mylist, int newpos){   //adds a new starting position to the current list

  node  *tmp;

  if(mylist == NULL){ // create new node
    mylist = (node*)malloc(sizeof(node)); 
    mylist->position = newpos;
    mylist->next = NULL;
    return(mylist);
  }


  tmp = mylist;
  
  while(tmp->next != NULL){
    tmp = tmp->next;
  }

  
  tmp->next = (node*)malloc(sizeof(node));
  tmp = tmp->next;
  tmp->position = newpos;
  tmp->next = NULL;
  

  return(mylist);
}

node *rmnode(node *mylist, int newpos){   //removes a starting position from the current list

  node  *tmp, *p;
  char  yes;

  if(mylist->position == newpos){ // at front
    
    if(mylist->next ==NULL){
      free(mylist);
      return NULL;
    }

    p = mylist->next;
    free(mylist);
    mylist = p;
    
    return(mylist);
   
  }
  
  tmp = mylist;
  while(tmp->next != NULL){
    
    if(tmp->next->position == newpos){
       
	 p = tmp->next->next;
	 free(tmp->next);
	 tmp->next = p;
       	 return(mylist);
    }
	 tmp = tmp->next;
  }
  printf("error- wrong node!");

  printf("\n continue? ");
  fflush(stdin);
  scanf("%c", &yes);
  if(yes == 'n') exit(0);
  
  return(NULL);
}





int findmatch(int pos, node *mylist, int w){
  // returns 1 if no overlap with motif, 2 if exact match with motif start, 0 if partial overlap

  int i,j,end,matchflag;
  node  *tmp;
  

  tmp = mylist;

  if(tmp==NULL){
    printf("number=0\n");
    return 1;
  }
  
  end = pos + w - 1; 
  
  while(tmp != NULL){

     i = tmp->position;
     j = i + w - 1;   
     
     if((end>=i)&&(end<j)){
       // overlaps!!
       return(0);
     }
     if(pos==i) return(2);     // is a CURRENT start position 


     if(tmp->next != NULL) tmp = tmp->next;
     else return(1);
  }

  return(1);

}



double p1theta(int w, int D, int counts[DICT_SIZE], int countmat[NO_OF_BASES][MOTIFLENGTH], double rho[DICT_SIZE], double theta[NO_OF_BASES][MOTIFLENGTH]){
  // calculates log(probability of an alignment under a given theta) 

  int	 a,i;
  double basepart = 0.0, motifpart=0.0;

  for(a=0;a<D;a++){
    basepart += counts[a+1]*log(rho[a]);
  }
  
  for(a=0; a<NO_OF_BASES; a++){
      for(i=0; i<w; i++){
	if((theta[a][i]>0)&&(countmat[a][i]>0)){
	  motifpart += countmat[a][i]*log(theta[a][i]);
	  }
	else if(countmat[a][i]>0){
	  motifpart = -1.0/0;
	}
      }
  }

  return(basepart+motifpart);
}







double C2back(int w, double gam[NO_OF_BASES][MOTIFLENGTH], int D, int counts[DICT_SIZE], int countmat[NO_OF_BASES][MOTIFLENGTH]){
  // computes log(Bayes Factor) for given motif alignment

  int    a,i ;
  int   Mc[DICT_SIZE];
  double NBsum = 0.0,Bsum = 0.0,lNBsum = 0.0, NBMsum = 0.0,lNBMsum = 0.0,Bprevsum = 0.0,lBprevsum = 0.0,tmpMsum = 0.0,tmpgsum = 0.0, lMsum = 0.0,Msum = 0.0,gsum = 0.0,lgsum = 0.0,lograt=0.0;


  for(a=0;a<D;a++){
    NBsum += counts[a+1] + beta[a]; 
      Bsum += beta[a];
    lNBsum += lgamma(counts[a+1]+beta[a]);
  }
  
  for(a=0;a<(D-1); a++) Mc[a] = 0;    	// also for words other than bases in dictionary

  for(a=0; a<NO_OF_BASES; a++){
      for(i=0; i<w; i++){
      Mc[a] += countmat[a][i];
      }
    }
   

  for(a=0;a<(D-1);a++){
    
    NBMsum += counts[a+1] + beta[a] + Mc[a];
    
    lNBMsum += lgamma(counts[a+1] + beta[a] + Mc[a]);
    Bprevsum += beta[a];
    lBprevsum += lgamma(beta[a]);
  }

  lograt =  lNBMsum - lgamma(NBMsum) + lgamma(Bprevsum) -  lBprevsum; 

  return(lograt);
}



void setmatzero(int mat[MOTIFLENGTH][NO_OF_BASES]){
  int i,j;

    for(i = 0; i < width; i++){
     for(j = 0; j < NO_OF_BASES; j++){
       mat[i][j] = 0;
     }
     }
    return;
}


void setveczero(int vec[DICT_SIZE], int n){
  int i;
  
 for(i = 0; i < n; i++){
   vec[i] = 0;
 }
 return;
}



double ratback(int w, int seq, int basecount[NO_OF_SEQ][NO_OF_BASES]){
  // computes log(Bayes Factor) for given motif alignment

  int    a,i,D=NO_OF_BASES ;
  int   Mc[DICT_SIZE],counts[D];
  double NBsum = 0.0,Bsum = 0.0,lNBsum = 0.0, NBMsum = 0.0,lNBMsum = 0.0,Bprevsum = 0.0,lBprevsum = 0.0,tmpMsum = 0.0,tmpgsum = 0.0, lMsum = 0.0,Msum = 0.0,gsum = 0.0,lgsum = 0.0,lograt=0.0, Nsum = 0.0, lNsum =0.0,tmpbeta[D];


  for(a=0;a<D;a++){
    tmpbeta[a] = beta[a] + beta[D+1]/4.0;
  }

  for(a=0;a<D;a++){
    counts[a] = dict[a+1].repeat;
    NBsum += counts[a] + tmpbeta[a]; 
    Bsum += tmpbeta[a];
    Nsum += counts[a];
    lNsum += lgamma(counts[a] + 1.0);
    lNBsum += lgamma(counts[a]+tmpbeta[a]);
    lBprevsum += lgamma(tmpbeta[a]);
  }
  

  lograt =  lNBsum - lgamma(NBsum) + lgamma(Bsum) -  lBprevsum + lgamma (Nsum + 1.0) -lNsum; 


  NBsum = 0.0;Bsum = 0.0;lNBsum = 0.0; NBMsum = 0.0;lNBMsum = 0.0;Bprevsum = 0.0;tmpMsum = 0.0;tmpgsum = 0.0; lMsum = 0.0;Msum = 0.0;gsum = 0.0;lgsum = 0.0;Nsum = 0.0; lNsum =0.0;
 lBprevsum = 0.0;

  for(a=0;a<D;a++){
    counts[a] -= basecount[seq][a];
  }

  for(a=0;a<D;a++){
    NBsum += counts[a] + tmpbeta[a]; 
    Bsum += tmpbeta[a];
    Nsum += counts[a];
    lNsum += lgamma(counts[a] + 1.0);
    lNBsum += lgamma(counts[a]+tmpbeta[a]);
    lBprevsum += lgamma(tmpbeta[a]);
  }
  

  lograt -= (lNBsum - lgamma(NBsum) + lgamma(Bsum) -  lBprevsum + lgamma (Nsum + 1.0) -lNsum);


return(lograt);		// log of f(y)/f(y(r)) for background

}



void runBF(){

  unsigned int   dum,SEED;  

  int 	       thisiter=0, i,j,jj,a,reqd, k,nw, l, L[NO_OF_SEQ],word_length,iter,N,flag1,seqno,sum_L=0,total_chosen,gw, start_position[NO_OF_SEQ][MOTIF_COUNT],end_position[NO_OF_SEQ][MOTIF_COUNT], gapindices[MOTIFLENGTH], it=0,wordmax, count[DICT_SIZE],ind[MOTIFLENGTH],sel,A, matcount[NO_OF_BASES][MOTIFLENGTH],sumcount=0,searchmotifs=0,del, num, iter50, flag, div, Tcount[NO_OF_BASES][NO_OF_BASES], MC=0, totBase=0, NoDimer=0, dimer=0,  equi, totdimer=0, numMotifs, n_in, N_in, run, setno, index[BIGSEQ],wordcount[BIGSEQ][dict_length], NoTruemotifs=0,TrueMatCount[NO_OF_BASES][MOTIFLENGTH], WordFound = 0,noadded, truebaseseqcount[NO_OF_SEQ][NO_OF_BASES],oldmatcount[NO_OF_BASES][MOTIFLENGTH],selcomp,finalmotifcount, FB,numcomp; 

  double 	f[BIGSEQ], lnS[BIGSEQ], T1, T2,T3, maxT ,pa[MOTIFLENGTH],count1[MOTIFLENGTH][NO_OF_BASES],probs[MOTIFLENGTH][NO_OF_BASES],localmat[NO_OF_BASES][MOTIFLENGTH],dictcount[MOTIFLENGTH],dictprobs[MOTIFLENGTH],obslik, b[DICT_SIZE][NO_OF_BASES][MOTIFLENGTH],startprob,normsum=0.0, SEGMENT_PROB[BIGSEQ],choose, rannum, expscore, Zscore[NO_OF_BASES][NO_OF_BASES], tmpT[NO_OF_BASES], tmpD[NO_OF_BASES], fracN, info=0.0, motifscore =0.0, prob[dict_length], trueinfo = 0.0, normprob, nprob[NO_OF_BASES],TrueMatProb[NO_OF_BASES][MOTIFLENGTH], diffprob, normprobfinal=0.0,a0, b0, T0,t0[DICT_SIZE], T0min, C1[HILL+1],BFIS,BFRIS,BFN=0.0,BFM, BFMarg, C1mode,postlik, alignprob,oldC2, CPO[NO_OF_SEQ], backf[NO_OF_SEQ] ,bdgeG1,bdgeG2,bdgecons1, bdgecons2,bdgeO1=0.0, bdgeO2=0.0,bdgeOPT=0.0, bdgeCON, cons1, cons2,G1, G2, bdgeG, thetaplus[NO_OF_BASES][MOTIFLENGTH], thetatrue[NO_OF_BASES][MOTIFLENGTH],thetaminus[NO_OF_BASES][MOTIFLENGTH], smtheta[NUMMIX][NO_OF_BASES][MOTIFLENGTH],tmprow[NO_OF_BASES],u, smthfac, complik[NUMMIX], lp[NUMMIX], sumbf,lptot=0.0,annpostlik=0.0, pcomp[NUMMIX] ,trueR =  3046.697  ;

  char 	        str1[BIGSEQ],str2[BIGSEQ],str3[MOTIFLENGTH],S[NO_OF_SEQ][BIGSEQ],S1[NO_OF_SEQ][BIGSEQ],lastword[MOTIFLENGTH],newstr[MOTIFLENGTH],comm[COMMENT_LENGTH], updateMotif[MOTIFLENGTH], selwords[TOTLENGTH],tempword[MOTIFLENGTH],choseword[NO_OF_SEQ][MOTIF_COUNT][MOTIFLENGTH],chosenmotif[NO_OF_SEQ][MOTIF_COUNT][MOTIFLENGTH],newword[MOTIFLENGTH],newS[NO_OF_SEQ][BIGSEQ],yes, rof, finalword[MOTIFLENGTH], truemotif[MOTIFLENGTH], tmpstr[MOTIFLENGTH];

 char	        filename[15],string1[10],file1[20],  names[NO_OF_SEQ], rowname[20];
 char           resfiles[MAXRUNS+2][10], outfile[15], outfiles[NoOfSets+2][20];
 node		*tmpnode;
 vect           *tmpvect; 
 table		*freqtable, *tmptab;
 FILE	        *f1,*f2, *inputfile, *tmp1, *buf, *out, *in,*fin, *tmpfile, *likfile; // *f2
  
 
 dict_length = 6;
 for(a = 1; a < dict_length-1; a++){
	strcpy(dict[a].name,word_list[a-1]);
	}

 fflush(stdin);
 scanf("%s",file1);

 fflush(stdin);
 scanf("%s",outfile);
 tmpfile = fopen(outfile,"w");

 fflush(stdin);
 scanf("%d", &SEED);
 srand(SEED);

 scanf("%d",&width);

 run = 1;

// read inputs

 
 setno = 0;

  //initialise everything

  WordFound = 0;
  sum_L=0;it=0;sumcount=0;MC=0; totBase=0; NoDimer=0; dimer=0;totdimer=0;info=0.0;motifscore =0.0;

  searchmotifs = 0;

   inputfile = fopen(file1,"r");


   buf = fopen("buf.out","w");
   no_of_seq = ReadSeq(inputfile, buf, newS, L);   //  read sequences in fasta format

   forwardno = no_of_seq;		// number of forward strands
  
   for(i = 0;i < no_of_seq; i++){
     strUpr(newS[i],S[i]);
     L[i] = strlen(S[i]);
     totBase += L[i];
     totdimer += L[i] - 1;
     CPO[i] = 0.0;
   }

   gaplength = 0;

   reqd = 1;
   gw = gaplength + width;

   strcpy(tempword,"X");

 for(i = 0;i < width-1; i++) strcat(tempword,"X");

 strcpy(word_list[dict_length-2],tempword);
 

 // parameters

 div = 10;
 equi = 2; 
 fracN = 0.10; 

 fflush(stdin);
 scanf("%d", &i);
 motifPC = i/1000.0;

 fflush(stdin);
 scanf("%d", &MC); 
 
 fflush(stdin);
 scanf("%d", &FB); 

 fflush(stdin);
 scanf("%d", &MAXITER);

 fflush(stdin);
 scanf("%d", &numcomp);


 fprintf(tmpfile,"\n sdBFmix -i %s -o %s -S %d -w %d -p %d  -d %d -r %d -I %d -M %d\n",file1,outfile,SEED,width,(int)(motifPC*1000),MC,FB,MAXITER,numcomp);

 if(FB == 1){			//include backward strand also
   
   for(i = 0;i < no_of_seq; i++){
     strcpy(str1, S[i]);
     TakeComplement(str1, str2);
     strcpy(S[i+no_of_seq],str2);
   }

   no_of_seq +=  no_of_seq;		// doubles the number of input sequences

   for(i = 0; i < no_of_seq; i++){
      L[i] = strlen(S[i]);
   }
 }


 sum_L=0;

 for(k = 0; k < no_of_seq; k++){
   sum_L += L[k];
   L[k]++;    /* L is now L+1 */
   S1[k][0] = '*';
 
   for(i=1; i<L[k]; i++)   S1[k][i] = S[k][i-1];
 }

 
  for(a = 1; a < dict_length; a++){
    strcpy(dict[a].name,word_list[a-1]);
    dict[a].coeff = 0.0;
    dict[a].repeat = 0;
    word_size[a] = strlen(dict[a].name);
    // printf("\n dict word[%d] :: %s",a, dict[a].name);
	}

  motifIndex = SizeDict - 1;

/* finding max length of the word */

  wordmax = word_size[1];

for(a=2; a<dict_length; a++){
	if(word_size[a] > wordmax) wordmax = word_size[a];
}

 max_length = wordmax;		      


for(seqno=0; seqno<no_of_seq; seqno++){
    for(a=0; a<NO_OF_BASES;a++){
     truebaseseqcount[seqno][a]=0;
    }
  }



/* finding no. of repeats */

  for(a=1; a<dict_length-1; a++){
     word_length = strlen(dict[a].name);

      for(k=0;k<no_of_seq;k++){	

	for(i=0; i<L[k]-word_length; i++){
		setString(i, i+word_length-1, S[k],str1);
		
	if(strcmp(str1,dict[a].name) == 0) {
		dict[a].repeat++;
		truebaseseqcount[k][a-1]++;
		}	
	}	

	}

	} /*end a*/


 normsum=0.0;
 for(a=1; a<dict_length-1; a++){
   normsum += dict[a].repeat;
 }


 normsum/= (float)NO_OF_BASES;
 normsum*= fracN;		// ave. of betas for bases

 for(a = 1; a < dict_length-1; a++) {
   beta[a-1] = (float)dict[a].repeat*fracN;     // pseudocounts to fix the prior
 }
 beta[dict_length-2] = motifPC*normsum ;     //in proportion to prior parameters of bases

 a0 =  beta[dict_length-2];
 b0 = 0.0;

 for(a = 0; a < dict_length-2; a++){
   b0 += beta[a];
 }

 dict[dict_length-1].repeat = 0;

 for(a=1; a<dict_length; a++){
   dictcount[a-1] = dict[a].repeat+beta[a-1];
 }

 
 rDirich(dict_length-1, dictcount, dictprobs);
 
 for(a=1; a<dict_length; a++){
   dict[a].prob = dictprobs[a-1];   
   dictprobs[a-1] =  (float)dict[a].repeat/sum_L ;    // proportion of occurrence of bases
}
 
 startprob=.25;

 if(equi == 1){

 

 for(i=0; i<NO_OF_BASES; i++){

   for(j=0; j<max_length; j++){
	dict[dict_length-1].probmat[i][j] = startprob;
	b[dict_length-1][i][j] = startprob;
   }
 }
  
 }

 else{  // matrix based on background

   for(j=0; j<max_length; j++){

     for(i=0; i<NO_OF_BASES; i++){
  	  b[dict_length-1][i][j] = dictprobs[i];
	  dict[dict_length-1].probmat[i][j] = startprob; //dictprobs[i]
     }
   }
   
 }


if(MC == 1){ // finding number of repeats of 2-mers
  
  dimer = 1;

  
   for(j = 0; j < NO_OF_BASES; j++){
     for(k = 0; k < NO_OF_BASES; k++){
       Tcount[j][k] = 0;
     }
   }
 
   for(seqno = 0; seqno < no_of_seq; seqno++){
     
     for(i = 1; i < (L[k]-1) ; i++){
        j = findindex(S1[seqno][i]);		// index- from 1 to 4
	k = findindex(S1[seqno][i+1]);
	
	if((j>0)&&(k>0)) Tcount[j-1][k-1]++;
     }
   }

  


 // Setting up the Markov transition matrix

   for(i = 0; i < NO_OF_BASES; i++){

     for(j = 0; j < NO_OF_BASES; j++)   tmpD[j] = 1.0*Tcount[i][j];
   
     rDirich(NO_OF_BASES, tmpD, tmpT);
   
     for(j = 0; j < NO_OF_BASES; j++)   T[i+1][j+1] = tmpT[j];
   }

 
   //  Finding significant dimers


    for(j = 0; j < NO_OF_BASES; j++){
     for(k = 0; k < NO_OF_BASES; k++){
       expscore = totdimer*dictprobs[j]*dictprobs[k];
       Zscore[j][k] = (Tcount[j][k] - expscore)/sqrt(expscore);
     }
   }

   // Adding "significant" dimers to the dictionary

   jj = dict_length; 
    NoDimer = 0;
    for(seqno = 0; seqno < no_of_seq; seqno++){
      NoDimer += L[seqno]-2;
    }

   flag1 = 0;

   for(j = 1; j <= NO_OF_BASES; j++){
     for(k = 1; k <= NO_OF_BASES; k++){
       
       if(Zscore[j-1][k-1] > zCutOff){ 
	 //add dimer to dictionary - occurs more than expected

	 setString(0,0,base[j-1],str1);
	 strcat(str1,base[k-1]);
	 strcpy(dict[jj].name,str1);
	 dict[jj].coeff = 0.0;
	
	 dict[jj].repeat = Tcount[j-1][k-1];
	 word_size[jj] = strlen(dict[jj].name);
	 strcpy(word_list[jj-1], dict[jj].name);
	 beta[jj-1] = fracN*Tcount[j-1][k-1]; 
	 dictcount[jj-1] = Tcount[j-1][k-1] + beta[jj-1] ;
	 jj++;
	 
       }
  

     }
   }
  
   // should draw from Dirichlet too??

   dict_length = jj;
   
   rDirich(dict_length-1, dictcount, dictprobs);

   for(a=1; a<dict_length; a++){
     dict[a].prob = dictprobs[a-1];   
   }
 }
 
 
    // PART 1: Sampling for words given current update of stochastic word matrix

 while(searchmotifs<reqd){


   //initialize start position vector 

   for(seqno = 0; seqno < no_of_seq; seqno++){
     startvec[seqno] = (node*)malloc(sizeof(node));
     startvec[seqno]->position = 0;
     startvec[seqno]->next = NULL;
   }

  
   if(dict_length > 6){ // dict. length > 6, update beta vector
    
     beta[dict_length-2] = motifPC*normsum ;     //in proportion to prior parameters of bases

     a0 =  beta[dict_length-2];
     b0 = 0.0;
     
     for(a = 0; a < dict_length-2; a++)  b0 += beta[a];
     dict[dict_length-1].repeat = 0;
     
     for(a=1; a<dict_length; a++)  dictcount[a-1] = dict[a].repeat+beta[a-1];
     rDirich(dict_length-1, dictcount, dictprobs);
     
     for(a=1; a<dict_length; a++){
       dict[a].prob = dictprobs[a-1];   
     }
     

    // new theta matrix

     for(j=0; j<max_length; j++){
       for(i=0; i<NO_OF_BASES; i++){
	 b[dict_length-1][i][j] = dictprobs[i];
	 dict[dict_length-1].probmat[i][j] = dictprobs[i];
       }
     }
   }// dict > 6
   
   iter=0; flag1=0;
   
   storemat.maxloglik = maxneg;
   storemat.maxpostlik = maxneg;
   storemat.maxobslik = maxneg;
   storemat.signif = maxneg;


   for(seqno = 0; seqno < no_of_seq; seqno++){
     backf[seqno] = ratback(width,seqno,truebaseseqcount);
   }

   flag1=0; iter=0;

   while(flag1 == 0){
     iter++;
     
     thisiter=0;
     for(seqno = 0; seqno < no_of_seq; seqno++) no_chosen[seqno]=0;
      
     obslik=0.0;
     
     /* Given p, draw A */
     
     for(i=0; i<NO_OF_BASES; i++){
       for(j=0; j<max_length; j++){
	 matcount[i][j] = 0;
       }}
     
     for(a=1; a<dict_length; a++) count[a] = 0;
     
     /* finding f */
     
     for(seqno = 0; seqno < no_of_seq; seqno++){   
 

       setveczero(seqbasecount[seqno],NO_OF_BASES+1);		// individual sequence base counts
       setmatzero(seqmotifmat[seqno]);



       setString(1,1,S1[seqno],str1);
       
       for(k = 1; k < L[seqno]; k++) SEGMENT_PROB[k] = 0.0;
       
       lnS[0] = 0.0;
       lnS[1] = log(prob_back(str1[0]));
       
       k=2;
       
         
       while(k < L[seqno]){		// FORWARD SUMMATION
	 
	 
	 lnS[k] = 0.0;
	 
	 // two components of prob
	 
	 T1 = lnS[k-1] + log(prob_back(S1[seqno][k]));


	 if( log(prob_back(S1[seqno][k]))  < -1e10  ){
	   printf("\n\n %c  fileread error : continue? ",S1[seqno][k]);
	    fflush(stdin);
	    scanf("%c", &yes); 
	    if(yes == 'n') exit(0);
	    fflush(stdin);
	    scanf("%c", &yes);
	    if(yes == 'n') exit(0);
	 }
	 setString(k-1, k, S1[seqno], str1);   //dimer string 

	 T0 = 0.0;
	 
	 
	 if( (k < L[seqno])&&(k >= gw) ){ // k > gw 
	   

	   if(dict_length > 6){   // one motif already in dictionary

		     
	     for(a = (NO_OF_BASES+1); a < (dict_length - 1); a++){
	       setString(k-gw+1,k,S1[seqno],tmpstr);
	       t0[a] = lnS[k-gw]+logProb(tmpstr,a);
	     }
	     
	     }
	   

	   setString(k-gw+1,k, S1[seqno], tmpstr);
	   SEGMENT_PROB[k-gw+1] = exp(logProb(tmpstr, motifIndex)) ;
	   T2 = lnS[k-gw] + logProb(tmpstr, motifIndex); 
	 
	   if((dimer == 1)&&(dimerProb(str1) == 1)){ // 3 components to sample from
	     
	     T3 = lnS[k-2] + log(newprob);   //prob of dimer str1
	     maxT = min(T1,T2);
	     maxT = min(maxT,T3);
	    
	     if(dict_length > 6){

	       for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){ 
		 maxT = min(maxT,t0[a]);
	       }
	       for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){
		 T0 += exp(t0[a] - maxT);
	       }
	       
	       lnS[k] = log( T0 + exp(T1 - maxT) + exp(T2 - maxT) + exp(T3 - maxT) ) + maxT;
	     
	     
	     }
	   }
	   
	   else{ // no dimers or insignificant dimer

	      if(dict_length > 6){
	
		maxT =  min(T1, T2);  
	
		for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){ 
		 maxT = min(maxT,t0[a]);
		}
		for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){
		  T0 += exp(t0[a] - maxT);
		}
  
		lnS[k] = log(T0  + exp(T1 - maxT) + exp(T2 - maxT)) + maxT; 
		
	      }
	      else{

		
		maxT =  min(T1, T2);    
		lnS[k] = log( exp(T1 - maxT) + exp(T2 - maxT)) + maxT ;
	      }
	     
	   }
	    setString(k-gw+1, k,S1[seqno],str2);

	 }
	 
	 else{   // only base or dimer
	   
	   if((dimer == 1)&&(dimerProb(str1) == 1)){ // has dimer
	     T3 = lnS[k-2] + log(newprob);
	     maxT = min(T1,T3);
	     lnS[k] = log( exp(T1 - maxT) + exp(T3 - maxT)) + maxT ;
	     
	   }
	   
	   else{ 
	     lnS[k] = T1 ;      // no dimer, only base
	   }
	 }
	
	 k++;
	 if(k == L[seqno]) break;
       }
       
       obslik += lnS[L[seqno]-1];
       
/* Backward Sampling */



 k=L[seqno]-1;
 
 while(k >= 1){

	// for base

		nw = 1;
	
       		setString(k,k,S1[seqno],str1);
	
		for(a = 1; a <= NO_OF_BASES; a++){
				if(strcmp(str1, dict[a].name)==0) {
				  pa[nw] =  lnS[k-1] + log(dict[a].prob);    // log prob of being a base
				  ind[nw] = a;
				
				} 
		}
		
	 
		// for motif

		if(k >= gw){		  
			nw++;
		       	pa[nw] = lnS[k-gw] + log(SEGMENT_PROB[k-gw+1]);  /* based on current update of parameter */
		
   			ind[nw] = motifIndex;			
			
			setString(k-gw+1,k,S1[seqno],str2);
	

			if(dict_length > 6){  //old  word

			  for(a = (NO_OF_BASES+1); a < (dict_length-1); a++)
			    {
			      nw++;
			      setString(k-gw+1,k,S1[seqno],tmpstr);
			      pa[nw] = lnS[k-gw] + logProb(tmpstr,a);
			    }
			}
		} // end k >= gw


		// dimer may be present

		if((dimer == 1) && (k >= 2)){
		  
		  setString(k-1, k, S1[seqno], str1);
		  
		  if(dimerProb(str1) == 1){		    
		    nw++;
		    pa[nw] = lnS[k-2] + log(newprob);   
		    ind[nw] = wordind;
		  }
		}
	     
		
		if(nw > 1){ // general- sampling for word
		    for(a = 1; a < nw ; a++){
		      pa[a] = exp(pa[a] - pa[nw]);
		    }

		    pa[nw] = 1.0;
		    sel = sample(pa,nw);
		    A = ind[sel];
		
	
		}

		  else A = ind[nw];
	       
		
	if(A != motifIndex){ /* base or dimer */
	    count[A]++;		
	    strcpy(lastword,str1);
	    seqbasecount[seqno][A-1]++;
	}

	
	else {	 

	  count[A]++;
	  seqbasecount[seqno][A-1]++;

	  total_chosen = no_chosen[seqno];  
	  jj = k - gw + 1;

	  
	start_position[seqno][total_chosen] = FindGaps(jj, S1[seqno],motifIndex, gapindices);
				// now don't penalise for gaps at end
	if((dict_length > 6)&&(start_position[seqno][total_chosen] < 0))
	  {
	    printf("%d (%d)- %d   ",jj,start_position[seqno][total_chosen],A);
	     // stop point
	    printf("\n\n continue? ");
	    fflush(stdin);
	    scanf("%c", &yes); 
	    if(yes == 'n') exit(0);
	    fflush(stdin);
	    scanf("%c", &yes);
	    if(yes == 'n') exit(0);
	  }

	end_position[seqno][total_chosen] = start_position[seqno][total_chosen] + width - 1;

	strcpy(lastword,str2);	// this is motif with gaps

	setMotif(str2,updateMotif,gapindices); //finds positions for the motif
	
	setWithGaps(selwords,str2, gapindices); // motif with gaps that is chosen
	strcpy(choseword[seqno][total_chosen],selwords);
	
	strcpy(chosenmotif[seqno][total_chosen],updateMotif);

       	no_chosen[seqno]++;
	}
		
	k -= strlen(lastword); 	 
      
	} /* end k */
  

}/* end seqno */

  

     for(i=0; i<width; i++){
       for(a=0; a<NO_OF_BASES; a++){
	 oldmatcount[a][i]=0;
       }}


     for(seqno = 0; seqno < no_of_seq; seqno++){
	  for(k = 0; k < no_chosen[seqno]; k++){
	 	    
	    for(i=0; i<width; i++){
	    setString(i,i,chosenmotif[seqno][k], str2);

	    for(a=0; a<NO_OF_BASES; a++){
	      if(strcmp(str2,dict[a+1].name)==0) {
		oldmatcount[a][i]++;
	      }
	    }
	    }	    
	  }}
     
  

  //Metropolis if iter > METRO and every 10th step

  if((iter > METRO) && (iter%10 == 0) && (count[motifIndex]>0) &&(iter <= (MAXITER-100))){  //Metropolis
    
    if((rannum=rand()/M1) < 0.5) del = 1; else del = -1;

    if(del == 1){ // check whether shift one ahead

      choose = colratio(start_position, end_position,1,S1 );	// comparison of column after end with first column 
      //calculates ratio of gamma functions for specified columns


      if(choose > 1){ // move ahead  
	  motifplusBF(chosenmotif,S1,end_position,start_position,count);
      }

      else if((rannum=rand()/M1) < (choose/(1+choose))) {	
		motifplusBF(chosenmotif,S1,end_position,start_position,count); 
      }
    }

    else if (del == -1){
      choose = colratio(end_position, start_position,-1,S1 );	// comparison of column before start with last column

      if(choose > 1){ // move back
	motifminusBF(chosenmotif,S1,start_position,count);
      }

      else if((rannum=rand()/M1) < (choose/(1+choose)) ){ 	
		motifminusBF(chosenmotif,S1,start_position,count); 
      }
    }

   
  }	// end of Metropolis

  ////////    annealing metropolis

  if((iter > (MAXITER-1000)) && (iter%5 == 0) && (count[motifIndex]>0)){  //Metropolis annealing

    if((rannum=rand()/M1) < 0.5) del = 1; else del = -1;


    if(del == 1){ // check whether shift one ahead

      choose = colratio(start_position, end_position,1,S1 );	
      // comparison of column after end with first column 
      //calculates ratio of gamma functions for specified columns

      if(choose > 1){ // move ahead  
	  motifplusBF(chosenmotif,S1,end_position,start_position,count);
      }
    }

    else if (del == -1){
      choose = colratio(end_position, start_position,-1,S1 );	
      // comparison of column before start with last column


      if(choose > 1){ // move back
	motifminusBF(chosenmotif,S1,start_position,count);
      }

    }
   
  }	// end of annealing Metropolis

  ////////////////

 //print positions

  if(iter > collIter){					//somewhat stabilized 

    for(seqno = 0; seqno < no_of_seq; seqno++){
      for(i = 0; i < no_chosen[seqno]; i++){
	addnode(startvec[seqno], start_position[seqno][i]);
      }
    }
  }

  
 // update count matrix

    for(seqno = 0; seqno < no_of_seq; seqno++){
	  for(k = 0; k < no_chosen[seqno]; k++){
	    
	    for(i=0; i<width; i++){
	    setString(i,i,chosenmotif[seqno][k], str2);

	    for(a=0; a<NO_OF_BASES; a++){
	      if(strcmp(str2,dict[a+1].name)==0) {
		matcount[a][i]++;
		seqmotifmat[seqno][i][a]++;
	      }
	    }
	  }	    
	  }}

     sumcount=0;
     for(a=1; a<dict_length; a++){
       sumcount +=count[a];
     }
     
    postlik =  findlikSINGLE(matcount, count, beta,sumcount,total_chosen,b[motifIndex]);

    if((postlik > storemat.maxpostlik)&&(iter > collIter)){ // store this theta
      
      thisiter=1;
      storemat.iteration = iter;
      storemat.maxloglik = obslik;

      storemat.maxpostlik = postlik;
  
      for(a=0; a<NO_OF_BASES; a++){
	storemat.basecount[a] = count[a+1];
	storemat.bases[a+1] = count[a+1];

	for(i=0; i<width; i++){
	  storemat.matcount[a][i] = matcount[a][i];
	}
      }
      storemat.bases[NO_OF_BASES+1] = count[NO_OF_BASES+1];

    // copy matrix

    normprob = 0.0;

     for(a=0; a<NO_OF_BASES; a++){
       storemat.prob[a] = dict[a+1].prob; 
       normprob += storemat.prob[a];
       for(i=0; i<width; i++){
	 storemat.mat[a][i] =  dict[motifIndex].probmat[a][i];
       }
     }
     storemat.prob[NO_OF_BASES] = dict[motifIndex].prob;
     

     for(a=0; a<NO_OF_BASES; a++){
       storemat.baseprob[a] = storemat.prob[a]/normprob;
     }

     // copy starting positions

      for(seqno = 0; seqno < no_of_seq; seqno++){
	storemat.mcount[seqno]= no_chosen[seqno];

	  storemat.pos[seqno] = copynode(start_position[seqno], no_chosen[seqno]);
	   if(no_chosen[seqno] > 0) printlist(storemat.pos[seqno]);

	  if(no_chosen[seqno] > 0){
	    for(i=0; i< no_chosen[seqno]; i++){
	      jj = start_position[seqno][i];
	      setString(jj, jj+width-1, S1[seqno],str2);
	       tmpFmat = FORWARD_SUM(jj, S1[seqno],motifIndex);
	    }
	  }
      }

      storemat.signif = motifsig(width, b[motifIndex],dict_length-1, count, matcount);
     
  }

  // END OF SAMPLING FOR WORDS -- next: sampling for theta


  // PART 2 : SAMPLING FOR THETA
 
 sumcount=0;
for(a=1; a<dict_length; a++){

  sumcount +=count[a];
}

 total_chosen=0;
 for(seqno=0; seqno<no_of_seq; seqno++){
   total_chosen += no_chosen[seqno];
 }

// now updating the word stochastic matrix

/* given A, draw p */

/* first draw probs of words */

 count[motifIndex] = total_chosen;

 for(a=1; a<dict_length; a++){
   dictcount[a-1] = count[a]+beta[a-1];
 }

 rDirich(dict_length-1,dictcount,dictprobs);

 if(iter < MAXITER){ // update word probs

 for(a=1; a<dict_length; a++){
  dict[a].prob = dictprobs[a-1];
 }
 }

 for(j=0; j<max_length; j++){
   for(i=0; i<NO_OF_BASES; i++){
     count1[j][i] = b[motifIndex][i][j] + matcount[i][j];
   }
 }


// Now draw for theta

 /* draws from product Dirichlet */
 
 for(i=0; i<max_length; i++){
   rDirich(NO_OF_BASES, count1[i], probs[i]);
 }
 
 if(iter < MAXITER){ //update Theta
 for(a=0; a<NO_OF_BASES; a++){
   for(i=0; i<max_length; i++){
     dict[motifIndex].probmat[a][i] = probs[i][a];
   }}
}


/* check criterion */

   for(i=0; i<max_length; i++){	
     for(a=0; a<NO_OF_BASES; a++){	
	localmat[a][i] = dict[motifIndex].probmat[a][i] ;	
     }}


   if(thisiter==1){ // this theta corresponding to "good" alignment should be stored

       for(a=0; a<NO_OF_BASES; a++){
	 storemat.prob[a] = dict[a+1].prob; 
       
	 for(i=0; i<width; i++){
	 storemat.mat[a][i] =  dict[motifIndex].probmat[a][i];
	 }
       }
   }
     

   a = word_size[motifIndex];

   if(criterion(localmat,a,newword)==1){
	/* converged if after burn-out period */
     if(iter>MAXITER) flag1=1;
   }
   else {
     if(iter>MAXITER) {
       // couldn't find more modes after MAXITER iterations
       flag1=1;
       /* will continue searching ignoring criterion */
     }
   }

}/* end iter */
 

// DO ANNEALING

 annpostlik =  storemat.maxpostlik;

 for(iter=0; iter<ANNEAL;iter++){// DO ANNEALING

    for(seqno = 0; seqno < no_of_seq; seqno++){   
      k = 1;
      gw = gaplength+width;
      while(k<(L[seqno]-gw+1)){


	if(storemat.mcount[seqno] > 0){
	  flag1 = findmatch(k, storemat.pos[seqno],width); // returns 1 if does not overlap and can be used
							 // returns 2 if a motif
							 // returns 0 if overlaps
	}

	else flag1 = 1;


	for(a=1; a<dict_length;a++) count[a] = 0;
	for(a=0; a<NO_OF_BASES;a++){
	  for(i=0; i<width; i++){
	    matcount[a][i] = 0;
	  }}
	

	if(flag1==1){ //  no overlap and not a motif, so try including it as motif
	  setString(k, k+gw-1,S1[seqno],str2);
	  for(i=0; i< gw; i++){
	    a = findindex(str2[i]);
	    if(a > 0){   
	      count[a]++;
	      matcount[a-1][i]++;
	    }
	  }

	  // postlik as background (old maxpostlik)

	  sumcount= 0;
	   for(a=1; a<dict_length;a++) sumcount += storemat.bases[a];

	  T2 = findlikSINGLE(storemat.matcount, storemat.bases, beta,sumcount,total_chosen,b[motifIndex])  ;

	  // postlik with motif

	  for(a=0; a<NO_OF_BASES;a++){
	    for(i=0; i<width; i++){
	      matcount[a][i] += storemat.matcount[a][i];
	    }}
	  
	  for(a=0; a<NO_OF_BASES;a++){
	    count[a+1] = storemat.bases[a+1] - count[a+1];
	  }
	  count[NO_OF_BASES+1] = storemat.bases[NO_OF_BASES+1] + 1;
	  sumcount= 0;
	  for(a=1; a<dict_length;a++) sumcount += count[a];

	  T1 = findlikSINGLE(matcount, count, beta,sumcount,total_chosen,b[motifIndex]);
	  
	  if(T1 > T2) {// include motif and positions and update all counts
	    
	    // updating all counts

	    for(a=0; a<NO_OF_BASES;a++){
	      for(i=0; i<width; i++){
		storemat.matcount[a][i] = matcount[a][i];
	    }}
	    for(a=1; a<dict_length;a++) storemat.bases[a] = count[a];
	    
	    // update positions

	    storemat.pos[seqno] = addnewnode(storemat.pos[seqno],k);
	     sumcount= 0;
	   for(a=1; a<dict_length;a++) sumcount += storemat.bases[a];

	   annpostlik = findlikSINGLE(storemat.matcount, storemat.bases, beta,sumcount,total_chosen,b[motifIndex]);
	    storemat.mcount[seqno]++;
	 	    
	    k += gw;  // if motif included  
	  }
	  else {k++;}
	}

	else if(flag1==2){ // check whether it should come from background instead
	  setString(k, k+gw-1,S1[seqno],str2);
	  
	  for(i=0; i< gw; i++){
	    a = findindex(str2[i]);
	    if(a > 0){
	      count[a]++;
	      matcount[a-1][i]++;
	    }
	  }

	  // postlik with motif (old maxpostlik)

	  sumcount= 0;
	   for(a=1; a<dict_length;a++) sumcount += storemat.bases[a];
	  T1 = findlikSINGLE(storemat.matcount, storemat.bases, beta,sumcount,total_chosen,b[motifIndex])  ;

	  // postlik as background 

	  for(a=0; a<NO_OF_BASES;a++){
	    for(i=0; i<width; i++){
	      matcount[a][i] =storemat.matcount[a][i] -  matcount[a][i];
	    }}
	  
	  for(a=0; a<NO_OF_BASES;a++){
	    count[a+1] = storemat.bases[a+1] + count[a+1];
	  }
	  count[NO_OF_BASES+1] = storemat.bases[NO_OF_BASES+1] - 1;
	  sumcount= 0;
	  for(a=1; a<dict_length;a++) sumcount += count[a];

	  T2 = findlikSINGLE(matcount, count, beta,sumcount,total_chosen,b[motifIndex]);

	  if(T1 < T2) { // exclude motif, update counts, positions
 	    
	     // updating all counts

	    for(a=0; a<NO_OF_BASES;a++){
	      for(i=0; i<width; i++){
		storemat.matcount[a][i] = matcount[a][i];
	    }}
	    for(a=1; a<dict_length;a++) storemat.bases[a] = count[a];
	  
	    // update positions
	   
	    storemat.pos[seqno] = rmnode(storemat.pos[seqno],k);
	    sumcount= 0;
	   for(a=1; a<dict_length;a++) sumcount += storemat.bases[a];

	   annpostlik = findlikSINGLE(storemat.matcount, storemat.bases, beta,sumcount,total_chosen,b[motifIndex]);
	     storemat.mcount[seqno]--;

	    k++;    // if excluded
	   }	   
	  
	  else {k += gw;}  // if motif included  
	}
	
	else if(flag1==0){
	  k++;
	}
      } //end k
    }// end seqno
}//end annealing iter
 

    // Bayes ratio
 storemat.signif = motifsig(width, b[motifIndex],dict_length-1, storemat.bases, storemat.matcount);
  
 finalmotifcount = 0;

 for(seqno = 0; seqno < no_of_seq; seqno++){   
   if(storemat.mcount[seqno] > 0) {
     printlist(storemat.pos[seqno]);
     finalmotifcount += storemat.mcount[seqno];
   }
 }
 

  // calculate obslik for "good" theta

 for(seqno = 0; seqno < no_of_seq; seqno++) no_chosen[seqno]=0;
   
     obslik=0.0;
     
  for(a=0; a<=NO_OF_BASES; a++){
       dict[a+1].prob	= storemat.prob[a] ; 
  }

     for(a=0; a<NO_OF_BASES; a++){
	 for(i=0; i<width; i++){
	 dict[motifIndex].probmat[a][i] =  storemat.mat[a][i] ;
	 }
       }

     /* finding f */
     
     for(seqno = 0; seqno < no_of_seq; seqno++){   

       setveczero(seqbasecount[seqno],NO_OF_BASES+1);		// individual sequence base counts
       setmatzero(seqmotifmat[seqno]);

       setString(1,1,S1[seqno],str1);
       
       for(k = 1; k < L[seqno]; k++) SEGMENT_PROB[k] = 0.0;
       
       lnS[0] = 0.0;
       lnS[1] = log(prob_back(str1[0]));
       
       k=2;
       
        
       while(k < L[seqno]){		// FORWARD SUMMATION
	 
	 
	 lnS[k] = 0.0;
	 
	 // two components of prob
	 
	 T1 = lnS[k-1] + log(prob_back(S1[seqno][k]));


	 if( log(prob_back(S1[seqno][k]))  < -1e10  ){
	   printf("\n\n %c fileread error : continue? %f",S1[seqno][k],prob_back(S1[seqno][k]) );
	    fflush(stdin);
	    scanf("%c", &yes); 
	    if(yes == 'n') exit(0);
	    fflush(stdin);
	    scanf("%c", &yes);
	    if(yes == 'n') exit(0);
	 }
	 setString(k-1, k, S1[seqno], str1);   //dimer string 

	 T0 = 0.0;
	 
	 
	 if( (k < L[seqno])&&(k >= gw) ){ // k > gw 
	   

	   if(dict_length > 6){   // one motif already in dictionary
	     
	     for(a = (NO_OF_BASES+1); a < (dict_length - 1); a++){
	       setString(k-gw+1,k,S1[seqno],tmpstr);
	       t0[a] = lnS[k-gw]+logProb(tmpstr,a);
	     }
	     
	     }

	   setString(k-gw+1,k, S1[seqno], tmpstr);
	   SEGMENT_PROB[k-gw+1] = exp(logProb(tmpstr, motifIndex)) ;
	   T2 = lnS[k-gw] + logProb(tmpstr, motifIndex); 



	   if((dimer == 1)&&(dimerProb(str1) == 1)){ // 3 components to sample from
	     
	     T3 = lnS[k-2] + log(newprob);   //prob of dimer str1
	     maxT = min(T1,T2);
	     maxT = min(maxT,T3);
	    
	     if(dict_length > 6){

	       for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){ 
		 maxT = min(maxT,t0[a]);
	       }
	       for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){
		 T0 += exp(t0[a] - maxT);
	       }
	       
	       lnS[k] = log( T0 + exp(T1 - maxT) + exp(T2 - maxT) + exp(T3 - maxT) ) + maxT;
	     
	     }
	   }
	   
	   else{ // no dimers or insignificant dimer

	      if(dict_length > 6){
	
		maxT =  min(T1, T2);  
		
		for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){ 
		 maxT = min(maxT,t0[a]);
		}
		for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){
		  T0 += exp(t0[a] - maxT);
		}
  
		lnS[k] = log(T0  + exp(T1 - maxT) + exp(T2 - maxT)) + maxT; 

	      }
	      else{
		maxT =  min(T1, T2);    
		lnS[k] = log( exp(T1 - maxT) + exp(T2 - maxT)) + maxT ;
	      }
	          setString(k-gw+1, k,S1[seqno],str2);

	   }
	 }
	 
	 else{   // only base or dimer
	   
	   if((dimer == 1)&&(dimerProb(str1) == 1)){ // has dimer
	     T3 = lnS[k-2] + log(newprob);
	     maxT = min(T1,T3);
	     lnS[k] = log( exp(T1 - maxT) + exp(T3 - maxT)) + maxT ;
	   }
	   
	   else{ 
	     lnS[k] = T1 ;      // no dimer, only base
	   }
	 }
	 
	 k++;
	 if(k == L[seqno]) break;

       }
       
       obslik += lnS[L[seqno]-1];
      
     }// end seqno

       storemat.maxloglik = obslik;

       // mixture density parameters

 for(seqno = 0; seqno < no_of_seq; seqno++){
   printlist(storemat.pos[seqno]);
   
 }


 oldC2 = C2back(width, b[motifIndex],dict_length-1, storemat.basecount, storemat.matcount);

 // ################################################
 // PARAMETERS CORR. TO HIGHEST POST PROB. 
 // ################################################

 gw = gaplength + width;

 for(i=0; i<width; i++){
   for(a=0; a<NO_OF_BASES; a++){
     dict[motifIndex].probmat[a][i] = storemat.mat[a][i];
   }
 }

 for(a=0; a<NO_OF_BASES; a++){
   dict[a+1].prob = storemat.prob[a];
 }
 dict[NO_OF_BASES+1].prob = storemat.prob[NO_OF_BASES];



   ///////////////////////////////////////////////////////////////////
  // CONSTRUCTING MIXTURE OF DISTRIBUTIONS FOR IMPORTANCE SAMPLING // 
 ///////////////////////////////////////////////////////////////////


 // number of components

 for(i=1; i<=numcomp; i++){
   pcomp[i] = 1.0/numcomp;
 }

 // "SHIFT -1" AND "SHIFT +1" and "true"

 for(i=0; i<width; i++){
   for(a=0; a<NO_OF_BASES; a++){
     thetaplus[a][i] = 0.0;
     thetaminus[a][i] = 0.0;
     thetatrue[a][i] = 0.0;
   }}



 if(finalmotifcount > 0){

 for(seqno = 0; seqno < no_of_seq; seqno++){

   tmpnode = storemat.pos[seqno];
   
   while(tmpnode!=NULL){
     j = tmpnode->position + 1;
     k = tmpnode->position - 1;

     setString(j, j+width -1, S1[seqno], str1);
     setString(k, k+width -1, S1[seqno], str2);
     setString(k+1, k+width, S1[seqno], str3);

     for(i=0; i<width; i++){
       a = findindex(str1[i])-1;if(a >= 0) thetaplus[a][i]++;
       a = findindex(str2[i])-1;if(a >= 0) thetaminus[a][i]++;
       a = findindex(str3[i])-1;if(a >= 0) thetatrue[a][i]++;
     }
     tmpnode = tmpnode->next;
   }
 }
 }


 // get probability matrix

 if(finalmotifcount > 0){
 for(i=0; i<width; i++){
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaplus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaplus[a][i]/= T1;}
   
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaminus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaminus[a][i]/= T1;}
   
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetatrue[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetatrue[a][i]/= T1;}

 }
 }



 for(i=0; i<width; i++){
   for(a=0; a<NO_OF_BASES; a++){
     dict[motifIndex].probmat[a][i] = thetatrue[a][i];
   }
 }

  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[0][a][i] = dict[motifIndex].probmat[a][i]; //"true"
    }
 } 

  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[1][a][i] = thetaplus[a][i];   // shift +1
    }
 } 

  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[2][a][i] = thetaminus[a][i];   // shift -1
    }
 } 

  if(finalmotifcount > 0){// shift by more , 2 here

  for(i=0; i<width; i++){
   for(a=0; a<NO_OF_BASES; a++){
     thetaplus[a][i] = 0.0;
     thetaminus[a][i] = 0.0;
   }}


 for(seqno = 0; seqno < no_of_seq; seqno++){

   tmpnode = storemat.pos[seqno];
   
   while(tmpnode!=NULL){
     j = tmpnode->position + 2;
     k = tmpnode->position - 2;

     setString(j, j+width -1, S1[seqno], str1);
     setString(k, k+width -1, S1[seqno], str2);

     for(i=0; i<width; i++){
       a = findindex(str1[i])-1;if(a >= 0) thetaplus[a][i]++;
       a = findindex(str2[i])-1;if(a >= 0) thetaminus[a][i]++;
     }
     tmpnode = tmpnode->next;
   }
 }


 for(i=0; i<width; i++){
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaplus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaplus[a][i]/= T1;}
   
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaminus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaminus[a][i]/= T1;}
   
 }

 for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[3][a][i] = thetaplus[a][i];   // shift +1
    }
 } 

  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[4][a][i] = thetaminus[a][i];   // shift -1
    }
 } 

 }


if(finalmotifcount > 0){// shift by more , 2 here

  for(i=0; i<width; i++){
   for(a=0; a<NO_OF_BASES; a++){
     thetaplus[a][i] = 0.0;
     thetaminus[a][i] = 0.0;
   }}


 for(seqno = 0; seqno < no_of_seq; seqno++){

   tmpnode = storemat.pos[seqno];
   
   while(tmpnode!=NULL){
     j = tmpnode->position + 3;
     k = tmpnode->position - 3;

     setString(j, j+width -1, S1[seqno], str1);
     setString(k, k+width -1, S1[seqno], str2);
    

     for(i=0; i<width; i++){
       a = findindex(str1[i])-1;if(a >= 0) thetaplus[a][i]++;
       a = findindex(str2[i])-1;if(a >= 0) thetaminus[a][i]++;
     }
     tmpnode = tmpnode->next;
   }
 }


 for(i=0; i<width; i++){
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaplus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaplus[a][i]/= T1;}
   
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaminus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaminus[a][i]/= T1;}
   
 }

 for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[5][a][i] = thetaplus[a][i];   // shift +1
    }
 } 

  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[6][a][i] = thetaminus[a][i];   // shift -1
    }
 } 
 }



if(finalmotifcount > 0){// shift by more , 2 here

  for(i=0; i<width; i++){
   for(a=0; a<NO_OF_BASES; a++){
     thetaplus[a][i] = 0.0;
     thetaminus[a][i] = 0.0;
   }}


 for(seqno = 0; seqno < no_of_seq; seqno++){

   tmpnode = storemat.pos[seqno];
   
   while(tmpnode!=NULL){
     j = tmpnode->position + 4;
     k = tmpnode->position - 4;

     setString(j, j+width -1, S1[seqno], str1);
     setString(k, k+width -1, S1[seqno], str2);

     for(i=0; i<width; i++){
       a = findindex(str1[i])-1;if(a >= 0) thetaplus[a][i]++;
       a = findindex(str2[i])-1;if(a >= 0) thetaminus[a][i]++;
     }
     tmpnode = tmpnode->next;
   }
 }


 for(i=0; i<width; i++){
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaplus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaplus[a][i]/= T1;}
   
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaminus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaminus[a][i]/= T1;}
   
 }

 for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[7][a][i] = thetaplus[a][i];   // shift +1
    }
 } 

  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[8][a][i] = thetaminus[a][i];   // shift -1
    }
 } 
 }



if(finalmotifcount > 0){// shift by more , 2 here

  for(i=0; i<width; i++){
   for(a=0; a<NO_OF_BASES; a++){
     thetaplus[a][i] = 0.0;
     thetaminus[a][i] = 0.0;
   }}


 for(seqno = 0; seqno < no_of_seq; seqno++){

   tmpnode = storemat.pos[seqno];
   
   while(tmpnode!=NULL){
     j = tmpnode->position + 5;
     k = tmpnode->position - 5;

     setString(j, j+width -1, S1[seqno], str1);
     setString(k, k+width -1, S1[seqno], str2);

     for(i=0; i<width; i++){
       a = findindex(str1[i])-1;if(a >= 0) thetaplus[a][i]++;
       a = findindex(str2[i])-1;if(a >= 0) thetaminus[a][i]++;
     }
     tmpnode = tmpnode->next;
   }
 }


 for(i=0; i<width; i++){
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaplus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaplus[a][i]/= T1;}
   
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaminus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaminus[a][i]/= T1;}
 }

 for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[9][a][i] = thetaplus[a][i];   // shift +1
    }
 } 

  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[10][a][i] = thetaminus[a][i];   // shift -1
    }
 } 
 }


  // "smoothed" theta matrices

// "smoothen" true matrix
 
 smthfac = 0.4;

 for(k = (numcomp-2); k<numcomp; k++){

  for(i=0; i<width; i++){
    
    for(a=0; a<NO_OF_BASES; a++)
      tmprow[a] = smtheta[0][a][i];
    a = maximum(tmprow,NO_OF_BASES);
    u = smthfac*(rand()/M1); // move at most smthfac of mass of largest theta
    smtheta[k][a][i] = (1-u)*smtheta[0][a][i]; //flatten largest
    
    for(j=0; j<NO_OF_BASES; j++){
      if(j!=a) smtheta[k][j][i] = smtheta[0][j][i] + u * smtheta[0][a][i]/(NO_OF_BASES-1);
    }
  }

   
 }

  //####################################################################

  // calculate obslik corresponding to each theta

  //####################################################################

  for(selcomp=0; selcomp<numcomp; selcomp++){// obslik for each component
 
    for(i=0; i<width; i++){
      for(a=0; a<NO_OF_BASES; a++){
	dict[motifIndex].probmat[a][i] = smtheta[selcomp][a][i];
      }
    }
    
    // now this theta is used...
        
    complik[selcomp] = 0.0;
 
    /* finding f */

   for(seqno = 0; seqno < no_of_seq; seqno++){	//no. of seq
     
     setString(1,1,S1[seqno],str1);
     
     for(k = 1; k < L[seqno]; k++) SEGMENT_PROB[k] = 0.0;

     lnS[0] = 0.0;
     lnS[1] = log(prob_back(str1[0]));
     
     k=2;
    
     while(k < L[seqno]){		// FORWARD SUMMATION
      
      lnS[k] = 0.0;
      
      // two components of prob
      
      T1 = lnS[k-1] + log(prob_back(S1[seqno][k]));
      setString(k-1, k, S1[seqno], str1);   //dimer string 
      
	if( (k < L[seqno])&&(k >= gw) ){
	   setString(k-gw+1,k, S1[seqno], tmpstr);
	   SEGMENT_PROB[k-gw+1] = exp(logProb(tmpstr, motifIndex)) ;
	   T2 = lnS[k-gw] + logProb(tmpstr, motifIndex); 

	  if((dimer == 1)&&(dimerProb(str1) == 1)){ // 3 components to sample from
	    T3 = lnS[k-2] + log(newprob);   //prob of dimer str1
	    maxT = min(T1,T2);
	    maxT = min(maxT,T3);
	    lnS[k] = log( exp(T1 - maxT) + exp(T2 - maxT) + exp(T3 - maxT) ) + maxT ;
	   
	  }

	  else{ // no dimers or insignificant dimer
	    maxT =  max(T1, T2);    
	    lnS[k] = log( exp(T1 - maxT) + exp(T2 - maxT)) + maxT ;
	  }
	}

	else{   // only base or dimer

	  if((dimer == 1)&&(dimerProb(str1) == 1)){ // has dimer
	    T3 = lnS[k-2] + log(newprob);
	    maxT = min(T1,T3);
	    lnS[k] = log( exp(T1 - maxT) + exp(T3 - maxT)) + maxT ;
	  }

	  else{ 
	    lnS[k] = T1 ;      // no dimer, only base
	  }
	}
	k++;
	if(k == L[seqno]) break;
     }
    
    complik[selcomp] += lnS[L[seqno]-1];
    
   }/* end seqno */

  }
    /////////////////////////////////////////////////////////
   //     second run of  sampling- for BDGE estimators    //
  /////////////////////////////////////////////////////////

 while(setno < NoOfSets){ // no of sets for each combination of parameters

   tmpfile = fopen(outfile,"a");

   fprintf(tmpfile,"\n started set %d\n",setno);
   
 bdgeO1=0.0;  bdgecons1=0.0; bdgeG1=0.0;
 bdgeO2=0.0;  bdgecons2=0.0; bdgeG2=0.0;

 for(i=0; i<width; i++){
      for(a=0; a<NO_OF_BASES; a++){
	dict[motifIndex].probmat[a][i] = smtheta[0][a][i];
      }
  }

 // reset word probs if reqd.

 for(a=0; a<NO_OF_BASES; a++){
   dict[a+1].prob = storemat.prob[a];
 }
 dict[NO_OF_BASES+1].prob = storemat.prob[NO_OF_BASES];

  BFRIS = 0.0; // reciprocal importance sampling

    flag1=0; iter=0;

/* end iter */


    /********************************************************************/
    /*              IMPORTANCE sampling  to estimate Bayes Factor       */
    /********************************************************************/


  BFIS = 0.0;

 for(iter=0; iter<HILL; iter++){ // importance sampling from mixture

   alignprob=0.0;

 for(seqno = 0; seqno < no_of_seq; seqno++) no_chosen[seqno]=0;

 // CHOOSE component of mixture density and copy to current probmat

 jj = sample(pcomp,numcomp); //from 1 to numcomp

 selcomp = jj;

 for(i=0; i<width; i++){
   for(a=0; a<NO_OF_BASES; a++){
     dict[motifIndex].probmat[a][i] = smtheta[jj-1][a][i];
   }
 }
 smthfac=0.0;

 // now this theta is used...

 obslik = 0.0;
 postlik =  0.0;
 
 /* Given p, draw A */
 
   for(i=0; i<NO_OF_BASES; i++){
     for(j=0; j<max_length; j++){
       matcount[i][j] = 0;
     }}
   
   for(a=1; a<dict_length; a++) count[a] = 0;
   
   /* finding f */

   for(seqno = 0; seqno < no_of_seq; seqno++){	//no. of seq
     
     setString(1,1,S1[seqno],str1);
     
     for(k = 1; k < L[seqno]; k++) SEGMENT_PROB[k] = 0.0;

     lnS[0] = 0.0;
     lnS[1] = log(prob_back(str1[0]));
     
    k=2;
    
    while(k < L[seqno]){		// FORWARD SUMMATION
      
      lnS[k] = 0.0;
      
      // two components of prob
      
      T1 = lnS[k-1] + log(prob_back(S1[seqno][k]));
      setString(k-1, k, S1[seqno], str1);   //dimer string 
      
	if( (k < L[seqno])&&(k >= gw) ){

	   setString(k-gw+1,k, S1[seqno], tmpstr);
	   SEGMENT_PROB[k-gw+1] = exp(logProb(tmpstr, motifIndex)) ;
	   T2 = lnS[k-gw] + logProb(tmpstr, motifIndex); 

	  if((dimer == 1)&&(dimerProb(str1) == 1)){ // 3 components to sample from
	    T3 = lnS[k-2] + log(newprob);   //prob of dimer str1
	    maxT = min(T1,T2);
	    maxT = min(maxT,T3);
	    lnS[k] = log( exp(T1 - maxT) + exp(T2 - maxT) + exp(T3 - maxT) ) + maxT ;
	  }

	  else{ // no dimers or insignificant dimer
	    maxT =  max(T1, T2);    
	    lnS[k] = log( exp(T1 - maxT) + exp(T2 - maxT)) + maxT ;
	  }
	}

	else{   // only base or dimer

	  if((dimer == 1)&&(dimerProb(str1) == 1)){ // has dimer
	    T3 = lnS[k-2] + log(newprob);
	    maxT = min(T1,T3);
	    lnS[k] = log( exp(T1 - maxT) + exp(T3 - maxT)) + maxT ;
	  }

	  else{ 
	    lnS[k] = T1 ;      // no dimer, only base
	  }
	}

	k++;
	if(k == L[seqno]) break;
	
 }
    
 obslik += lnS[L[seqno]-1];
 
/* Backward Sampling */

 k=L[seqno]-1;
 
 noadded=0;
 while(k >= 1){
                noadded++;
		
		// for base

		nw = 1;
       		setString(k,k,S1[seqno],str1);
	
		for(a=1; a<motifIndex; a++){
				if(strcmp(str1, dict[a].name)==0) {
				  pa[nw] =  lnS[k-1] + log(dict[a].prob);    // log prob of being a base
				  ind[nw] = a;
				} /* end if */
		}
	 
		// for motif

		if(k >= gw){		  
			nw++;
		       	pa[nw] = lnS[k-gw] + log(SEGMENT_PROB[k-gw+1]);  /* based on current update of parameter */
			ind[nw] = motifIndex;			
			setString(k-gw+1,k,S1[seqno],str2);
			}
	

		// dimer may be present

		if((dimer == 1) && (k >= 2)){
		  
		  setString(k-1, k, S1[seqno], str1);
		  
		  if(dimerProb(str1) == 1){		    
                    nw++;
		    pa[nw] = lnS[k-2] + log(newprob);   
		    ind[nw] = wordind;
		  }
		}
	     
		if(nw > 2){  // motif, dimer and base
		 
		  pa[1] = exp(pa[1] - pa[3]);
		  pa[2] = exp(pa[2] - pa[3]);
		  pa[3] = 1;
		  sel = sample(pa,3);
		  A = ind[sel];

		  if(sel <= 4){ //base
		    alignprob += log(dict[sel].prob);  
		  }
		  else{  // no dimers considered yet
		    alignprob += log(SEGMENT_PROB[k-gw+1]);  
		    setString(k-gw+1,k,S1[seqno], str3);
		  }
		}


		else if(nw > 1){ // base and dimer, or motif and base
		 	
		  pa[2] = exp(pa[2] - pa[1]);
		  pa[1] = 1;
		  sel = sample(pa,2);
		  A = ind[sel];
		  
		  if(A <= 4){ //base
		    alignprob += log(dict[A].prob);  
		  }
		  else{  // no dimers considered yet
		     setString(k-gw+1,k,S1[seqno], str3);
		     alignprob += log(SEGMENT_PROB[k-gw+1]);  
		  }
		}
		else{
		  A = ind[nw];
		  alignprob += log(dict[A].prob);
		}
		

	if(A != motifIndex){ /* base or dimer */
	    count[A]++;		
	    strcpy(lastword,str1);
	}

	
	else {	 
	  // now need to sample for gaps within selected words and update the count matrix

	  count[A]++;
	  total_chosen = no_chosen[seqno];  
	  jj = k - gw + 1;
	  start_position[seqno][total_chosen] = FindGaps(jj, S1[seqno],motifIndex, gapindices);
	  setString(jj, jj+width-1, S1[seqno],str2);
	  strcpy(lastword,str2);
	  strcpy(chosenmotif[seqno][total_chosen],str2);
	  no_chosen[seqno]++;
	}
		
	k -= strlen(lastword); 	 
      
	} /* end k */
  

}/* end seqno */

 // update count matrix

    for(seqno = 0; seqno < no_of_seq; seqno++){
	  for(k = 0; k < no_chosen[seqno]; k++){

	    for(i=0; i<width; i++){
	    setString(i,i,chosenmotif[seqno][k], str2);

	    for(a=0; a<NO_OF_BASES; a++){
	      if(strcmp(str2,dict[a+1].name)==0) matcount[a][i]++;
	    }
	  }	    
	  }}
    
    // summing counts of words
    
    sumcount=0;
    for(a=1; a<dict_length; a++){
      sumcount +=count[a];
    }

    // total number of motifs

    total_chosen=0;
    
    for(seqno=0; seqno<no_of_seq; seqno++){
      total_chosen += no_chosen[seqno];
    }

    postlik =  findlikSINGLE(matcount, count, beta,sumcount,total_chosen,b[motifIndex]);


    // marginal calculations


    alignprob -= obslik;

    // mixture distribution: p2

    for(i=0; i<numcomp; i++){
      lp[i] = p1theta(width, dict_length-1, count, matcount, storemat.prob, smtheta[i]) - complik[i] + log(pcomp[i+1]);
    }

    a = maximum(lp,numcomp);
    sumbf = 0.0;
   
    for(i=0; i<numcomp; i++){
      sumbf += exp(lp[i] - lp[a]);
    }

    lptot = lp[a] +  log(sumbf);      //lptot is log(imp samp prob) from mixture

    C1[iter] = motifsig(width, b[motifIndex],dict_length-1, count, matcount);
    BFIS += exp(C1[iter] - lptot);   //new

   bdgeO1 += exp( - log(exp(log(trueR) - motifsig(width, b[motifIndex],dict_length-1, count, matcount) + lptot) + 1.0));


    if(iter>0){
       bdgecons1 += exp(C1[iter] - cons1); 
       bdgeG1 += exp(0.5*(motifsig(width, b[motifIndex],dict_length-1, count, matcount) - lptot ) - G1 );
       
    }
    else{
      cons1 = C1[iter] ;
      G1 = 0.5*( motifsig(width, b[motifIndex],dict_length-1, count, matcount) - lptot ) ;
    }
   
 } // end imp. sampling

 BFIS /= HILL;
 BFRIS /= HILL;
 BFRIS = 1/BFRIS;


 bdgecons1 = log(bdgecons1) + cons1;
 bdgecons2 = log(bdgecons2) + cons2;
 bdgeG2 = log(bdgeG2)+G2;
 bdgeG1 = log(bdgeG1)+G1;


 bdgeCON = exp(bdgecons1 - bdgecons2 );
 bdgeG = exp( bdgeG1 - bdgeG2);
 bdgeOPT = exp(log(bdgeO1) - log(bdgeO2));

 fprintf(tmpfile," %d\t %d\t %lf\t %lf\t %lf\t ",finalmotifcount,numcomp,log(BFIS),log(bdgeG), log(BFRIS));


 fprintf(tmpfile,"%f\t  %f\t %d\t %d (%d)\n", storemat.signif, storemat.maxpostlik, HILL,width,SEED);


   info = 0.0; motifscore = 0.0;


  for(i=0; i<width; i++){

    for(a=0; a<NO_OF_BASES; a++){
      dict[motifIndex].probmat[a][i] = storemat.mat[a][i];
    }
  }

  for(a=0; a<NO_OF_BASES; a++){
    dict[a+1].prob = storemat.prob[a];
  }


  setno++;
  fclose(tmpfile);
 
 } //end setno 

 searchmotifs++;

 motifIndex++;

  } /* end prob calc - search for next motif*/


   
   system("date"); 
   printf("\n\n");
   system("rm -f buf.out");
 
    
 } /* end BF */


double infocalc(int mat[NO_OF_BASES][MOTIFLENGTH], double probmat[NO_OF_BASES][MOTIFLENGTH], int nw){

  int	i,a;
  double  info=0.0;

  for(i = 0; i < width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      if(probmat[a][i]>0){ 
	if(mat[a][i]>0) info += (mat[a][i]/(float)nw)*(log(mat[a][i]/(float)nw) - log(probmat[a][i]) );
      }
      else info += -999999.0;
      
    }
  }
  return(info);
}


double infoback(int mat[NO_OF_BASES][MOTIFLENGTH], int nw){

  int	i,a;
  double  info=0.0;

  for(i = 0; i < width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      if(dict[a+1].prob>0){ 
	if(mat[a][i]>0) info += (mat[a][i]/(float)nw)*(log(mat[a][i]/(float)nw) - log(dict[a+1].prob) );
      }
      else info += -999999.0;
      
    }
  }
  return(info);
}


double FIND_BACK(int pos, char SEQ[BIGSEQ]){

  int    end, length = gaplength + width, j;
  double logR = 0.0;
  char seg[TOTLENGTH];

  end = pos + gaplength + width - 1;  
  setString(pos, end , SEQ,seg); 

  for(j = 0; j < length; j++){
    logR += log(prob_back(seg[j])); 
  }

  return(exp(logR));   // multiplied by prior
}




void genmotif(double R[MOTIFLENGTH][NO_OF_BASES+1], int w, char motifstr[MOTIFLENGTH]){

  int i, a;
  
  for(i = 1; i <= w; i++){
    a = sample(R[i], NO_OF_BASES);
    motifstr[i-1] = letter[a-1];
  }
  motifstr[w] = '\0';
  return;
}


void UpdateCount(int mat[NO_OF_BASES][MOTIFLENGTH], char motifstr[MOTIFLENGTH],int w){

  int i, a;

  for(i = 0; i < w; i++){
    a = findindex(motifstr[i]) - 1;
    if(a >= 0)    mat[a][i]++ ;
  }
  return;
}




double endratio(int num[NO_OF_SEQ][MOTIF_COUNT],int den[NO_OF_SEQ][MOTIF_COUNT], int d,char SEQ[NO_OF_SEQ][BIGSEQ]){
//calculates ratio of gamma functions for '+1' column to '-1' column, i.e. end1 to end2, to decide which col to include in motif model

  int	 seqno,k,a;
  double rat = 0.0, coll1[NO_OF_BASES],coll2[NO_OF_BASES] ;

for(a=0; a<NO_OF_BASES; a++){ coll1[a]=0; coll2[a]=0;}

  for(seqno = 0 ; seqno < no_of_seq; seqno++){
    for(k = 0 ; k < no_chosen[seqno]; k++){
            for(a = 0; a < NO_OF_BASES; a++){
	 		if(SEQ[seqno][num[seqno][k] + d]==letter[a]) coll2[a]++;	
			if(SEQ[seqno][den[seqno][k] - d]==letter[a]) coll1[a]++;	
	    }

    }}

  for(a=0; a<NO_OF_BASES; a++){
    rat += (coll2[a]+beta[a]-0.5)*log(coll2[a]+beta[a]-1.0) - (coll1[a]+beta[a]-0.5)*log(coll1[a]+beta[a]-1.0);
  }
  
return(exp(rat));
}



double lengthprobratio(int matcount[NO_OF_BASES][MOTIFLENGTH], int count[NO_OF_BASES+2], double bb[NO_OF_BASES+2], double gam[NO_OF_BASES][MOTIFLENGTH],int incr, int chcol[NO_OF_BASES]){
  // returns ratio of probs of including/deleting a column from the motif as compared to current length (incr = 1 => increase, -1 => decrease, baseline length is w0


  // returns Bayes Factor of P(H0)/ P(H1)


  double  tm1= 0.0,tm2= 0.0,Hsum = 0.0, Gsum = 0.0,lGsum = 0.0, Nsum = 0.0,motifcol=0.0, lmotifcol = 0.0, logL = 0.0;
  int     D = dict_length - 1, i, a;
  

for(a = 0 ; a < NO_OF_BASES; a++){

  tm1 += (count[a+1] + bb[a] - 0.5)*log(count[a+1] + bb[a] - 1.0) - (count[a+1] + bb[a] - incr*chcol[a] - 0.5)*log(count[a+1] + bb[a] - incr*chcol[a] - 1.0);
  Hsum += chcol[a];
  Nsum += count[a+1] + bb[a];
  Gsum += gam[0][a];
  lGsum += lgamma(gam[0][a]); 
  motifcol +=  chcol[a] + gam[0][a];
  lmotifcol += lgamma(chcol[a] + gam[0][a]);
}

 Nsum += count[NO_OF_BASES+1] + bb[NO_OF_BASES];  // updating by motif counts

 logL += tm1 + (Nsum - incr*Hsum - 0.5)*log(Nsum - incr*Hsum - 1.0)  - (Nsum  - 0.5)*log(Nsum - 1.0) + incr*(lgamma(motifcol) - lmotifcol + lGsum - lgamma(Gsum)); 
 
 if(incr == 1){
   logL +=  -log(w0*1.0) + log(width+1.0);
   return(exp(-logL));
 }

 else if(incr == -1){
   logL +=  - log(width*1.0) + log(w0*1.0);
   return(exp(-logL));
 }

 else {
   printf("wrong increase specification!");
   exit(0);
 }

}





void increasemotif(char SEQ[NO_OF_SEQ][BIGSEQ],int newmatcount[NO_OF_BASES][MOTIFLENGTH], int count[NO_OF_BASES+2], int newcol[NO_OF_BASES], int posn[NO_OF_SEQ][MOTIF_COUNT], int ch,double gam[NO_OF_BASES][MOTIFLENGTH]){
  // updates counts, changes width and start positions if necessary

  int i,a,k,seqno;
  char str2[2];

  width++;

  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      newmatcount[a][i] = 0;
    }
  }

  // sets the new motifs
  for(seqno = 0; seqno < no_of_seq; seqno++){
    for(k = 0; k < no_chosen[seqno]; k++){
      setString(posn[seqno][k]+ch,(posn[seqno][k]+ch + width-1),SEQ[seqno],chosenmotif[seqno][k]); // new motif
	    
	    for(i=0; i<width; i++){
	    setString(i,i,chosenmotif[seqno][k], str2);

	    for(a=0; a<NO_OF_BASES; a++){
	      if(strcmp(str2,dict[a+1].name)==0) newmatcount[a][i]++;
	    }
	  }	    
	  }}
    
  for(a=0; a<NO_OF_BASES; a++){ // only base counts change (decrease)
    count[a+1] -= newcol[a];
  }

  // changes positions if necessary

  for(seqno = 0; seqno < no_of_seq; seqno++){
    for(k = 0; k < no_chosen[seqno]; k++){
      posn[seqno][k] += ch;
    }
  }

  // updating beta for new length

  for(i=0; i<NO_OF_BASES; i++){
    gam[i][width-1] =  gam[i][0];
  }
  return;
}



void decreasemotif(char SEQ[NO_OF_SEQ][BIGSEQ],int newmatcount[NO_OF_BASES][MOTIFLENGTH], int count[NO_OF_BASES+2], int newcol[NO_OF_BASES], int posn[NO_OF_SEQ][MOTIF_COUNT], int ch){
  // updates counts, changes width and start positions if necessary, after deletions
  
   int i,a,k,seqno;
   char str2[2];

  width--;

  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      newmatcount[a][i] = 0;
    }
  }

  // sets the new motifs
  for(seqno = 0; seqno < no_of_seq; seqno++){
    for(k = 0; k < no_chosen[seqno]; k++){
      setString(posn[seqno][k]+ch,(posn[seqno][k]+ch + width-1),SEQ[seqno],chosenmotif[seqno][k]); // new motif
	    
	    for(i=0; i<width; i++){
	    setString(i,i,chosenmotif[seqno][k], str2);

	    for(a=0; a<NO_OF_BASES; a++){
	      if(strcmp(str2,dict[a+1].name)==0) newmatcount[a][i]++;
	    }
	  }	    
	  }}
    
  for(a=0; a<NO_OF_BASES; a++){ // only base counts change (increase)
    count[a+1] += newcol[a]; 
  }

  // changes positions if necessary

  for(seqno = 0; seqno < no_of_seq; seqno++){
    for(k = 0; k < no_chosen[seqno]; k++){
      posn[seqno][k] += ch;
    }
  }
  return;
}



void newlengthmotifs(char SEQ[NO_OF_SEQ][BIGSEQ],int startposn[NO_OF_SEQ][MOTIF_COUNT],int endposn[NO_OF_SEQ][MOTIF_COUNT],int matcount[NO_OF_BASES][MOTIFLENGTH], int count[NO_OF_BASES+2], double bb[NO_OF_BASES], double gam[NO_OF_BASES][MOTIFLENGTH],int incr, int side){

  // CHANGED probratio... 

  // find the column that is to be included/ deleted - calculates prob. ratio, decides whether length should be changed, and updates motif positions and counts and width of motif; side = 1 denotes position after, -1, before
  //posn denotes end positions for increase forward, start positions for increase backward

  int i,a,k,seqno, newcol[NO_OF_BASES];
  double probratio, rannum;

  for(a=0; a<NO_OF_BASES; a++) newcol[a]=0;
 

  if(incr == 1){  // increase length of motif
  // try to include next position after end if side= 1 or try to include previous position before start if side= -1 : get newcol

    for(seqno = 0 ; seqno < no_of_seq; seqno++){
      for(k = 0 ; k < no_chosen[seqno]; k++){
	for(a = 0; a < NO_OF_BASES; a++){
	  if (side == 1){ 
	    if(SEQ[seqno][endposn[seqno][k]+side] ==letter[a]) newcol[a]++;
	  } 
	  else { 
	    if(SEQ[seqno][startposn[seqno][k]+side] ==letter[a]) newcol[a]++; 
	  }
	}
      }}


    probratio = lengthprobratio(matcount,  count, bb, gam, incr, newcol);

    
    //INCREASE ONLY IF PROB

      if( probratio > 1){ //include  column
	if(side==1){ // no change in start positions- next column
	  increasemotif(SEQ,matcount, count, newcol, startposn, 0,gam);
	    for(seqno = 0 ; seqno < no_of_seq; seqno++){
	      for(k = 0 ; k < no_chosen[seqno]; k++){
		endposn[seqno][k] = startposn[seqno][k] + width - 1;
	      }}
	}
	else { // prev column, decrease by 1 the start positions
	  increasemotif(SEQ,matcount, count,  newcol, startposn, -1,gam);
	}
      }
    

     if( probratio < 1){ //Bayes Factor in favour of alternative

       if((rannum=rand()/M1) < (probratio/(1+probratio))){ 

	if(side==1){ // no change in start positions
	  increasemotif(SEQ,matcount, count, newcol, startposn, 0,gam);
	  for(seqno = 0 ; seqno < no_of_seq; seqno++){
	      for(k = 0 ; k < no_chosen[seqno]; k++){
		endposn[seqno][k] = startposn[seqno][k] + width - 1;
	      }}
	}
	else { // prev column, decrease by 1 the start positions
	  increasemotif(SEQ,matcount, count,  newcol, startposn, -1,gam);
	}
	
       }}
  }

    // if want to delete a column

  else if(incr == -1){ //try to delete a column

    for(seqno = 0 ; seqno < no_of_seq; seqno++){
      for(k = 0 ; k < no_chosen[seqno]; k++){
	for(a = 0; a < NO_OF_BASES; a++){ 
	  if (side == 1){ // no change in start positions- delete last column
	    if(SEQ[seqno][endposn[seqno][k]] ==letter[a]) newcol[a]++; }
	  else { //delete 1st column, increase by 1 the start positions
	    if(SEQ[seqno][startposn[seqno][k]] ==letter[a]) newcol[a]++; }
	}
      }}


 probratio = lengthprobratio(matcount,  count, bb, gam, incr, newcol);
   
  //INCREASE ONLY IF PROB
  if( probratio > 1){ //delete column
	if(side==1){ // no change in start positions - last column
	  decreasemotif(SEQ,matcount, count, newcol, startposn, 0);
	  for(seqno = 0 ; seqno < no_of_seq; seqno++){
	      for(k = 0 ; k < no_chosen[seqno]; k++){
		endposn[seqno][k] = startposn[seqno][k] + width - 1;
	      }}
	}
	else { // prev column, decrease by 1 the start positions
	  decreasemotif(SEQ,matcount, count,  newcol, startposn, +1);
	}
      }
 
 if( probratio < 1){ //Bayes Factor in favour of alternative
       if((rannum=rand()/M1) < (probratio/(1+probratio))){ 

	if(side==1){ // no change in start positions
	  decreasemotif(SEQ,matcount, count, newcol, startposn, 0);
	  for(seqno = 0 ; seqno < no_of_seq; seqno++){
	      for(k = 0 ; k < no_chosen[seqno]; k++){
		endposn[seqno][k] = startposn[seqno][k] + width - 1;
	      }}
	}
	else { // prev column, decrease by 1 the start positions
	  decreasemotif(SEQ,matcount, count,  newcol, startposn, +1);
	}	
       }}
  }

  return;

}






void runLEN(FILE *f2, int numcomp){

  unsigned int   dum, SEED;  

  int 	       thisiter=0, i,j,jj,a,reqd, k,nw, l, L[NO_OF_SEQ],word_length,iter,N,flag1,seqno,sum_L=0,total_chosen,gw, start_position[NO_OF_SEQ][MOTIF_COUNT],end_position[NO_OF_SEQ][MOTIF_COUNT], gapindices[MOTIFLENGTH], it=0,wordmax, count[DICT_SIZE],ind[MOTIFLENGTH],sel,A, matcount[NO_OF_BASES][MOTIFLENGTH],sumcount=0,searchmotifs=0,del, num, iter50, flag, div, Tcount[NO_OF_BASES][NO_OF_BASES], MC=0, totBase=0, NoDimer=0, dimer=0,  equi, totdimer=0, numMotifs, n_in, N_in, run, setno, index[BIGSEQ],wordcount[BIGSEQ][dict_length], NoTruemotifs=0,TrueMatCount[NO_OF_BASES][MOTIFLENGTH], WordFound = 0,noadded, truebaseseqcount[NO_OF_SEQ][NO_OF_BASES],oldmatcount[NO_OF_BASES][MOTIFLENGTH],selcomp,finalmotifcount,step,MAXWIDTH,startwidth,minposn,maxposn, FB ; 

  double 	f[BIGSEQ], lnS[BIGSEQ], T1, T2,T3, maxT ,pa[MOTIFLENGTH],count1[MOTIFLENGTH][NO_OF_BASES],probs[MOTIFLENGTH][NO_OF_BASES],localmat[NO_OF_BASES][MOTIFLENGTH],dictcount[MOTIFLENGTH],dictprobs[MOTIFLENGTH],obslik, b[DICT_SIZE][NO_OF_BASES][MOTIFLENGTH],startprob,normsum=0.0, SEGMENT_PROB[BIGSEQ],choose, rannum, expscore, Zscore[NO_OF_BASES][NO_OF_BASES], tmpT[NO_OF_BASES], tmpD[NO_OF_BASES], fracN, info=0.0, motifscore =0.0, prob[dict_length], trueinfo = 0.0, normprob, nprob[NO_OF_BASES],TrueMatProb[NO_OF_BASES][MOTIFLENGTH], diffprob, normprobfinal=0.0,a0, b0, T0,t0[DICT_SIZE], T0min, C1[MAXITER],BFIS,BFRIS,BFN=0.0,BFM, BFMarg, C1mode,postlik, alignprob,oldC2, CPO[NO_OF_SEQ], backf[NO_OF_SEQ] ,bdgeG1,bdgeG2,bdgecons1, bdgecons2,bdgeO1=0.0, bdgeO2=0.0,bdgeOPT=0.0, bdgeCON, cons1, cons2,G1, G2, bdgeG, thetaplus[NO_OF_BASES][MOTIFLENGTH], thetatrue[NO_OF_BASES][MOTIFLENGTH],thetaminus[NO_OF_BASES][MOTIFLENGTH], smtheta[NUMMIX][NO_OF_BASES][MOTIFLENGTH],tmprow[NO_OF_BASES],u, smthfac, complik[NUMMIX], lp[NUMMIX], sumbf,lptot=0.0,annpostlik=0.0, pcomp[NUMMIX] ,trueR =  3046.697  ;

  char 	        str1[BIGSEQ],str2[BIGSEQ],str3[MOTIFLENGTH],S[NO_OF_SEQ][BIGSEQ],S1[NO_OF_SEQ][BIGSEQ],lastword[MOTIFLENGTH],newstr[MOTIFLENGTH],comm[COMMENT_LENGTH], updateMotif[MOTIFLENGTH], selwords[TOTLENGTH],tempword[MOTIFLENGTH],choseword[NO_OF_SEQ][MOTIF_COUNT][MOTIFLENGTH],newword[MOTIFLENGTH],newS[NO_OF_SEQ][BIGSEQ],yes, rof, finalword[MOTIFLENGTH], truemotif[MOTIFLENGTH], tmpstr[MOTIFLENGTH];

 char	        filename[15],string1[10],file1[20],  names[NO_OF_SEQ], rowname[20];
 char           resfiles[MAXRUNS+2][10], outfile[15], outfiles[NoOfSets+2][20];
 node		*tmpnode;
 vect           *tmpvect; 
 table		*freqtable, *tmptab;
 FILE	        *f1, *inputfile, *tmp1, *buf, *out, *in,*fin, *tmpfile, *likfile; 
  
 dict_length = 6;
 for(a = 1; a < dict_length-1; a++){
	strcpy(dict[a].name,word_list[a-1]);
	}

 fflush(stdin);
 scanf("%s",file1);

 fflush(stdin);
 scanf("%s",outfile);
 tmpfile = fopen(outfile,"w");

 fflush(stdin);
 scanf("%d", &SEED);
 srand(SEED);

 scanf("%d",&width);
 startwidth = width;

 run = 1;

// read inputs
 
 setno = 0;

  //initialise everything

  WordFound = 0;
  sum_L=0;it=0;sumcount=0;MC=0; totBase=0; NoDimer=0; dimer=0;totdimer=0;info=0.0;motifscore =0.0;

  searchmotifs = 0;

   inputfile = fopen(file1,"r");

   buf = fopen("buf.out","w");

   no_of_seq = ReadSeq(inputfile, buf, newS, L);   //  read sequences in fasta format

   forwardno = no_of_seq;		// number of forward strands
  
   for(i = 0;i < no_of_seq; i++){
     strUpr(newS[i],S[i]);
     L[i] = strlen(S[i]);
     totBase += L[i];
     totdimer += L[i] - 1;
     CPO[i] = 0.0;
   }
   
   gaplength = 0;
   reqd = 1;
   gw = gaplength + width;

   strcpy(tempword,"X");

 for(i = 0;i < width-1; i++) strcat(tempword,"X");

 strcpy(word_list[dict_length-2],tempword);
 

 // parameters

 div = 10;
 equi = 2; 
 fracN = 0.10; 


// motif pseudocount as fraction of 1000
 fflush(stdin);
 scanf("%d", &i); 
 motifPC = i/1000.0;

 // Include dimers? Y(1)/N(0)
 fflush(stdin);
 scanf("%d", &MC); 
 
 // Include reverse strand ? Y(1)/N(0)
 fflush(stdin);
 scanf("%d", &FB); 

 // Max no. of iterations 
 fflush(stdin);
 scanf("%d", &MAXITER);

 // Min. and Max width of motif
 fflush(stdin);
 scanf("%d", &minwidthlimit);
 fflush(stdin);
 scanf("%d", &maxwidthlimit);
 MAXWIDTH = maxwidthlimit;

 // # iter for length (<5000 : HILL)
 fflush(stdin);
 scanf("%d", &LENITER);


 fprintf(tmpfile,"\n sdlen -i %s -o %s -S %d -w %d -p %d -d %d -r %d -I %d -l %d -L %d -A %d\n",file1,outfile,SEED,width,(int)(motifPC*1000),MC,FB,MAXITER,minwidthlimit,maxwidthlimit,LENITER);

 if(FB == 1){			//include backward strand also
   
   for(i = 0;i < no_of_seq; i++){
     strcpy(str1, S[i]);
     TakeComplement(str1, str2);
     strcpy(S[i+no_of_seq],str2);
   }

   no_of_seq +=  no_of_seq;		// doubles the number of input sequences

   for(i = 0; i < no_of_seq; i++){
      L[i] = strlen(S[i]);
   }

 }
 

 sum_L=0;

 for(k = 0; k < no_of_seq; k++){
   sum_L += L[k];
   L[k]++;    /* L is now L+1 */
   S1[k][0] = '*';
 
   for(i=1; i<L[k]; i++)   S1[k][i] = S[k][i-1];
 }

 
  for(a = 1; a < dict_length; a++){
    strcpy(dict[a].name,word_list[a-1]);
    dict[a].coeff = 0.0;
    dict[a].repeat = 0;
    word_size[a] = strlen(dict[a].name);
  }

  motifIndex = SizeDict - 1;

/* finding max length of the word */

  wordmax = word_size[1];

for(a=2; a<dict_length; a++){
	if(word_size[a] > wordmax) wordmax = word_size[a];
}

 max_length = wordmax;		      

for(seqno=0; seqno<no_of_seq; seqno++){
    for(a=0; a<NO_OF_BASES;a++){
     truebaseseqcount[seqno][a]=0;
    }
  }



/* finding no. of repeats */

  for(a=1; a<dict_length-1; a++){
     word_length = strlen(dict[a].name);

      for(k=0;k<no_of_seq;k++){	

	for(i=0; i<L[k]-word_length; i++){
		setString(i, i+word_length-1, S[k],str1);
		
	if(strcmp(str1,dict[a].name) == 0) {
		dict[a].repeat++;
		truebaseseqcount[k][a-1]++;
		}	
	}	
	}

	} /*end a*/



 normsum=0.0;
 for(a=1; a<dict_length-1; a++){
   normsum += dict[a].repeat;
 }

 normsum/= (float)NO_OF_BASES;
 normsum*= fracN;		// ave. of betas for bases



 for(a = 1; a < dict_length-1; a++) {
   beta[a-1] = (float)dict[a].repeat*fracN;     // pseudocounts to fix the prior
 }
 beta[dict_length-2] = motifPC*normsum ;     //in proportion to prior parameters of bases

 a0 =  beta[dict_length-2];
 b0 = 0.0;

 for(a = 0; a < dict_length-2; a++){
   b0 += beta[a];
 }

 dict[dict_length-1].repeat = 0;

 for(a=1; a<dict_length; a++){
   dictcount[a-1] = dict[a].repeat+beta[a-1];
 }

 
 rDirich(dict_length-1, dictcount, dictprobs);

 for(a=1; a<dict_length; a++){
   dict[a].prob = dictprobs[a-1];   
   dictprobs[a-1] =  (float)dict[a].repeat/sum_L ;    // proportion of occurrence of bases
}

 if(equi == 1){

 startprob=.25;

 for(i=0; i<NO_OF_BASES; i++){

   for(j=0; j<MAXWIDTH; j++){
	dict[dict_length-1].probmat[i][j] = startprob;
	b[dict_length-1][i][j] = startprob;
   }
 }
  
 }

 else{  // matrix based on background

   for(j=0; j<MAXWIDTH; j++){

     for(i=0; i<NO_OF_BASES; i++){
  	  b[dict_length-1][i][j] = dictprobs[i];
	  dict[dict_length-1].probmat[i][j] = dictprobs[i];
     }
   }
   
 }


if(MC == 1){ // finding number of repeats of 2-mers
  
  dimer = 1;

  
   for(j = 0; j < NO_OF_BASES; j++){
     for(k = 0; k < NO_OF_BASES; k++){
       Tcount[j][k] = 0;
     }
   }
 
   for(seqno = 0; seqno < no_of_seq; seqno++){
     
     for(i = 1; i < (L[k]-1) ; i++){
        j = findindex(S1[seqno][i]);		// index- from 1 to 4
	k = findindex(S1[seqno][i+1]);
	
	if((j>0)&&(k>0)) Tcount[j-1][k-1]++;
     }
   }

  


 // Setting up the Markov transition matrix

   for(i = 0; i < NO_OF_BASES; i++){

     for(j = 0; j < NO_OF_BASES; j++)   tmpD[j] = 1.0*Tcount[i][j];
   
     rDirich(NO_OF_BASES, tmpD, tmpT);
   
     for(j = 0; j < NO_OF_BASES; j++)   T[i+1][j+1] = tmpT[j];
   }

 
   //  Finding significant dimers

    for(j = 0; j < NO_OF_BASES; j++){

     for(k = 0; k < NO_OF_BASES; k++){
       expscore = totdimer*dictprobs[j]*dictprobs[k];
       Zscore[j][k] = (Tcount[j][k] - expscore)/sqrt(expscore);
     }
   }
  

   // Adding "significant" dimers to the dictionary

   jj = dict_length; 

    NoDimer = 0;
    for(seqno = 0; seqno < no_of_seq; seqno++){
      NoDimer += L[seqno]-2;
    }

   flag1 = 0;


   for(j = 1; j <= NO_OF_BASES; j++){
     for(k = 1; k <= NO_OF_BASES; k++){
       
       if(Zscore[j-1][k-1] > zCutOff){ 
	 //add dimer to dictionary - occurs more than expected

	 setString(0,0,base[j-1],str1);
	 strcat(str1,base[k-1]);
	 strcpy(dict[jj].name,str1);
	 dict[jj].coeff = 0.0;
	
	 dict[jj].repeat = Tcount[j-1][k-1];
	 word_size[jj] = strlen(dict[jj].name);
	 strcpy(word_list[jj-1], dict[jj].name);
	 beta[jj-1] = fracN*Tcount[j-1][k-1]; 
	 dictcount[jj-1] = Tcount[j-1][k-1] + beta[jj-1] ;
	 jj++;
	 
       }
  

     }
   }
  
   // should draw from Dirichlet too??

   dict_length = jj;
   
   rDirich(dict_length-1, dictcount, dictprobs);


   for(a=1; a<dict_length; a++){
     dict[a].prob = dictprobs[a-1];   
   }
 }
 
 
    // PART 1: Sampling for words given current update of stochastic word matrix

 while(searchmotifs<reqd){


   //initialize start position vector 

   for(seqno = 0; seqno < no_of_seq; seqno++){
     startvec[seqno] = (node*)malloc(sizeof(node));
     startvec[seqno]->position = 0;
     startvec[seqno]->next = NULL;
   }

  
   if(dict_length > 6){ // dict. length > 6, update beta vector
    
     beta[dict_length-2] = motifPC*normsum ;     //in proportion to prior parameters of bases
     a0 =  beta[dict_length-2];
     b0 = 0.0;
     
     for(a = 0; a < dict_length-2; a++)  b0 += beta[a];
     dict[dict_length-1].repeat = 0;
     
     for(a=1; a<dict_length; a++)  dictcount[a-1] = dict[a].repeat+beta[a-1];
     rDirich(dict_length-1, dictcount, dictprobs);
     
     for(a=1; a<dict_length; a++){
       dict[a].prob = dictprobs[a-1];   
     }
     

    // new theta matrix

     for(j=0; j<max_length; j++){

       for(i=0; i<NO_OF_BASES; i++){
	 b[dict_length-1][i][j] = dictprobs[i];
	 dict[dict_length-1].probmat[i][j] = dictprobs[i];
       }
     }
   }// dict > 6
   
   iter=0; flag1=0;
   
   storemat.maxloglik = maxneg;
   storemat.maxpostlik = maxneg;
   storemat.maxobslik = maxneg;
   storemat.signif = maxneg;


   for(seqno = 0; seqno < no_of_seq; seqno++){
     backf[seqno] = ratback(width,seqno,truebaseseqcount);
   }

   flag1=0; iter=0;

   while(flag1 == 0){
     iter++;
     
     thisiter=0;
     for(seqno = 0; seqno < no_of_seq; seqno++) no_chosen[seqno]=0;
      
     obslik=0.0;
     
     /* Given p, draw A */
     
     for(i=0; i<NO_OF_BASES; i++){
       for(j=0; j<max_length; j++){
	 matcount[i][j] = 0;
       }}
     
     for(a=1; a<dict_length; a++) count[a] = 0;
     
     /* finding f */
     
     for(seqno = 0; seqno < no_of_seq; seqno++){   
 

       setveczero(seqbasecount[seqno],NO_OF_BASES+1);		// individual sequence base counts
       setmatzero(seqmotifmat[seqno]);



       setString(1,1,S1[seqno],str1);
       
       for(k = 1; k < L[seqno]; k++) SEGMENT_PROB[k] = 0.0;
       
       lnS[0] = 0.0;
       lnS[1] = log(prob_back(str1[0]));
       
       k=2;
       
         
       while(k < L[seqno]){		// FORWARD SUMMATION
	 
	 
	 lnS[k] = 0.0;
	 
	 // two components of prob
	 
	 T1 = lnS[k-1] + log(prob_back(S1[seqno][k]));


	 if( log(prob_back(S1[seqno][k]))  < -1e10  ){
	    printf("\n\n %c  fileread error : continue? ",S1[seqno][k]);
	    fflush(stdin);
	    scanf("%c", &yes); 
	    if(yes == 'n') exit(0);
	    
	    fflush(stdin);
	    scanf("%c", &yes);
	    if(yes == 'n') exit(0);
	 }
	 setString(k-1, k, S1[seqno], str1);   //dimer string 

	 T0 = 0.0;
	 
	 
	 if( (k < L[seqno])&&(k >= gw) ){ // k > gw 
	   

	   if(dict_length > 6){   // one motif already in dictionary

		     
	     for(a = (NO_OF_BASES+1); a < (dict_length - 1); a++){
	       setString(k-gw+1,k,S1[seqno],tmpstr);
	       t0[a] = lnS[k-gw]+logProb(tmpstr,a);
	     }
	     }
	   
	   
	   // new  
	   setString(k-gw+1,k, S1[seqno], tmpstr);
	   SEGMENT_PROB[k-gw+1] = exp(logProb(tmpstr, motifIndex)) ;
	   T2 = lnS[k-gw] + logProb(tmpstr, motifIndex); 

	 
	   if((dimer == 1)&&(dimerProb(str1) == 1)){ // 3 components to sample from
	     
	     T3 = lnS[k-2] + log(newprob);   //prob of dimer str1
	     maxT = min(T1,T2);
	     maxT = min(maxT,T3);
	    
	     if(dict_length > 6){

	       for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){ 
		 maxT = min(maxT,t0[a]);
	       }
	       for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){
		 T0 += exp(t0[a] - maxT);
	       }
	       
	       lnS[k] = log( T0 + exp(T1 - maxT) + exp(T2 - maxT) + exp(T3 - maxT) ) + maxT;
	     
	     }
	   }
	   
	   else{ // no dimers or insignificant dimer

	      if(dict_length > 6){
	
		maxT =  min(T1, T2);  
	
		for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){ 
		 maxT = min(maxT,t0[a]);
		}
		for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){
		  T0 += exp(t0[a] - maxT);
		}
  
		lnS[k] = log(T0  + exp(T1 - maxT) + exp(T2 - maxT)) + maxT; 
	      }
	      else{
		maxT =  min(T1, T2);    
		lnS[k] = log( exp(T1 - maxT) + exp(T2 - maxT)) + maxT ;
	      }
	   }

	    setString(k-gw+1, k,S1[seqno],str2);
	 }
	 
	 else{   // only base or dimer
	   
	   if((dimer == 1)&&(dimerProb(str1) == 1)){ // has dimer
	     T3 = lnS[k-2] + log(newprob);
	     maxT = min(T1,T3);
	     lnS[k] = log( exp(T1 - maxT) + exp(T3 - maxT)) + maxT ;
	   }
	   
	   else{ 
	     lnS[k] = T1 ;      // no dimer, only base
	   }
	 }
	
	 k++;
	 if(k == L[seqno]) break;
       }
       
       obslik += lnS[L[seqno]-1];
       
/* Backward Sampling */


 k=L[seqno]-1;
 
 while(k >= 1){

	// for base

		nw = 1;
	
       		setString(k,k,S1[seqno],str1);
	
		for(a = 1; a <= NO_OF_BASES; a++){
				if(strcmp(str1, dict[a].name)==0) {
				  pa[nw] =  lnS[k-1] + log(dict[a].prob);    // log prob of being a base
				  ind[nw] = a;
				
				}
		}
		
	 
		// for motif

		if(k >= gw){		  
			nw++;
		       	pa[nw] = lnS[k-gw] + log(SEGMENT_PROB[k-gw+1]);  /* based on current update of parameter */
		
   			ind[nw] = motifIndex;			
			
			setString(k-gw+1,k,S1[seqno],str2);
			
	

			if(dict_length > 6){  //old  word

			  for(a = (NO_OF_BASES+1); a < (dict_length-1); a++)
			    {
			      nw++;
			      setString(k-gw+1,k,S1[seqno],tmpstr);
			      pa[nw] = lnS[k-gw] + logProb(tmpstr,a);
			    }
			}
		} // end k >= gw


		// dimer may be present

		if((dimer == 1) && (k >= 2)){
		  
		  setString(k-1, k, S1[seqno], str1);
		  
		  if(dimerProb(str1) == 1){		    
		    nw++;
		    pa[nw] = lnS[k-2] + log(newprob);   
		    ind[nw] = wordind;
		  }
		}
	     
		
		if(nw > 1){ // general- sampling for word
		    for(a = 1; a < nw ; a++){
		      pa[a] = exp(pa[a] - pa[nw]);
		    }

		    pa[nw] = 1.0;
		    sel = sample(pa,nw);
		    A = ind[sel];
		
	
		}

		  else A = ind[nw];
	       
		
	if(A != motifIndex){ /* base or dimer */
	    count[A]++;		
	    strcpy(lastword,str1);
	    seqbasecount[seqno][A-1]++;
	}

	
	else {	 

	  count[A]++;
	  seqbasecount[seqno][A-1]++;

	  total_chosen = no_chosen[seqno];  
	  jj = k - gw + 1;

	  
	start_position[seqno][total_chosen] = FindGaps(jj, S1[seqno],motifIndex, gapindices);
				// now don't penalise for gaps at end
	if((dict_length > 6)&&(start_position[seqno][total_chosen] < 0))
	  {
	    printf("%d (%d)- %d   ",jj,start_position[seqno][total_chosen],A);
	     // error: stop?
	    printf("\n\n Error in position: continue? ");
	    fflush(stdin);
	    scanf("%c", &yes); 
	    if(yes == 'n') exit(0);
	    fflush(stdin);
	    scanf("%c", &yes);
	    if(yes == 'n') exit(0);
	  }

	end_position[seqno][total_chosen] = start_position[seqno][total_chosen] + width - 1;

	strcpy(lastword,str2);	// this is motif with gaps

	setMotif(str2,updateMotif,gapindices); //finds positions for the motif
	
	setWithGaps(selwords,str2, gapindices); // motif with gaps that is chosen
	strcpy(choseword[seqno][total_chosen],selwords);
	
	strcpy(chosenmotif[seqno][total_chosen],updateMotif);

       	no_chosen[seqno]++;

	}
		
	k -= strlen(lastword); 	 
      
	} /* end k */
  

}/* end seqno */

  

     for(i=0; i<width; i++){
       for(a=0; a<NO_OF_BASES; a++){
	 oldmatcount[a][i]=0;
       }}


     for(seqno = 0; seqno < no_of_seq; seqno++){
	  for(k = 0; k < no_chosen[seqno]; k++){
	 	    
	    for(i=0; i<width; i++){
	    setString(i,i,chosenmotif[seqno][k], str2);

	    for(a=0; a<NO_OF_BASES; a++){
	      if(strcmp(str2,dict[a+1].name)==0) {
		oldmatcount[a][i]++;
	      }
	    }
	    }	    
	  }}
     
  

  //Metropolis if iter > METRO and every 10th step


  if((iter > METRO) && (iter%10 == 0) && (count[motifIndex]>0) &&(iter <= (MAXITER-600))){  //Metropolis
    
    if((rannum=rand()/M1) < 0.5) del = 1; else del = -1;

    if(del == 1){ // check whether shift one ahead

      choose = colratio(start_position, end_position,1,S1 );
      // comparison of column after end with first column 
      //calculates ratio of gamma functions for specified columns


      if(choose > 1){ // move ahead  
	  motifplusBF(chosenmotif,S1,end_position,start_position,count);
      }

      else if((rannum=rand()/M1) < (choose/(1+choose))) {	
		motifplusBF(chosenmotif,S1,end_position,start_position,count); 
      }
    }



    else if (del == -1){
      choose = colratio(end_position, start_position,-1,S1 );	// comparison of column before start with last column

      if(choose > 1){ // move back
	motifminusBF(chosenmotif,S1,start_position,count);
      }

      else if((rannum=rand()/M1) < (choose/(1+choose)) ){ 	
		motifminusBF(chosenmotif,S1,start_position,count); 
      }
    }

   
  }	// end of Metropolis



  ////////    annealing metropolis



  if((iter > (MAXITER-600)) && (iter%5 == 0) && (count[motifIndex]>0)){  //Metropolis annealing
    if((rannum=rand()/M1) < 0.5) del = 1; else del = -1;

    if(del == 1){ // check whether shift one ahead

      choose = colratio(start_position, end_position,1,S1 );	
      // comparison of column after end with first column 
      //calculates ratio of gamma functions for specified columns


      if(choose > 1){ // move ahead  
	  motifplusBF(chosenmotif,S1,end_position,start_position,count);
      }
    }



    else if (del == -1){
      choose = colratio(end_position, start_position,-1,S1 );	// comparison of column before start with last column

      if(choose > 1){ // move back
	motifminusBF(chosenmotif,S1,start_position,count);
      }
    }
  }	// end of annealing Metropolis


  ////////////////


 //print positions

  if(iter > collIter){					//somewhat stabilized 

    for(seqno = 0; seqno < no_of_seq; seqno++){
      for(i = 0; i < no_chosen[seqno]; i++){
	addnode(startvec[seqno], start_position[seqno][i]);
      }
      
    }

  }

 
  
 // update count matrix

    for(seqno = 0; seqno < no_of_seq; seqno++){
	  for(k = 0; k < no_chosen[seqno]; k++){
	  
	    
	    for(i=0; i<width; i++){
	    setString(i,i,chosenmotif[seqno][k], str2);

	    for(a=0; a<NO_OF_BASES; a++){
	      if(strcmp(str2,dict[a+1].name)==0) {
		matcount[a][i]++;
		seqmotifmat[seqno][i][a]++;
	      }
	    }
	  }	    
	  }}

     sumcount=0;
     for(a=1; a<dict_length; a++){
       sumcount +=count[a];
     }
     
    postlik =  findlikSINGLE(matcount, count, beta,sumcount,total_chosen,b[motifIndex]);


    if((postlik > storemat.maxpostlik)&&(iter > collIter)){ // store this theta
      
      thisiter=1;

      storemat.iteration = iter;
      storemat.maxloglik = obslik;

      storemat.maxpostlik = postlik;
  
      for(a=0; a<NO_OF_BASES; a++){
	storemat.basecount[a] = count[a+1];
	storemat.bases[a+1] = count[a+1];

	for(i=0; i<width; i++){
	  storemat.matcount[a][i] = matcount[a][i];
	}
      }
      storemat.bases[NO_OF_BASES+1] = count[NO_OF_BASES+1];

    // copy matrix

    normprob = 0.0;

     for(a=0; a<NO_OF_BASES; a++){
       storemat.prob[a] = dict[a+1].prob; 
       normprob += storemat.prob[a];
       for(i=0; i<width; i++){
	 storemat.mat[a][i] =  dict[motifIndex].probmat[a][i];
       }
     }
     storemat.prob[NO_OF_BASES] = dict[motifIndex].prob;
     
     for(a=0; a<NO_OF_BASES; a++){
       storemat.baseprob[a] = storemat.prob[a]/normprob;
     }

     // copy starting positions

      for(seqno = 0; seqno < no_of_seq; seqno++){
	storemat.mcount[seqno]= no_chosen[seqno];

	  storemat.pos[seqno] = copynode(start_position[seqno], no_chosen[seqno]);
	   if(no_chosen[seqno] > 0) printlist(storemat.pos[seqno]);

	  if(no_chosen[seqno] > 0){
	    for(i=0; i< no_chosen[seqno]; i++){
	      jj = start_position[seqno][i];
	      setString(jj, jj+width-1, S1[seqno],str2);
	       tmpFmat = FORWARD_SUM(jj, S1[seqno],motifIndex);
	    }
	  }
      }



      storemat.signif = motifsig(width, b[motifIndex],dict_length-1, count, matcount);
     
  }

   
  // END OF SAMPLING FOR WORDS -- next: sampling for theta


  // PART 2 : SAMPLING FOR THETA
 
 sumcount=0;
for(a=1; a<dict_length; a++){
  sumcount +=count[a];
}

 total_chosen=0;
 for(seqno=0; seqno<no_of_seq; seqno++){
   total_chosen += no_chosen[seqno];
 }
 


// now updating the word stochastic matrix

/* given A, draw p */

/* first draw probs of words */

 count[motifIndex] = total_chosen;

 for(a=1; a<dict_length; a++){
   dictcount[a-1] = count[a]+beta[a-1];
 }

 rDirich(dict_length-1,dictcount,dictprobs);
 
 if(iter < MAXITER){ // update word probs

 for(a=1; a<dict_length; a++){
  dict[a].prob = dictprobs[a-1];
 }
 }


 for(j=0; j<max_length; j++){
   for(i=0; i<NO_OF_BASES; i++){
     count1[j][i] = b[motifIndex][i][j] + matcount[i][j];
   }
 }


// Now draw for theta

 /* draws from product Dirichlet */
 
 for(i=0; i<max_length; i++){
   rDirich(NO_OF_BASES, count1[i], probs[i]);
 }
 
 if(iter < MAXITER){ //update Theta
 for(a=0; a<NO_OF_BASES; a++){
   for(i=0; i<max_length; i++){
     dict[motifIndex].probmat[a][i] = probs[i][a];
   }}
}




/* check criterion */

   for(i=0; i<max_length; i++){	
     for(a=0; a<NO_OF_BASES; a++){	
	localmat[a][i] = dict[motifIndex].probmat[a][i] ;	
     }}


   if(thisiter==1){ // this theta corresponding to "good" alignment should be stored

       for(a=0; a<NO_OF_BASES; a++){
	 storemat.prob[a] = dict[a+1].prob; 
       
	 for(i=0; i<width; i++){
	 storemat.mat[a][i] =  dict[motifIndex].probmat[a][i];
	 }
       }

   }
     

   a = word_size[motifIndex];

   if(criterion(localmat,a,newword)==1){
	/* converged if after burn-out period */
     if(iter>MAXITER) flag1=1;
   }
   else {
     if(iter>MAXITER) {
       // couldn't find more modes after MAXITER # iterations 
       flag1=1;
       /* will continue searching ignoring criterion */
     }
   }

}/* end iter */
 

// DO ANNEALING

 annpostlik =  storemat.maxpostlik;

 for(iter=0; iter<ANNEAL;iter++){// DO ANNEALING


    for(seqno = 0; seqno < no_of_seq; seqno++){   
      k = 1;
      gw = gaplength+width;
      while(k<(L[seqno]-gw+1)){


	if(storemat.mcount[seqno] > 0){

	  
	  flag1 = findmatch(k, storemat.pos[seqno],width); // returns 1 if does not overlap and can be used
							 // returns 2 if a motif
							 // returns 0 if overlaps
	}

	else flag1 = 1;


	for(a=1; a<dict_length;a++) count[a] = 0;
	for(a=0; a<NO_OF_BASES;a++){
	  for(i=0; i<width; i++){
	    matcount[a][i] = 0;
	  }}
	

	if(flag1==1){ //  no overlap and not a motif, so try including it as motif
	  setString(k, k+gw-1,S1[seqno],str2);
	  for(i=0; i< gw; i++){
	    a = findindex(str2[i]);
	    if(a > 0){
	      count[a]++;
	      matcount[a-1][i]++;
	    }
	  }

	  // postlik as background (old maxpostlik)

	  sumcount= 0;
	   for(a=1; a<dict_length;a++) sumcount += storemat.bases[a];

	  T2 = findlikSINGLE(storemat.matcount, storemat.bases, beta,sumcount,total_chosen,b[motifIndex])  ;

	  // postlik with motif

	  for(a=0; a<NO_OF_BASES;a++){
	    for(i=0; i<width; i++){
	      matcount[a][i] += storemat.matcount[a][i];
	    }}
	  
	  for(a=0; a<NO_OF_BASES;a++){
	    count[a+1] = storemat.bases[a+1] - count[a+1];
	  }
	  count[NO_OF_BASES+1] = storemat.bases[NO_OF_BASES+1] + 1;
	  sumcount= 0;
	  for(a=1; a<dict_length;a++) sumcount += count[a];
	  

	  T1 = findlikSINGLE(matcount, count, beta,sumcount,total_chosen,b[motifIndex]);
	  
	  
	  if(T1 > T2) {// include motif and positions and update all counts
	    
	    // updating all counts

	    for(a=0; a<NO_OF_BASES;a++){
	      for(i=0; i<width; i++){
		storemat.matcount[a][i] = matcount[a][i];
	    }}
	    for(a=1; a<dict_length;a++) storemat.bases[a] = count[a];
	    
	    // update positions

	    storemat.pos[seqno] = addnewnode(storemat.pos[seqno],k);
	     sumcount= 0;
	   for(a=1; a<dict_length;a++) sumcount += storemat.bases[a];

	   annpostlik = findlikSINGLE(storemat.matcount, storemat.bases, beta,sumcount,total_chosen,b[motifIndex]);
	    storemat.mcount[seqno]++;
	 	    
	    k += gw;  // if motif included  
	  }
	  else {k++;}
	}

	else if(flag1==2){ // check whether it should come from background instead
	  
	  setString(k, k+gw-1,S1[seqno],str2);
	  
	  for(i=0; i< gw; i++){
	    a = findindex(str2[i]);
	    if(a > 0){
	      count[a]++;
	      matcount[a-1][i]++;
	    }
	  }

	  // postlik with motif (old maxpostlik)

	  sumcount= 0;
	   for(a=1; a<dict_length;a++) sumcount += storemat.bases[a];
	  T1 = findlikSINGLE(storemat.matcount, storemat.bases, beta,sumcount,total_chosen,b[motifIndex])  ;

	  // postlik as background 

	  for(a=0; a<NO_OF_BASES;a++){
	    for(i=0; i<width; i++){
	      matcount[a][i] =storemat.matcount[a][i] -  matcount[a][i];
	    }}
	  
	  for(a=0; a<NO_OF_BASES;a++){
	    count[a+1] = storemat.bases[a+1] + count[a+1];
	  }
	  count[NO_OF_BASES+1] = storemat.bases[NO_OF_BASES+1] - 1;
	  sumcount= 0;
	  for(a=1; a<dict_length;a++) sumcount += count[a];
	  

	  T2 = findlikSINGLE(matcount, count, beta,sumcount,total_chosen,b[motifIndex]);


	  if(T1 < T2) { // exclude motif, update counts, positions

 	    
	     // updating all counts

	    for(a=0; a<NO_OF_BASES;a++){
	      for(i=0; i<width; i++){
		storemat.matcount[a][i] = matcount[a][i];
	    }}
	    for(a=1; a<dict_length;a++) storemat.bases[a] = count[a];
	  
	    // update positions
	   
	    storemat.pos[seqno] = rmnode(storemat.pos[seqno],k);
	    sumcount= 0;
	   for(a=1; a<dict_length;a++) sumcount += storemat.bases[a];

	   annpostlik = findlikSINGLE(storemat.matcount, storemat.bases, beta,sumcount,total_chosen,b[motifIndex]);
	     storemat.mcount[seqno]--;
	     k++;    // if excluded
	   }	   
	  
	  else {k += gw;}  // if motif included  
	}
	
	
	else if(flag1==0){
	  k++;
	}


	 
      } //end k

      
    }// end seqno


}//end annealing iter
 
 

 storemat.signif = motifsig(width, b[motifIndex],dict_length-1, storemat.bases, storemat.matcount);
  
 finalmotifcount = 0;

 for(seqno = 0; seqno < no_of_seq; seqno++){   
   if(storemat.mcount[seqno] > 0) {
     printlist(storemat.pos[seqno]);
     finalmotifcount += storemat.mcount[seqno];
   }
 }

    BFN /= HILL;

  // calculate obslik for "good" theta

       for(seqno = 0; seqno < no_of_seq; seqno++) no_chosen[seqno]=0;
   
     obslik=0.0;
     
  for(a=0; a<=NO_OF_BASES; a++){
       dict[a+1].prob	= storemat.prob[a] ; 
  }


     for(a=0; a<NO_OF_BASES; a++){
       
	 for(i=0; i<width; i++){
	 dict[motifIndex].probmat[a][i] =  storemat.mat[a][i] ;
	 }
       }


     /* finding f */
     
     for(seqno = 0; seqno < no_of_seq; seqno++){   

       setveczero(seqbasecount[seqno],NO_OF_BASES+1);		// individual sequence base counts
       setmatzero(seqmotifmat[seqno]);

       setString(1,1,S1[seqno],str1);
       
       for(k = 1; k < L[seqno]; k++) SEGMENT_PROB[k] = 0.0;
       
       lnS[0] = 0.0;
       lnS[1] = log(prob_back(str1[0]));
       
       k=2;
       
        
       while(k < L[seqno]){		// FORWARD SUMMATION
	 
	 
	 lnS[k] = 0.0;
	 
	 // two components of prob
	 
	 T1 = lnS[k-1] + log(prob_back(S1[seqno][k]));


	 if( log(prob_back(S1[seqno][k]))  < -1e10  ){
	   printf("\n\n %c fileread error : continue? %f",S1[seqno][k],prob_back(S1[seqno][k]) );
	    fflush(stdin);
	    scanf("%c", &yes); 
	    if(yes == 'n') exit(0);
	    fflush(stdin);
	    scanf("%c", &yes);
	    if(yes == 'n') exit(0);
	 }
	 setString(k-1, k, S1[seqno], str1);   //dimer string 

	 T0 = 0.0;
	 
	 if( (k < L[seqno])&&(k >= gw) ){ // k > gw 

	   if(dict_length > 6){   // one motif already in dictionary
	     
	     for(a = (NO_OF_BASES+1); a < (dict_length - 1); a++){
	       setString(k-gw+1,k,S1[seqno],tmpstr);
	       t0[a] = lnS[k-gw]+logProb(tmpstr,a);
	     }
	     
	     }
	   
	   setString(k-gw+1,k, S1[seqno], tmpstr);
	   SEGMENT_PROB[k-gw+1] = exp(logProb(tmpstr, motifIndex)) ;
	   T2 = lnS[k-gw] + logProb(tmpstr, motifIndex); 


	   if((dimer == 1)&&(dimerProb(str1) == 1)){ // 3 components to sample from
	     
	     T3 = lnS[k-2] + log(newprob);   //prob of dimer str1
	     maxT = min(T1,T2);
	     maxT = min(maxT,T3);
	    
	     if(dict_length > 6){

	       for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){ 
		 maxT = min(maxT,t0[a]);
	       }
	       for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){
		 T0 += exp(t0[a] - maxT);
	       }
	       
	       lnS[k] = log( T0 + exp(T1 - maxT) + exp(T2 - maxT) + exp(T3 - maxT) ) + maxT;
	     
	     }
	   }
	   
	   else{ // no dimers or insignificant dimer

	      if(dict_length > 6){
	
		maxT =  min(T1, T2);  
		
		for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){ 
		 maxT = min(maxT,t0[a]);
		}
		for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){
		  T0 += exp(t0[a] - maxT);
		}
  
		lnS[k] = log(T0  + exp(T1 - maxT) + exp(T2 - maxT)) + maxT; 

	      }
	      else{
		maxT =  min(T1, T2);    
		lnS[k] = log( exp(T1 - maxT) + exp(T2 - maxT)) + maxT ;
	      }
	          setString(k-gw+1, k,S1[seqno],str2);
	   }
	 }
	 
	 else{   // only base or dimer
	   
	   if((dimer == 1)&&(dimerProb(str1) == 1)){ // has dimer
	     T3 = lnS[k-2] + log(newprob);
	     maxT = min(T1,T3);
	     lnS[k] = log( exp(T1 - maxT) + exp(T3 - maxT)) + maxT ;
	   }
	   
	   else{ 
	     lnS[k] = T1 ;      // no dimer, only base
	   }
	 }
	 
	 k++;
	 if(k == L[seqno]) break;
       }
       
       obslik += lnS[L[seqno]-1];
      
     }// end seqno

       storemat.maxloglik = obslik;

 
    /******************  using theta(*) for br *******************/


       // mixture density parameters

 for(seqno = 0; seqno < no_of_seq; seqno++){
   printlist(storemat.pos[seqno]);
   
 }


 oldC2 = C2back(width, b[motifIndex],dict_length-1, storemat.basecount, storemat.matcount);

 // ################################################
 // PARAMETERS CORR. TO HIGHEST POST PROB. 
 // ################################################

 gw = gaplength + width;

 for(i=0; i<width; i++){
   for(a=0; a<NO_OF_BASES; a++){
     dict[motifIndex].probmat[a][i] = storemat.mat[a][i];
   }
 }

 for(a=0; a<NO_OF_BASES; a++){
   dict[a+1].prob = storemat.prob[a];
 }
 dict[NO_OF_BASES+1].prob = storemat.prob[NO_OF_BASES];

 // ################################################

   ///////////////////////////////////////////////////////////////////
  // CONSTRUCTING MIXTURE OF DISTRIBUTIONS FOR IMPORTANCE SAMPLING // 
 ///////////////////////////////////////////////////////////////////


 // number of components

 for(i=1; i<=numcomp; i++){
   pcomp[i] = 1.0/numcomp;
 }

 // "SHIFT -1" AND "SHIFT +1" and "true"

 for(i=0; i<width; i++){
   for(a=0; a<NO_OF_BASES; a++){
     thetaplus[a][i] = 0.0;
     thetaminus[a][i] = 0.0;
     thetatrue[a][i] = 0.0;
   }}

 if(finalmotifcount > 0){

 for(seqno = 0; seqno < no_of_seq; seqno++){

   tmpnode = storemat.pos[seqno];
   
   while(tmpnode!=NULL){
     j = tmpnode->position + 1;
     k = tmpnode->position - 1;

     setString(j, j+width -1, S1[seqno], str1);
     setString(k, k+width -1, S1[seqno], str2);
     setString(k+1, k+width, S1[seqno], str3);

     for(i=0; i<width; i++){
       a = findindex(str1[i])-1;if(a >= 0) thetaplus[a][i]++;
       a = findindex(str2[i])-1;if(a >= 0) thetaminus[a][i]++;
       a = findindex(str3[i])-1;if(a >= 0) thetatrue[a][i]++;
     }
     tmpnode = tmpnode->next;
   }
 }
 }

 // get probability matrix

 if(finalmotifcount > 0){
 for(i=0; i<width; i++){
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaplus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaplus[a][i]/= T1;}
   
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaminus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaminus[a][i]/= T1;}
   
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetatrue[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetatrue[a][i]/= T1;}

 }
 }


 // "TRUE" matrix
 for(i=0; i<width; i++){
   for(a=0; a<NO_OF_BASES; a++){
     dict[motifIndex].probmat[a][i] = thetatrue[a][i];
   }
 }


  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[0][a][i] = dict[motifIndex].probmat[a][i]; //"true"
    }
 } 

  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[1][a][i] = thetaplus[a][i];   // shift +1
    }
 } 

  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[2][a][i] = thetaminus[a][i];   // shift -1
    }
 } 


  if(finalmotifcount > 0){// shift by more , 2 here

  for(i=0; i<width; i++){
   for(a=0; a<NO_OF_BASES; a++){
     thetaplus[a][i] = 0.0;
     thetaminus[a][i] = 0.0;
   }}


 for(seqno = 0; seqno < no_of_seq; seqno++){

   tmpnode = storemat.pos[seqno];
   
   while(tmpnode!=NULL){
     j = tmpnode->position + 2;
     k = tmpnode->position - 2;

     setString(j, j+width -1, S1[seqno], str1);
     setString(k, k+width -1, S1[seqno], str2);

     for(i=0; i<width; i++){
       a = findindex(str1[i])-1;if(a >= 0) thetaplus[a][i]++;
       a = findindex(str2[i])-1;if(a >= 0) thetaminus[a][i]++;
     }
     tmpnode = tmpnode->next;
   }
 }


 for(i=0; i<width; i++){
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaplus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaplus[a][i]/= T1;}
   
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaminus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaminus[a][i]/= T1;}
   
 }

 for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[3][a][i] = thetaplus[a][i];   // shift +1
    }
 } 

  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[4][a][i] = thetaminus[a][i];   // shift -1
    }
 } 
 }


if(finalmotifcount > 0){// shift by more , 2 here

  for(i=0; i<width; i++){
   for(a=0; a<NO_OF_BASES; a++){
     thetaplus[a][i] = 0.0;
     thetaminus[a][i] = 0.0;
   }}


 for(seqno = 0; seqno < no_of_seq; seqno++){

   tmpnode = storemat.pos[seqno];
   
   while(tmpnode!=NULL){
     j = tmpnode->position + 3;
     k = tmpnode->position - 3;

     setString(j, j+width -1, S1[seqno], str1);
     setString(k, k+width -1, S1[seqno], str2);

     for(i=0; i<width; i++){
       a = findindex(str1[i])-1;if(a >= 0) thetaplus[a][i]++;
       a = findindex(str2[i])-1;if(a >= 0) thetaminus[a][i]++;
     }
     tmpnode = tmpnode->next;
   }
 }


 for(i=0; i<width; i++){
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaplus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaplus[a][i]/= T1;}
   
   T1 = 0.0;
   for(a=0; a<NO_OF_BASES; a++){ T1 += thetaminus[a][i];}
   for(a=0; a<NO_OF_BASES; a++){thetaminus[a][i]/= T1;}
   
 }

 for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[5][a][i] = thetaplus[a][i];   // shift +1
    }
 } 

  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      smtheta[6][a][i] = thetaminus[a][i];   // shift -1
    }
 } 
 }


  // "smoothed" theta matrices

// "smoothen" true matrix

 
 smthfac = 0.4;

 for(k = (numcomp-2); k<numcomp; k++){

  for(i=0; i<width; i++){
    
    for(a=0; a<NO_OF_BASES; a++)
      tmprow[a] = smtheta[0][a][i];
    
    a = maximum(tmprow,NO_OF_BASES);

    u = smthfac*(rand()/M1); // move at most smthfac of mass of largest theta

    smtheta[k][a][i] = (1-u)*smtheta[0][a][i]; //flatten largest
    
    for(j=0; j<NO_OF_BASES; j++){
      if(j!=a) smtheta[k][j][i] = smtheta[0][j][i] + u * smtheta[0][a][i]/(NO_OF_BASES-1);
    }

  }

 }








  //########################################################################

  // calculate obslik corresponding to each theta

  //########################################################################

  for(selcomp=0; selcomp<numcomp; selcomp++){// obslik for each component
 
    for(i=0; i<width; i++){
      for(a=0; a<NO_OF_BASES; a++){
	dict[motifIndex].probmat[a][i] = smtheta[selcomp][a][i];
      }
    }
    
    // now this theta is used...
        
    complik[selcomp] = 0.0;
 
    /* finding f */

   for(seqno = 0; seqno < no_of_seq; seqno++){	//no. of seq
     
     setString(1,1,S1[seqno],str1);
     
     for(k = 1; k < L[seqno]; k++) SEGMENT_PROB[k] = 0.0;

     lnS[0] = 0.0;
     lnS[1] = log(prob_back(str1[0]));
     
     k=2;
    
     while(k < L[seqno]){		// FORWARD SUMMATION
      
      lnS[k] = 0.0;
      
      // two components of prob
      
      T1 = lnS[k-1] + log(prob_back(S1[seqno][k]));

      setString(k-1, k, S1[seqno], str1);   //dimer string 
      
	if( (k < L[seqno])&&(k >= gw) ){

	   setString(k-gw+1,k, S1[seqno], tmpstr);
	   SEGMENT_PROB[k-gw+1] = exp(logProb(tmpstr, motifIndex)) ;
	   T2 = lnS[k-gw] + logProb(tmpstr, motifIndex); 

	  if((dimer == 1)&&(dimerProb(str1) == 1)){ // 3 components to sample from
	    
	    T3 = lnS[k-2] + log(newprob);   //prob of dimer str1
	   
	    maxT = min(T1,T2);
	    maxT = min(maxT,T3);
	    
	    lnS[k] = log( exp(T1 - maxT) + exp(T2 - maxT) + exp(T3 - maxT) ) + maxT ;
	   
	  }

	  else{ // no dimers or insignificant dimer
	    maxT =  max(T1, T2);    
	    lnS[k] = log( exp(T1 - maxT) + exp(T2 - maxT)) + maxT ;
	  }
	}

	else{   // only base or dimer

	  if((dimer == 1)&&(dimerProb(str1) == 1)){ // has dimer
	    T3 = lnS[k-2] + log(newprob);
	    maxT = min(T1,T3);
	    lnS[k] = log( exp(T1 - maxT) + exp(T3 - maxT)) + maxT ;
	  }

	  else{ 
	    lnS[k] = T1 ;      // no dimer, only base
	  }
	}

	k++;
	if(k == L[seqno]) break;

     }
    
    complik[selcomp] += lnS[L[seqno]-1];
    
   }/* end seqno */
   
  }


  //////////////////////////////////////////////////////////
 
        // LENGTH SAMPLING FOR MOTIFS: tempering //

  /////////////////////////////////////////////////////////



 while(setno < NoOfSets){ // no of sets for each combination of parameters

   width = startwidth;
   max_length = width;
   
 bdgeO1=0.0;  bdgecons1=0.0; bdgeG1=0.0;
 bdgeO2=0.0;  bdgecons2=0.0; bdgeG2=0.0;
 

 for(i=0; i<width; i++){
      for(a=0; a<NO_OF_BASES; a++){
	dict[motifIndex].probmat[a][i] = smtheta[0][a][i];
      }
  }


 // reset word probs if reqd.

 for(a=0; a<NO_OF_BASES; a++){
   dict[a+1].prob = storemat.prob[a];
 }
 dict[NO_OF_BASES+1].prob = storemat.prob[NO_OF_BASES];




  BFRIS = 0.0; // reciprocal importance sampling

    flag1=0; iter=-1;

    while(flag1 == 0){ //bridge iterations
     iter++;

     gw = width + gaplength;

     thisiter=0;
     for(seqno = 0; seqno < no_of_seq; seqno++) no_chosen[seqno]=0;
 
     obslik=0.0;
     
     /* Given p, draw A */
     
     for(i=0; i<NO_OF_BASES; i++){
       for(j=0; j<max_length; j++){
	 matcount[i][j] = 0;
       }}
     
     for(a=1; a<dict_length; a++) count[a] = 0;
     
     /* finding f */
     
     for(seqno = 0; seqno < no_of_seq; seqno++){   
     
       setveczero(seqbasecount[seqno],NO_OF_BASES+1);		// individual sequence base counts
       setmatzero(seqmotifmat[seqno]);

       setString(1,1,S1[seqno],str1);
       
       for(k = 1; k < L[seqno]; k++) SEGMENT_PROB[k] = 0.0;
       
       lnS[0] = 0.0;
       lnS[1] = log(prob_back(str1[0]));
        
       k=2;
       
       
       while(k < L[seqno]){		// FORWARD SUMMATION
	 
	 
	 lnS[k] = 0.0;
	 
	 // two components of prob
	 
	 T1 = lnS[k-1] + log(prob_back(S1[seqno][k]));

	 
	 if( log(prob_back(S1[seqno][k]))  < -1e10  ){
	   printf("\n\n fileread error : continue? ");
	    fflush(stdin);
	    scanf("%c", &yes); 
	    if(yes == 'n') exit(0);
	    fflush(stdin);
	    scanf("%c", &yes);
	    if(yes == 'n') exit(0);
	 }
	 setString(k-1, k, S1[seqno], str1);   //dimer string 

	 T0 = 0.0;
	 
	 
	 if( (k < L[seqno])&&(k >= gw) ){ // k > gw 
	   

	   if(dict_length > 6){   // one motif already in dictionary

	      
	     for(a = (NO_OF_BASES+1); a < (dict_length - 1); a++){
	       setString(k-gw+1,k,S1[seqno],tmpstr);
	       t0[a] = lnS[k-gw]+logProb(tmpstr,a);
	     }
	     
	     }
	   
	   setString(k-gw+1,k, S1[seqno], tmpstr);
	   SEGMENT_PROB[k-gw+1] = exp(logProb(tmpstr, motifIndex)) ;
	   T2 = lnS[k-gw] + logProb(tmpstr, motifIndex); 

	   if((dimer == 1)&&(dimerProb(str1) == 1)){ // 3 components to sample from
	     
	     T3 = lnS[k-2] + log(newprob);   //prob of dimer str1
	     maxT = min(T1,T2);
	     maxT = min(maxT,T3);
	    
	     if(dict_length > 6){

	       for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){ 
		 maxT = min(maxT,t0[a]);
	       }
	       for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){
		 T0 += exp(t0[a] - maxT);
	       }
	       
	       lnS[k] = log( T0 + exp(T1 - maxT) + exp(T2 - maxT) + exp(T3 - maxT) ) + maxT;
	     
	     }
	   }
	   
	   else{ // no dimers or insignificant dimer

	      if(dict_length > 6){
	
		maxT =  min(T1, T2);  
		
		for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){ 
		 maxT = min(maxT,t0[a]);
		}
		for(a =(NO_OF_BASES+1); a < (dict_length - 1); a++){
		  T0 += exp(t0[a] - maxT);
		}
  
		lnS[k] = log(T0  + exp(T1 - maxT) + exp(T2 - maxT)) + maxT; 

	      }
	      else{
		maxT =  max(T1, T2);    
		lnS[k] = log( exp(T1 - maxT) + exp(T2 - maxT)) + maxT ;
	      }
	   }
	   setString(k-gw+1, k,S1[seqno],str2);
	 }
	 
	 else{   // only base or dimer
	   
	   if((dimer == 1)&&(dimerProb(str1) == 1)){ // has dimer
	     T3 = lnS[k-2] + log(newprob);
	     maxT = min(T1,T3);
	     lnS[k] = log( exp(T1 - maxT) + exp(T3 - maxT)) + maxT ;
	   }
	   
	   else{ 
	     lnS[k] = T1 ;      // no dimer, only base
	   }
	 }
	 
	 k++;
	 if(k == L[seqno]) break;

       }
       
       obslik += lnS[L[seqno]-1];
       
/* Backward Sampling */

 k=L[seqno]-1;
 
 while(k >= 1){

	// for base

		nw = 1;
	
       		setString(k,k,S1[seqno],str1);
	
		for(a = 1; a <= NO_OF_BASES; a++){
				if(strcmp(str1, dict[a].name)==0) {
				  pa[nw] =  lnS[k-1] + log(dict[a].prob);    // log prob of being a base
				  ind[nw] = a;
				 
				} 
		}
		
	 
		// for motif

		if(k >= gw){		  
			nw++;
		       	pa[nw] = lnS[k-gw] + log(SEGMENT_PROB[k-gw+1]);  /* based on current update of parameter */
		
   			ind[nw] = motifIndex;			
			
			setString(k-gw+1,k,S1[seqno],str2);

			if(dict_length > 6){  //old  word

			  for(a = (NO_OF_BASES+1); a < (dict_length-1); a++)
			    {
			      nw++;
			      setString(k-gw+1,k,S1[seqno],tmpstr);
			      pa[nw] = lnS[k-gw] + logProb(tmpstr,a);
			    }
			}
		} // end k >= gw


		// dimer may be present

		if((dimer == 1) && (k >= 2)){
		  
		  setString(k-1, k, S1[seqno], str1);
		  
		  if(dimerProb(str1) == 1){		    
		    nw++;
		    pa[nw] = lnS[k-2] + log(newprob);   
		    ind[nw] = wordind;
		  }
		}
	     
		
		if(nw > 1){ // general- sampling for word
		  pa[2] = exp(pa[2] - pa[1]);
		  pa[1] = 1.0;
		  sel = sample(pa,nw);
		  A = ind[sel];
		}

		  else A = ind[nw];
	
	if(A != motifIndex){ /* base or dimer */
	    count[A]++;		
	    strcpy(lastword,str1);
	    seqbasecount[seqno][A-1]++;
	}

	else {	 
	  count[A]++;
	  seqbasecount[seqno][A-1]++;
	  total_chosen = no_chosen[seqno];  
	  jj = k - gw + 1;
	  
	start_position[seqno][total_chosen] = FindGaps(jj, S1[seqno],motifIndex, gapindices);
				// now don't penalise for gaps at end
	if((dict_length > 6)&&(start_position[seqno][total_chosen] < 0))
	  {
	    printf("%d (%d)- %d   ",jj,start_position[seqno][total_chosen],A);
	     // stop point
	    printf("\n\n continue? ");
	    fflush(stdin);
	    scanf("%c", &yes); 
	    if(yes == 'n') exit(0);
	    fflush(stdin);
	    scanf("%c", &yes);
	    if(yes == 'n') exit(0);
	  }

	end_position[seqno][total_chosen] = start_position[seqno][total_chosen] + width - 1;
	strcpy(lastword,str2);	// this is motif with gaps

	setMotif(str2,updateMotif,gapindices); //finds positions for the motif
	
	setWithGaps(selwords,str2, gapindices); // motif with gaps that is chosen
	strcpy(choseword[seqno][total_chosen],selwords);
	
	strcpy(chosenmotif[seqno][total_chosen],updateMotif);

       	no_chosen[seqno]++;
	}
		
	k -= strlen(lastword); 	 

	} /* end k */
  

}/* end seqno */

   

     for(i=0; i<width; i++){
       for(a=0; a<NO_OF_BASES; a++){
	 oldmatcount[a][i]=0;
       }}


     for(seqno = 0; seqno < no_of_seq; seqno++){
	  for(k = 0; k < no_chosen[seqno]; k++){
	 	    
	    for(i=0; i<width; i++){
	    setString(i,i,chosenmotif[seqno][k], str2);

	    for(a=0; a<NO_OF_BASES; a++){
	      if(strcmp(str2,dict[a+1].name)==0) {
		oldmatcount[a][i]++;
	      }
	    }
	    }	    
	  }}
     

  if(iter > collIter){					//somewhat stabilized 

    for(seqno = 0; seqno < no_of_seq; seqno++){
      for(i = 0; i < no_chosen[seqno]; i++){
	addnode(startvec[seqno], start_position[seqno][i]);

      }
      
    }
    
  }

 
 
 // update count matrix

    for(seqno = 0; seqno < no_of_seq; seqno++){
	  for(k = 0; k < no_chosen[seqno]; k++){
	  
	    
	    for(i=0; i<width; i++){
	    setString(i,i,chosenmotif[seqno][k], str2);

	    for(a=0; a<NO_OF_BASES; a++){
	      if(strcmp(str2,dict[a+1].name)==0) {
		matcount[a][i]++;
		seqmotifmat[seqno][i][a]++;
	      }
	    }
	  }	    
	  }}

    postlik =  findlikSINGLE(matcount, count, beta,sumcount,total_chosen,b[motifIndex]);
   


 //########################################################################
    // LENGTH UPDATE


   if((iter > LENADJ ) && (iter%5 == 0)){  //length update
     

     for(step = 0; step < 10; step++){ // number of steps

      if((rannum=rand()/M1) < 0.5) del = -1; else del = 1;


       for(seqno = 0; seqno < no_of_seq; seqno++){
	 for(i = 0; i < no_chosen[seqno]; i++){
	   a = end_position[seqno][i];
	 }
      }
       
       minposn = minposition(start_position,no_chosen,no_of_seq);
       maxposn = maxposition(end_position,no_chosen,no_of_seq);

       // MAX LENGTH RESTRICTION
       if((del == 1)&&(width < maxwidthlimit)){ // check whether to INCREASE length
	 // compare columns on either side to choose which to include
	 //choose = endratio(end_position,start_position,1,S1);	// comparison of column after end with column before first 
	 //choose either side with equal probability
	 
	  if((rannum=rand()/M1) < 0.5) { // decide whether to take next column 
	    if(maxposn < 104)   newlengthmotifs(S1,start_position,end_position,matcount, count, beta, b[motifIndex], 1, 1);

	  }
	  else { // decide whether to take previous column
	   if(minposn > 2) newlengthmotifs(S1,start_position,end_position,matcount, count, beta, b[motifIndex], 1, -1);
	  }
       }


        else if ((del == -1)&&(width > minwidthlimit)){ // check whether to DECREASE length
	  //choose = endratio(end_position,start_position,0,S1 );	// comparison of end column  with first column 
	  
	  if((rannum=rand()/M1) < 0.5) { // decide whether to delete first column (end had higher prob)
	    newlengthmotifs(S1,start_position,end_position,matcount, count, beta, b[motifIndex],-1,-1);
	  }
	  else { // decide whether to delete end column
	     newlengthmotifs(S1,start_position,end_position,matcount, count, beta, b[motifIndex],-1,1);

	  }
	   
	}
       
        max_length = width;
      
    // summing counts of words
    
    sumcount=0;
    for(a=1; a<dict_length; a++){
      sumcount +=count[a];
    }
    
   }

     postlik =  findlikSINGLE(matcount, count, beta,sumcount,total_chosen,b[motifIndex]);
   }


   total_chosen=0;
   for(seqno=0; seqno<no_of_seq; seqno++){
     total_chosen += no_chosen[seqno];
   }
   
   postlik =  findlikSINGLE(matcount, count, beta,sumcount,total_chosen,b[motifIndex]);

   if(iter>= (LENADJ-10)) fprintf(f2,"%d\t %d\t %f\t %f\t %d\t %d\n",setno,iter+1,motifsig(width, b[motifIndex],dict_length-1, count, matcount) ,postlik,width,total_chosen); 


    //#######################################################################


  // END OF SAMPLING FOR WORDS -- next: sampling for theta


  // PART 2 : SAMPLING FOR THETA
 
 sumcount=0;
for(a=1; a<dict_length; a++){
  sumcount +=count[a];
}
 total_chosen=0;

 for(seqno=0; seqno<no_of_seq; seqno++){
   total_chosen += no_chosen[seqno];
 }
 

// now updating the word stochastic matrix

/* given A, draw p */

/* first draw probs of words */

 count[motifIndex] = total_chosen;

 for(a=1; a<dict_length; a++){
   dictcount[a-1] = count[a]+beta[a-1];
 }


 rDirich(dict_length-1,dictcount,dictprobs);


 for(a=1; a<dict_length; a++){
  dict[a].prob = dictprobs[a-1];
 }


 for(j=0; j<max_length; j++){
   for(i=0; i<NO_OF_BASES; i++){
     count1[j][i] = b[motifIndex][i][j] + matcount[i][j];
   }
 }


// Now draw for theta

 /* draws from product Dirichlet */
 
 for(i=0; i<max_length; i++){
   rDirich(NO_OF_BASES, count1[i], probs[i]);
 }
 

 for(a=0; a<NO_OF_BASES; a++){
   for(i=0; i<max_length; i++){
     dict[motifIndex].probmat[a][i] = probs[i][a];
   }
 }

/* check criterion */

   for(i=0; i<max_length; i++){	
     for(a=0; a<NO_OF_BASES; a++){	
	localmat[a][i] = dict[motifIndex].probmat[a][i] ;	
     }}

   a = word_size[motifIndex];

   if(criterion(localmat,a,newword)==1){
	/* converged if after burn-out period */
     if(iter>HILL) flag1=1;
   }
   else {
     if(iter>=HILL) {
       // couldn't find more modes after MAXITER # iterations 
       flag1=1;           /* will continue searching ignoring criterion */
     }
   }

}/* end iter */



   info = 0.0; motifscore = 0.0;

 // get final theta (to find gaps) based on highest likelihood


  for(i=0; i<width; i++){
    for(a=0; a<NO_OF_BASES; a++){
      dict[motifIndex].probmat[a][i] = storemat.mat[a][i];
    }
  }

  for(a=0; a<NO_OF_BASES; a++){
    dict[a+1].prob = storemat.prob[a];
  }

  setno++;

 } //end setno 

 searchmotifs++;

 motifIndex++;

 } /* end prob calc - search for next motif*/


 system("date"); 
 printf("\n\n");
 fclose(tmpfile);
 fclose(f2);
 system("rm -f lenfile");

} /* end LEN */




